
#include "AppEvent.Ch"
#include "Common.Ch"
#include "DcApp.Ch"
#include "DcBitMap.Ch"
#include "DcCursor.Ch"
#include "DcDialog.Ch"
#include "DcDir.Ch"
#include "DcGra.Ch"
#include "DcIcon.Ch"
#include "DcTree.Ch"
#include "FileIo.Ch"
#include "Gra.Ch"
#include "Inkey.Ch"
#include "Psst.Ch"
#include "Set.Ch"
#include "Thread.Ch"
#include "TopDown.Ch"
#include "Xbp.Ch"
#include "XbpDev.Ch"

// Include the Automation Support Library
#PRAGMA LIBRARY( "ASCOM10.LIB" )

// Include the UI Extension Library (required for "XbpFileDialog")
#PRAGMA LIBRARY( "XPPUI2.LIB" )

// #define CRLF              Chr(13) + Chr(10)
#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

PROCEDURE Mvp110

  LOCAL GetList := {}, GetOptions, lStatus, oStatBar, oMsgStatic, oInsStatic, oNumStatic, oCapsStatic, oMsgBox

  PRIVATE oTabPage1, oTabPage2, oTabPage3, oTabPage4, oTabPage5, oTabPage6, oTabPage7, oTabPage8, ;
		    oStatic1, oStatic2, oStatic3, oStatic4, oStatic5, oStatic6, oStatic7, oStatic8, ;
          oGroup1 , oGroup2 , oGroup3 , oGroup4 , oGroup5 , oGroup6 , oGroup7 , oGroup8 , oGroup9 , oGroup10, ;
          oGroup11, oGroup12, oGroup13, oGroup14, oGroup15, oGroup16, oGroup17, oGroup18, ;
		    oGet1 , oGet2 , oGet3 , oGet4 , oGet5 , oGet6 , ;
  	       oDesc1, oDesc2, oDesc3, oDesc4, oDesc5, oDesc6, ;
          oPtext, oStext, oXtext, oCdate, ;
          aFiles, aAssociated, aDirectory, ;
          lProtectSoc := .t., ;
          oDoc, nCol := 2, nRow := 0, cCourtAbrev

  DC_Gui(.t.)
  DC_SetKeyActive(.t.)
  DC_GetPopupCaption({ '12.Arial Bold', BITMAP_SCAN_M, 0 })
  DC_GetPopupAutoHide(.t.)

  cProcName := PROCNAME()
  PrgSecurity(@aSecurity, @aMvMenu01, cProcName, GetList)

  SELECT OrdMst
  SET ORDER TO 1
  SELECT AltOrdMst
  SET ORDER TO 1
  SELECT DigiMst
  SET ORDER TO 1
  SELECT StatMst
  SET ORDER TO 1
  SELECT AssocMst
  SET ORDER TO 1
  SELECT CodeDtl
  SET ORDER TO 12
  SELECT LocMst
  SET ORDER TO 1
  SELECT MemoDtl
  SET ORDER TO 1
  SELECT PersMst
  SET ORDER TO 1
  SELECT RcptMst
  SET ORDER TO 6
  SELECT CodeMst
  SET ORDER TO 1
  SEEK "MVPAID"
  IF Eof()
	 cPaid          := Space(4)
  ELSE
	 cPaid          := CodeMst->CmLink
  ENDIF
  SEEK "FCDEF0"
  IF Eof()
    cCounty        := Space(40)
    cAbState       := "IL"  // Default to Illinois
    cClerkName     := Space(35)
    cClerkInit     := Space(3)
    cClerkTitle    := Space(35)
    cClerkPhone    := Space(13)
    cClerkExt      := Space(4)
	 lMandatory     := .f.
  ELSE
    cCounty        := SubStr(CodeMst->CmText1, 1,40)
    cAbState       := SubStr(CodeMst->CmText1,70, 2)
    cClerkName     := CodeMst->CmDesc
    cClerkInit     := CodeMst->CmLink
    cClerkTitle    := CodeMst->CmGlAcct
    cClerkPhone    := SubStr(CodeMst->CmText2, 1,13)
    cClerkExt      := CodeMst->CmDisp
	 lMandatory     := CodeMst->CmLogical
  ENDIF
  SEEK "FCDEF1"
  IF Eof()
    nJage          := 17
    nAlcohol       := 21
    _Pdays         := 21
    _Fdays         := 35
	 nCdays         := 15
    nDueDays       := 10
    lReceipt       := .f.
    lAmnesty       := .f.
    lPartial       := .f.
  ELSE
    nJage          := IIF(CodeMst->CmValue == 0, 17, CodeMst->CmValue)
    nAlcohol       := IIF(CodeMst->CmPoint == 0, 21, CodeMst->CmPoint)
    _Pdays         := IIF(CodeMst->CmStart == 0, 21, CodeMst->CmStart)
    _Fdays         := IIF(CodeMst->CmEnd   == 0, 35, CodeMst->CmEnd)
	 nCdays         := IIF(CodeMst->CmSeq   == 0, 15, CodeMst->CmSeq)
    nDueDays       := IIF(CodeMst->CmLow   == 0, 10, CodeMst->CmLow)
    lReceipt       := CodeMst->CmLogical
    lAmnesty       := CodeMst->CmLogic1
    lPartial       := CodeMst->CmLogic2
  ENDIF
  SEEK "FCDEF2"
  IF Eof()
	 cAdminName     := Space(35)
	 cAdminInit     := Space(3)
	 cAtitle        := "Traffic Compliance Administrator"
	 nBadCheck      := 0.00
    cLayout        := "A"
    nPartial       := 0
  ELSE
    cAdminName     := SubStr(CodeMst->CmDesc, 1,35)
    cAdminInit     := SubStr(CodeMst->CmDesc,41, 3)
	 cAtitle        := CodeMst->CmGlAcct
	 nBadCheck      := CodeMst->CmPoint
	 cLayout        := CodeMst->CmDefault
	 nPartial       := CodeMst->CmSeq
  ENDIF
  SEEK "FCDEF6"
  IF Eof()
	 cPoliceAddr    := ""
	 cPoliceCsz     := ""
	 cPolicePhone   := ""
    nEnvRow        := 14.00
    nEnvCol        :=  7.00
  ELSE
	 cPoliceAddr    := AllTrim(CodeMst->CmGlAcct)
 	 cPoliceCsz     := AllTrim(CodeMst->CmText1) +", " + AllTrim(CodeMst->CmLink) + ". " + CodeMst->CmDisp
	 cPolicePhone   := SubStr(CodeMst->CmText2,1,13)
    nEnvRow        := CodeMst->CmLow
    nEnvCol        := CodeMst->CmHigh
  ENDIF
  SEEK "FCDEF7"
  IF Eof()
    cHearingName   := Space(45)
    cHearingAddr   := Space(35)
    cHearingCsz    := Space(35)
    cHearingPhone  := Space(13)
    cHearingFax    := Space(13)
  ELSE
    cHearingName   := CodeMst->CmDesc
    cHearingAddr   := CodeMst->CmGlAcct
    cHearingCsz    := AllTrim(CodeMst->CmText1) + ", " + SubStr(CodeMst->CmLink,1,2) + ". " + AllTrim(CodeMst->CmDisp)
    cHearingPhone  := SubStr(CodeMst->CmText2,1,13)
    cHearingFax    := SubStr(CodeMst->CmText2,15,13)
  ENDIF
  SEEK "FCDEF9"                                           // Circuit Court Information
  IF Eof()
    cCourt2        := Space(45)                           // Circuit Court Clerk
    cCourtAbrev    := ""
  ELSE
    cCourt2        := SubStr(CodeMst->CmText3,30,45)
    cCourtAbrev    := SubStr(CodeMst->CmText4,1,35)
  ENDIF
  nJudge           := 0
  cHname           := " "
  cSignature       := " "
  SELECT CrtMst
  SET ORDER TO 2
  SEEK DtoS(Date())
  IF Eof()
    SET SOFTSEEK ON
    SEEK DtoS(Date())
    SET SOFTSEEK OFF
    IF !Eof()
      nJudge       := CrtMst->Judge
  	   SELECT CodeMst
  	   SET ORDER TO 1
  	   SEEK "FB" + StrZero(nJudge,4,0)
  	   IF !Eof()
        cHname     := AllTrim(CodeMst->CmDesc)
  		  cSignature := AllTrim(CodeMst->CmText1)
  	   ENDIF
  	 ENDIF
  ELSE
    nJudge         := CrtMst->Judge
  	 SELECT CodeMst
  	 SET ORDER TO 1
  	 SEEK "FB" + StrZero(nJudge,4,0)
  	 IF !Eof()
      cHname       := AllTrim(CodeMst->CmDesc)
  	   cSignature   := AllTrim(CodeMst->CmText1)
  	 ENDIF
  ENDIF

  lNewRec          := .t.
  lNewCash         := .t.
  lNewStat         := .t.
  lNewAssoc        := .t.
  lNewGraphic      := .t.
  lNewComment      := .t.
  lAlarm           := .f.
  lLiquor          := .f.
  lSuspense        := .f.

  cLiquor          := "Liquor Offense"
  cJuvenile        := "Juvenile"

  cCitation        := Space(10)
  nRdYr            := 0
  nRdNumber        := 0
  cRdSuffix        := Space(1)
  nRptYr           := 0
  nRptNumber       := 0
  dTdate           := CtoD('')
  cTtime           := Space(5)
  cLocation        := Space(30)
  cUnit            := Space(4)
  cCommonName      := Space(30)
  cBeat            := Space(4)
  cSubBeat         := Space(4)
  nCensus          := 0
  cWatch           := Space(4)
  cWatchDesc       := Space(30)
  cClass           := Space(4)
  cClassDesc       := Space(30)
  nViolation       := 0
  cTypeCode        := Space(4)
  nChapter         := 0.000
  nSection         := 0
  cParagraph       := Space(6)
  cVdesc           := Space(65)
  nRstar           := 0
  nIdNumber        := 0
  cRname           := Space(30)
  cKcode           := Space(4)
  cDdesc           := Space(30)  // Department
  cComplainant     := Space(40)
  nComplainant     := 0
  cRespondent      := "I"
  cSex             := Space(1)
  cRace            := Space(1)
  dDob             := CtoD('')
  cSocial          := Space(11)
  cDln             := Space(16)
  cDlnState        := Space(2)
  cBname           := Space(40)
  cBaddress        := Space(40)
  cBcity           := Space(25)
  cBstate          := Space(2)
  nBzip            := 0
  cPhone           := Space(13)
  nRespondent      := 0
  dHdate           := CtoD('')
  cHtime           := Space(5)
  dHdate2          := CtoD('')
  dDuedate         := CtoD('')
  cSrvCode         := Space(4)
  cSrvDesc         := Space(30)
  dCircuitDte      := CtoD('')
  cXcode           := Space(4)
  cXdesc           := Space(30)
  cXform           := Space(4)
  dXdate           := CtoD('')
  lConvict         := .f.
  lPayPlan         := .f.
  nCShrs           := 0
  dCSdate          := CtoD('')
  dContinued       := CtoD('')
  nDueDateAmt      := 0.00
  nDefaultAmt      := 0.00
  nFine            := 0.00
  nCosts           := 0.00
  nARamt           := 0.00
  nARhrs           := 0
  lCollection      := .f.
  lAppear          := .f.
  lEvidence        := .f.
  lCrimeFree       := .f.
  cEvidCode        := Space(4)
  cEvidDesc        := ""
  dEvidDate        := CtoD('')

  nAlarms          := 0

  dPdate           := CtoD('')
  cPcode           := Space(1)
  cPdesc           := Space(30)
  dNewHdate        := CtoD('')
  cPtext           := ''

  nCount           := 0
  nBalAmt          := 0.00
  nBalHrs          := 0
  nHistCount       := 0
  nHistAmt         := 0.00
  nHistHrs         := 0
  nTownCnt         := 0
  nTownBal         := 0

  dRdate           := CtoD('')
  aPayment         := {{PADR("Cash",12)}, ;                  // Receipting
                       {PADR("Check",12)}, ;
                       {PADR("Credit Card",12)}, ;
                       {PADR("Money Order",12)} }
  aPayment         := DC_AConvert(aPayment) [1]
  cPayment         := aPayment[1]
  cCheckNo         := Space(25)
  nAmt             := 0.00
  nOverAmt         := 0.00
  nDollars         := (nFine + nCosts)
  cBatchName       := Space(20)
  nBatchAmt        := 0.00
  nReceipt         := 0
  nHrs             := 0
  nHours           := nCsHrs
  nAgency          := 0.00
  cAgencyCode      := Space(4)
  cAgencyDesc      := Space(30)
  nWriteOff        := 0.00
  cCashCode        := Space(4)
  cCashDesc        := Space(30)
  nAmnesty         := 0.00
  lBadCheck        := .f.
  dBadCheck        := CtoD('')
  lReceipts        := .f.
  nTransYear       := 0
  nTransNo         := 0
  nChecks          := 0
  nCheckFee        := 0.00
  nReceiptAmt      := 0.00
  nReceiptHrs      := 0
  bPayment         := {|| (nAmt + nOverAmt + nAgency + nWriteOff + nAmnesty) }

  dSdate           := CtoD('')
  cScode           := Space(4)
  cSdesc           := Space(30)
  cStext           := ''
  nStatus          := 0
  cStatus          := ""
  dCollections     := CtoD('')
  cCurrentStatus   := ""

  cXtext           := ''
  lSubpoena        := .f.
  lTownship        := .f.
  dTownship        := CtoD('')
  bTotal           := {|| nFine + nCosts }

  cDeptCode        := Space(4)
  cDeptDesc        := Space(40)
  lStepPct         := .f.
  cFineType        := 'A'
  cClassCode       := ' '
  cClassDesc       := Space(40)
  nMin             := 0.00
  nMax             := 0.00
  nGroup           := 1

  cTicket          := Space(10)
  cSexDesc         := ""
  cRaceDesc        := ""
  dDobDesc         := CtoD('')
  cNameDesc        := ""
  cAssocName       := ""
  cAssocAddr       := ""
  aAssociated      := {}
  nAssociated      := 0
  nPointer         := 1

  cDirectory       := ''
  cFileName        := Space(75)
  aFiles           := {}

  cCtext           := ''
  dCdate           := CtoD('')

  cMaintInfo       := ""

  bRefresh         := {|| DC_GetRefresh(GetList) }
  bHistory         := {|| Print360( cBname, cSex, cRace, dDob ) }
//  bCsHrs           := {|| IIF(nHrs == nCsHrs, {GRA_CLR_DARKGREEN, Nil}, {GRA_CLR_RED, Nil}) }
//  bReceipt         := {|| IIF(nAmt + nCosts + nAgency + nWriteOff + nAmnesty < nFine + nCosts, {GRA_CLR_RED, Nil}, {GRA_CLR_DARKGREEN, Nil}) }
  bCsHrs           := {|| IIF(nReceiptHrs > 0   , {GRA_CLR_RED, Nil}, {GRA_CLR_DARKGREEN, Nil}) }
  bReceipt         := {|| IIF(nReceiptAmt > 0.00, {GRA_CLR_RED, Nil}, {GRA_CLR_DARKGREEN, Nil}) }
  bMandatory       := {|| {GRA_CLR_BLACK, GRA_CLR_YELLOW} }

/* ---- Tab Page #1 ---- */

  @  1.00, 1.00 DCTABPAGE oTabPage1    CAPTION ' Citation '               SIZE 83.00,34.25                                                                COLOR GRA_CLR_BLUE   PREOFFSET 0   POSTOFFSET 87.5 ;
                ACCELKEY xbeK_ALT_C

  DCSETPARENT TO oTabPage1

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3, DCGUI_PARENTHEIGHT - 2          PARENT oTabPage1    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic1 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic1

  @   .25, 1.00 DCGROUP oGroup1        CAPTION ' Citation Information '   SIZE DCGUI_PARENTWIDTH - 2, 6.20                            PARENT oStatic1     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.20, 1.00 DCSAY 'Citation Number'                                   SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00,14.00 DCGET cCitation        Picture '!!!!!!!!!!'                                                                           PARENT oGroup1      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
				    TABSTOP ;
					 NOCONFIRM ;
 				    GETID "Get_cCitation" ;
                WHEN {|| nGroup == 1 } ;
                TABGROUP XBP_BEGIN_GROUP ;
                VALID {|| ValidateCitation(cCitation, GetList) } ;
                POPUP {|c| c := CitationScan(cCitation, GetList) } ;
                MESSAGE 'Enter The Citation Number To Be Maintained.' INTO oMsgBox

  @   .70,30.50 DCSAY 'Incident'                                          SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.40,30.50 DCSAY 'Number'                                            SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00,38.00 DCGET nRdYr            Picture '99'                                                                                   PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_nRdYr" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Incident Year.' INTO oMsgBox
  @  1.20,41.65 DCSAY '-'                                                 SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00,42.50 DCGET nRdNumber        Picture '999999'                                                                               PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_nRdNumber" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Incident Number.' INTO oMsgBox ;
					 VALID {|| ValidateRdNumber(nRdYr, nRdNumber, GetList) }
  @  1.00,50.75 DCGET cRdSuffix        Picture '!'                                                                                    PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cRdSuffix" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Incident Number Suffix.' INTO oMsgBox

  @   .70,54.00 DCSAY 'Report'                                            SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.40,54.00 DCSAY 'Number'                                            SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00,63.00 DCGET nRptYr           Picture '99'                                                                                   PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_nRptYr" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Report Year.' INTO oMsgBox
  @  1.20,66.75 DCSAY '-'                                                 SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00,68.00 DCGET nRptNumber       Picture '999999'                                                                               PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_nRptNumber" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Report Number.' INTO oMsgBox

  @  2.40, 1.00 DCSAY 'Issue Date'                                        SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  2.20,14.00 DCGET dTdate           Picture '@D'                                                                                   PARENT oGroup1      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_dTdate" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
					 VALID {|| ValidateIssueDate( GetList ) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray", .f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Citation Issue Date.' INTO oMsgBox

  @  2.40,30.50 DCSAY {|| PrintDate(dTdate,1) }                           SIZE 20                                                     PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dTdate) }


  @  2.40,54.00 DCSAY 'Issue Time'                                        SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  2.20,63.00 DCGET cTtime           Picture '99:99'                                                                                PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cTtime" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
					 VALID {|| ValidateTtime(cTtime, GetList) } ;
                MESSAGE 'Enter The Citation Issue Time (Military Format).' INTO oMsgBox

  @  2.40,70.75 DCSAY {|| TS_TO_AMPM(cTtime) }                            SAYSIZE  6.50                                               PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(cTtime) }

  @  3.60, 1.00 DCSAY 'Issue Location'                                    SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  3.40,14.00 DCGET cLocation        Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                                       PARENT oGroup1      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 PROPER ;
					 NOCONFIRM ;
 				    GETID "Get_cLocation" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                VALID {|| ValidateLocation(@cLocation, GetList) } ;
                POPUP {|c| c := LocationScan(cLocation, GetList) } ;
                MESSAGE 'Enter The Citation Issue Location.' INTO oMsgBox

  @  3.60,54.00 DCSAY 'Unit'                                              SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  3.40,63.00 DCGET cUnit            Picture '!!!!'                                                                                 PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cUnit" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Location Unit Number.' INTO oMsgBox

  @  3.60,70.00 DCSAY {|| TRANSFORM(nAssociated,"99,999") }               SAYSIZE  7                                                  PARENT oGroup1      COLOR {255,200,0} ;
  					 SAYFONT '12.Helv Bold' ;
  					 HIDE {|| nAssociated == 0 }

  @  4.80,14.00 DCSAY {|| cCommonName }                                   SAYSIZE 40.00                                               PARENT oGroup1      COLOR GRA_CLR_BLUE ;
                SAYFONT '10.Helv Bold'

  @  4.80,54.00 DCSAY 'Beat'                                              SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  4.60,63.00 DCGET cBeat            Picture '!!!!'                                                                                 PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cBeat" ;
                TABGROUP XBP_END_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                VALID {|| ValidateBeat(@cBeat, GetList) } ;
                MESSAGE 'Enter The Location Beat ID.' INTO oMsgBox ;
					 KEYBLOCK { |c,b,o| IIF(c==xbeK_ENTER, PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o),Nil) }


  @  6.70, 1.00 DCGROUP oGroup2        CAPTION ' Violation Information '  SIZE DCGUI_PARENTWIDTH -2.00, 3.75                          PARENT oStatic1     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @   .65,30.50 DCSAY 'Type'                                              SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @   .65,36.70 DCSAY 'Chapter'                                           SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @   .65,45.30 DCSAY 'Section'                                           SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @   .65,54.00 DCSAY 'Paragraph'                                         SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK

  @   .65,66.00 DCSAY "At Collections"                                    SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_RED ;
					 HIDE {|| !lCollection }

  @  1.25, 1.00 DCSAY "Violation Number"                                  SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @  1.00,14.00 DCGET nViolation       Picture '99999999'                                                                             PARENT oGroup2      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
				    TABSTOP ;
					 NOCONFIRM ;
 				    GETID "Get_nViolation" ;
                TABGROUP XBP_BEGIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                POPUP {|n| n := ViolationScan( GetList ) } ;
                VALID {|| ValidateViolation(nViolation, GetList ) } ;
                MESSAGE 'Enter The Alternate Violation Code.' INTO oMsgBox ;
					 KEYBLOCK { |c,b,o| IIF(c==xbeK_ENTER, PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o),Nil) }
/*
  @  1.00,66.00 DCPUSHBUTTON           CAPTION 'Violation Review'         SIZE 10.00, 2.00 				                                PARENT oGroup2 ;
					 CARGO "CANCEL" ;
				    ALIGNCAPTION BS_MULTILINE ;
					 WHEN {|| !Empty(cCitation) } ;
                ACTION {|| ViolationScan(cCitation, nViolation, cTypeCode, nChapter, nSection, cParagraph, GetList) }
*/


  @  1.50,30.71 DCSAY {|| cTypeCode }                                     SAYSIZE  5                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
					 WHEN {|| !Empty(cTypeCode) }

  @  1.50,36.14 DCSAY {|| TRANSFORM(nChapter,"9999.999") }                SAYSIZE  6                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
                WHEN {|| nChapter > 0.000 }

  @  1.50,47.86 DCSAY {|| TRANSFORM(nSection,"99999") }                   SAYSIZE  6                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
                WHEN {|| nSection > 0 }

  @  1.50,54.57 DCSAY {|| cParaGraph }                                    SAYSIZE  6                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
					 WHEN {|| !Empty(cParaGraph) }

  @  1.50,65.25 DCSAY {|| "$ " + TRANSFORM(nFine,"999,999.99") }          SAYSIZE 12                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
                SAYFONT '10.Helv Bold' ;
                HIDE {|| nFine == 0.00 }

  @  2.50, 1.00 DCSAY 'Description'                                       SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @  2.35,14.00 DCSAY {|| cVdesc }                                        SAYSIZE 63                                                  PARENT oGroup2      COLOR GRA_CLR_BLUE ;
                SAYFONT '10.Helv Bold' ;
                HIDE {|| nViolation == 0 } ;
                WHEN {|| !Empty(cCitation) }

  @  2.50,67.50 DCSAY {|| SubStr(cLiquor,1,6) }                           SAYSIZE 10                                                  PARENT oGroup2      COLOR GRA_CLR_RED ;
  					 SAYFONT '12.Helv Bold' ;
					 HIDE {|| !lLiquor .OR. dDob == CtoD('') .OR. Age( dDob, dTdate ) >= nAlcohol }


  @ 10.70, 1.00 DCGROUP oGroup2a CAPTION ' Complainant Information '      SIZE DCGUI_PARENTWIDTH - 2.00, 3.75                         PARENT oStatic1     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.25, 1.00 DCSAY 'Complainant Name'                                  SIZE  0                                                     PARENT oGroup2a     COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND
  @  1.00,16.00 DCGET cComplainant     Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                             PARENT oGroup2a     COLOR GRA_CLR_BLUE ;
					 PROPER ;
				    TABSTOP ;
					 NOCONFIRM ;
                TABGROUP XBP_BEGIN_GROUP ;
					 GETID "Get_cComplainant" ;
					 WHEN {|| !Empty(cCitation) } ;
					 VALID {|| ValidateComplainant(Getlist) } ;
                KEYBLOCK {|a,b,o| SearchComplainant(a,b,o,@cComplainant) } ;
                MESSAGE 'Enter The Complaint Name Information (Last, First Middle Initial).' INTO oMsgBox

  @  1.00,62.20 DCPUSHBUTTON           CAPTION {|| TRANSFORM(nComplainant,"99") } ;
                CARGO "CANCEL"                                            SIZE  3.75, 1.00                                            PARENT oGroup2a ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| Mvp112(cCitation, nComplainant) }

//                TOOLTIP {|| LTRIM(TRANSFORM(nComplainant,"99")) + ' Detailed Complainant;Information Record(s) Exist.' }

  @  1.00,66.00 DCPUSHBUTTON           CAPTION 'Complainant Review'       SIZE 10.00, 2.00                                            PARENT oGroup2a ;
					 CARGO "CANCEL" ;
				    ALIGNCAPTION BS_MULTILINE ;
					 WHEN {|| !Empty(cCitation) } ;
                ACTION {|| ComplainantScan(cComplainant,GetList) }

  @  2.50, 1.00 DCSAY 'Issued By'                                         SIZE  0                                                     PARENT oGroup2a     COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND
  @  2.25,16.00 DCGET nRstar           Picture '9999'                                                                                 PARENT oGroup2a     COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_nRstar" ;
                TABGROUP XBP_END_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                VALID {|| ValidateRstar(nRstar, dTdate, GetList) } ;
                POPUP {|n| n := GuiRstarScan(n, GetList) } ;
                MESSAGE 'Enter The Issued by Star Number.' INTO oMsgBox ;
					 KEYBLOCK { |c,b,o| IIF(c==xbeK_ENTER, PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o),Nil) }

  @  2.50,25.00 DCSAY {|| cRname }                                        SAYSIZE 30                                                  PARENT oGroup2a     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND


  @ 14.70, 1.00 DCGROUP oGroup3        CAPTION ' Respondent Information ' SIZE DCGUI_PARENTWIDTH - 2.00, 8.75                         PARENT oStatic1     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @   .60,10.50 DCSAY {|| cJuvenile }                                     SAYSIZE 10                                                  PARENT oGroup3      COLOR {165,000,000} ;
					 SAYFONT '10.Helv Bold' ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I" } ;
					 HIDE {|| dDob == CtoD('') .OR. Age( dDob, dTdate ) >= nJage }

  @   .25,25.00 DCRADIO cRespondent                                                                                                   PARENT oGroup3 ;
				    TABSTOP ;
                VALUE "I" ;
					 OBJECT oRadioI ;
                ACCELKEY xbeK_ALT_I ;
                PROMPT ' &Individual' ;
                TABGROUP XBP_BEGIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                ACTION {|| DC_GetRefresh(GetList), SetAppFocus(DC_GetObject(GetList,"Get_cSex")) }

  @   .25,37.00 DCRADIO cRespondent                                                                                                   PARENT oGroup3 ;
				    TABSTOP ;
                VALUE "B" ;
					 OBJECT oRadioB ;
                ACCELKEY xbeK_ALT_B ;
                PROMPT ' &Business' ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                ACTION {|| DC_GetRefresh(GetList), SetAppFocus(DC_GetObject(GetList,"Get_cBname")) }

  @   .50,54.00 DCSAY 'Sent to Collections'                               SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_RED ;
				    WHEN {|| !Empty(dCollections) }

  @  1.40, 1.00 DCSAY 'Sex'                                               SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    WHEN {|| cRespondent == "I"}
  @  1.40, 5.00 DCSAY 'Race'                                              SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    WHEN {|| cRespondent == "I"}
  @  1.40,10.50 DCSAY 'Date of Birth'                                     SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    WHEN {|| cRespondent == "I"}
  @  1.40,21.00 DCSAY {|| AGE(dDob, dTdate) }                             SAYSIZE  3                                                  PARENT oGroup3      COLOR GRA_CLR_RED ;
				    HIDE {|| Empty(dDob)} ;
				    WHEN {|| cRespondent == "I" .AND. !Empty(dDob)}
  @  1.40,26.00 DCSAY 'Social Security'                                   SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    WHEN {|| cRespondent == "I"}
  @  1.40,41.00 DCSAY "Driver's License Number"                           SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    WHEN {|| cRespondent == "I"}
  @  1.40,60.75 DCSAY 'State'                                             SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
                WHEN {|| cRespondent == "I"}

  @  1.40,66.00 DCPUSHBUTTON           CAPTION 'Respondent Review'        SIZE 10.00, 2.00 				                                PARENT oGroup3 ;
					 CARGO "CANCEL" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    ALIGNCAPTION BS_MULTILINE ;
					 WHEN {|| !Empty(cCitation) } ;
                ACTION {|| RespondentScan(cBname,GetList) }


  @  2.40, 1.50 DCGET cSex             Picture '!'                                                                                    PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_cSex" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 VALID {|| ValidateSex(cSex, GetList) } ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}
  @  2.40, 6.00 DCGET cRace            Picture '!'                                                                                    PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_cRace" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 VALID {|| ValidateRace(cRace, GetList) } ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}
  @  2.40,10.50 DCGET dDob             Picture '@D'                                                                                   PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_dDob" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray", .f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}
  @  2.40,26.00 DCGET cSocial          Picture '999-99-9999'                                                                          PARENT oGroup3      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cSocial" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}
  @  2.40,41.00 DCGET cDln             Picture '!!!!!!!!!!!!!!!!'                                                                     PARENT oGroup3      COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cDln" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}
  @  2.40,61.00 DCGET cDlnState        Picture '!!'                                                                                   PARENT oGroup3      COLOR GRA_CLR_BLUE ;
                NOCONFIRM ;
                GETID "Get_cDlnState" ;
                TABGROUP XBP_WITHIN_GROUP ;
                VALID {|| ValidateRespondent(GetList) } ;
                WHEN {|| !Empty(cCitation) .AND. cRespondent == "I"}

  @  3.80, 1.00 DCSAY "Person's Name"                                     SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    HIDE {|| cRespondent == "B"}
  @  3.80, 1.00 DCSAY 'Business Name'                                     SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK ;
				    HIDE {|| cRespondent == "I"}
  @  3.60,18.00 DCGET cBname           Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                             PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
                PROPER ;
                NOCONFIRM ;
                GETID "Get_cBname" ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| !Empty(cCitation) } ;
                VALID {|| ValidateRespondent(GetList) } ;
                KEYBLOCK {|a,b,o| SearchRespondent(a,b,o,@cBname) } ;
                MESSAGE 'Enter The Respondent Name Information (Last, First Middle Initial).' INTO oMsgBox

  @  4.25,70.00 DCSAY {|| TRANSFORM(nRespondent,"99,999") }               SAYSIZE  7                                                  PARENT oGroup3      COLOR GRA_CLR_BLUE ;
					 CURSOR 12347 ;
					 HYPERLINK bHistory ;
					 SAYFONT '12.Helv Bold' ;
					 HIDE {|| Empty(cCitation) }

  @  5.00, 1.00 DCSAY 'Mailing Address'                                   SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK
  @  4.80,18.00 DCGET cBaddress        Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                             PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
                PROPER ;
                NOCONFIRM ;
                GETID "Get_cBaddress" ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| !Empty(cCitation) } ;
                MESSAGE 'Enter The Respondent Mailing Address Information.' INTO oMsgBox

  @  6.20, 1.00 DCSAY 'City, State  Zip Code'                             SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK
  @  6.00,18.00 DCGET cBcity           Picture '!XXXXXXXXXXXXXXXXXXXXXXXX'                                                            PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 PROPER ;
					 NOCONFIRM ;
 				    GETID "Get_cBcity" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                VALID {|| ValidateCity(cBcity, GetList) } ;
					 KEYBLOCK {|a,b,o| SearchCity(a,b,o,@cBcity) } ;
                MESSAGE "Enter The Respondent's Mailing City Name." INTO oMsgBox
  @  6.00,48.25 DCGET cBstate          Picture '!!'                                                                                   PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
                NOCONFIRM ;
                GETID "Get_cBstate" ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| !Empty(cCitation) } ;
                MESSAGE "Enter The Respondent's Mailing State Code." INTO oMsgBox
  @  6.00,53.25 DCGET nBzip            Picture '99999'                                                                                PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
                NOCONFIRM ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| !Empty(cCitation) } ;
                MESSAGE "Enter The Respondent's Mailing Zip Code." INTO oMsgBox

  @  6.00,61.50 DCSAY {|| "* * HOLD * * "}                                SAYSIZE 15                                                  PARENT oGroup3      COLOR GRA_CLR_RED ;
					 SAYFONT '12.Helv Bold' ;
					 HIDE {|| !lSuspense }

  @  7.40, 1.00 DCSAY 'Telephone Number'                                  SIZE  0                                                     PARENT oGroup3      COLOR GRA_CLR_BLACK
  @  7.20,18.00 DCGET cPhone           Picture '(999)999-9999'                                                                        PARENT oGroup3      COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_cPhone" ;
                TABGROUP XBP_END_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                MESSAGE "Enter The Respondent's Telephone Number." INTO oMsgBox ;
					 KEYBLOCK { |c,b,o| IIF(c==xbeK_ENTER, PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o),Nil) }

  @  7.40,48.25 DCSAY {|| cMaintInfo }                                    SAYSIZE 28                                                  PARENT oGroup3      COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND ;
                HIDE  {|| lNewRec }


  @ 23.70, 1.00 DCGROUP oGroup3a       CAPTION ' Hearing Information '    SIZE DCGUI_PARENTWIDTH - 2.00, 6.25                         PARENT oStatic1     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.25, 1.00 DCSAY 'Hearing Date'                                      SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK
  @  1.00,14.00 DCGET dHdate           Picture '@D'                                                                                   PARENT oGroup3a     COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
				    TABSTOP ;
					 NOCONFIRM ;
 				    GETID "Get_dHdate" ;
                TABGROUP XBP_BEGIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
					 VALID {|| ValidateHearingDate(dHdate, GetList) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE "Enter/Update The Hearing Date." INTO oMsgBox

  @  1.25,29.50 DCSAY 'Time'                                              SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK
  @  1.00,34.00 DCGET cHtime           Picture '99:99'                                                                                PARENT oGroup3a     COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
					 NOCONFIRM ;
 				    GETID "Get_cHtime" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
					 VALID {|| ValidateHtime(cHtime, GetList) } ;
                MESSAGE "Enter The Hearing Time." INTO oMsgBox

  @  1.25,42.00 DCSAY {|| TS_TO_AMPM(cHtime) }                            SIZE  6.50                                                  PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(cHtime) }

  @  2.50, 1.00 DCSAY 'Due Date'                                          SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK
  @  2.25,14.00 DCGET dDueDate         Picture '@D'                                                                                   PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_dDueDate" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) .AND. lDueDate .AND. !lAppear } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE "Enter The Due Date." INTO oMsgBox

  @  2.50,29.50 DCSAY {|| PrintDate(dDueDate,1) }                         SAYSIZE 20                                                  PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dDueDate) }

  @  3.75, 1.00 DCSAY 'Service by'                                        SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK
  @  3.50,14.00 DCGET cSrvCode         Picture '!!!!'                                                                                 PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
 				    GETID "Get_cSrvCode" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                POPUP {|c| c := GuiServiceScan(c, GetList) } ;
                VALID {|| ValidateService(cSrvCode, GetList) } ;
                MESSAGE "Enter The Citation Service Type Code." INTO oMsgBox

  @  3.75,29.50 DCSAY {|| cSrvDesc }                                      SAYSIZE 30                                                  PARENT oGroup3a     COLOR GRA_CLR_BLUE

  @  5.00, 1.00 DCSAY 'Circuit Date'                                      SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK
  @  4.75,14.00 DCGET dCircuitDte      Picture '@D'                                                                                   PARENT oGroup3a     COLOR IIF(lMandatory, bMandatory, GRA_CLR_BLUE) ;
				    TABSTOP ;
					 NOCONFIRM ;
 				    GETID "Get_dCircuitDte" ;
                TABGROUP XBP_BEGIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE "Enter/Update The Associated Circuit Court Date." INTO oMsgBox

  @  5.00,29.50 DCSAY {|| PrintDate(dCircuitDte,1) }                      SAYSIZE 20                                                  PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dCircuitDte) }


  @   .40,54.00 DCCHECKBOX lAppear     PROMPT " &Must Appear"                                                                         PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 ACCELKEY xbeK_ALT_M ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                TOOLTIP 'Flag Citation as Mandatory;Hearing Appearance Required.'

  @  1.40,54.00 DCCHECKBOX lEvidence   PROMPT " Evidence &Tag"                                                                        PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 ACCELKEY xbeK_ALT_T ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                TOOLTIP 'Flag Citation as Evidence;Stored Into Custody.'

  @  2.40,54.00 DCCHECKBOX lCrimeFree  PROMPT " Crime Free Housing"                                                                   PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 ACCELKEY xbeK_ALT_F ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(cCitation) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                TOOLTIP 'Flag Citation as;Crime Free Housing Related.'

  @  3.85,54.00 DCSAY 'Alarm Count'                                       SIZE  0                                                     PARENT oGroup3a     COLOR GRA_CLR_BLACK ;
					 WHEN {|| lAlarm }
  @  3.60,64.00 DCGET nAlarms          Picture '999'                                                                                  PARENT oGroup3a     COLOR GRA_CLR_BLUE ;
					 NOCONFIRM ;
                TABGROUP XBP_END_GROUP ;
					 WHEN {|| !Empty(cCitation) .AND. lAlarm } ;
                MESSAGE "Enter The Number of False Alarm Activations." INTO oMsgBox


  @ 30.50, 2.00 DCPUSHBUTTON           CAPTION {|| IIF(lNewRec,'Add','Update') } ;
                                                                          SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. aSecurity[2] } ;
                ACTION {|| CodeAction(IIF(lNewRec,1,2),GetList) }

  @ 30.50,13.00 DCPUSHBUTTON           CAPTION 'Multiple'                 SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. lNewRec .AND. aSecurity[2] } ;
                ACTION {|| CodeAction(5,GetList) }

  @ 30.50,24.00 DCPUSHBUTTON           CAPTION 'Delete'                   SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| !lNewRec .AND. nGroup > 1 .AND. aSecurity[3] } ;
                ACTION {|| CodeAction(3,GetList) }

  @ 30.50,35.00 DCPUSHBUTTON           CAPTION 'Cancel'                   SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| CodeAction(0,GetList) }

  @ 30.50,46.00 DCPUSHBUTTON           CAPTION 'Exit'                     SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 30.50,58.00 DCPUSHBUTTON           CAPTION 'Label'                    SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. aSecurity[4] } ;
                ACTION {|| Label770(cCitation) }

  @ 30.50,69.00 DCPUSHBUTTON           CAPTION 'Print'                    SIZE  9, 1.20                                               PARENT oStatic1 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. aSecurity[4] } ;
                ACTION {|| Print390(cCitation) }


  DCSETPARENT TO


/* ---- Tab Page #2 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage2    CAPTION ' Petition '               RELATIVE oTabPage1                                                              COLOR GRA_CLR_CYAN ;
                ACCELKEY xbeK_ALT_P ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(DC_GetObject(GetList,"Get_dPdate")) }

  DCSETPARENT TO oTabPage2

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3, DCGUI_PARENTHEIGHT - 2          PARENT oTabPage2    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic2 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic2

  @   .25, 1.50 DCGROUP oGroup4        CAPTION ' Citation Information '   SIZE DCGUI_PARENTWIDTH - 3,10.00                            PARENT oStatic2     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)


  @ 10.50, 1.50 DCGROUP oGroup5        CAPTION ' Petition Information '   SIZE DCGUI_PARENTWIDTH - 3,19.25                            PARENT oStatic2     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.20, 1.00 DCSAY 'Received Date'                                     SIZE  0                                                     PARENT oGroup5      COLOR GRA_CLR_BLACK
  @  1.00,15.00 DCGET dPdate           Picture '@D'                                                                                   PARENT oGroup5      COLOR GRA_CLR_BLUE ;
				    TABSTOP ;
 				    GETID "Get_dPdate" ;
                TABGROUP XBP_BEGIN_GROUP ;
					 VALID {|| ValidatePDate("Get_cPcode", dPdate, GetList) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  1.20,32.00 DCSAY {|| PrintDate(dPdate,1) }                           SAYSIZE 20                                                  PARENT oGroup5      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dPdate) }

  @  2.40, 1.00 DCSAY 'Set Aside Code'                                    SIZE  0                                                     PARENT oGroup5      COLOR GRA_CLR_BLACK
  @  2.20,15.00 DCGET cPcode           Picture '!'                                                                                    PARENT oGroup5      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cPcode" ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| dPdate > CtoD("") } ;
                VALID {|| ValidateAside(cPcode,GetList) } ;
                POPUP {|c| c := GuiAsideScan(cPcode,GetList) } ;
                MESSAGE 'Enter The Desire Petiton to Set Aside Code.' INTO oMsgBox
  @  2.40,32.00 DCSAY {|| cPdesc }                                        SAYSIZE 30                                                  PARENT oGroup5      COLOR GRA_CLR_BLUE

  @  3.60, 1.00 DCSAY 'New Hearing Date'                                  SIZE  0                                                     PARENT oGroup5      COLOR GRA_CLR_BLACK
  @  3.40,15.00 DCGET dNewHdate        Picture '@D'                                                                                   PARENT oGroup5      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_dNewHdate" ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| dPdate > CtoD("") } ;
					 VALID {|| ValidateDate("Get_cPtext", GetList) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  3.60,32.00 DCSAY {|| PrintDate(dNewHdate,1) }                        SAYSIZE 20                                                  PARENT oGroup5      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dNewHdate) }

  @  3.60,64.00 DCPUSHBUTTON CAPTION "1" 			 		                    SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(1,GetList) } ;
                TOOLTIP '1 Month Petition Hearing Return Date'

  @  3.60,66.00 DCPUSHBUTTON CAPTION "2"                                  SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(2,GetList) } ;
                TOOLTIP '2 Month Petition Hearing Return Date'

  @  3.60,68.00 DCPUSHBUTTON CAPTION "3"                                  SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(3,GetList) } ;
                TOOLTIP '3 Month Petition Hearing Return Date'

  @  3.60,70.00 DCPUSHBUTTON CAPTION "4"                                  SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(4,GetList) } ;
                TOOLTIP '4 Month Petition Hearing Return Date'

  @  3.60,72.00 DCPUSHBUTTON CAPTION "5"                                  SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(5,GetList) } ;
                TOOLTIP '5 Month Petition Hearing Return Date'

  @  3.60,74.00 DCPUSHBUTTON CAPTION "6"                                  SIZE  2, 1                                                  PARENT oGroup5 ;
                ACTION {|| BumpPetition(6,GetList) } ;
                TOOLTIP '6 Month Petition Hearing Return Date'


  @  5.00, 1.00 DCMULTILINE cPtext                                        SIZE DCGUI_PARENTWIDTH - 2,13.75                            PARENT oGroup5 ;
				    TABSTOP ;
				    OBJECT oPtext ;
                NOHORIZSCROLL ;
 				    ID "Get_cPtext" ;
				    FONT "8.Courier New" ;
                TABGROUP XBP_END_GROUP ;
 					 WHEN {|| !Empty(cPcode) } ;
				    EVAL {|o| o:RbDown := {|x,y,z| oMenuMemo:PopUp( z, x, 2, ;
				                                   XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) } }

  DCSUBMENU oMenuMemo PROMPT "&Memo" PARENT oPtext

    DCMENUITEM "~Delete" ACTION {|| oPtext:deleteMarked() }               MESSAGE 'Delete Item'                                       PARENT oMenuMemo

    DCMENUITEM "~Cut"    ACTION {|| oPtext:cutMarked() }                  MESSAGE 'Cut Item'                                          PARENT oMenuMemo

    DCMENUITEM "C~opy"   ACTION {|| oPtext:copyMarked() }                 MESSAGE 'Copy Item'                                         PARENT oMenuMemo

    DCMENUITEM "~Paste"  ACTION {|| oPtext:pasteMarked()}                 MESSAGE 'Paste Item'                                        PARENT oMenuMemo

    DCMENUITEM "~Undo"   ACTION {|| oPtext:undo() }                       MESSAGE 'Undo Item'                                         PARENT oMenuMemo


  @ 30.25, 3.00 DCPUSHBUTTON           CAPTION {|| IIF(lNewRec,'Add','Update')} ;
                                                                          SIZE  9, 1.20                                               PARENT oStatic2 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. !Empty(cPcode) .AND. aSecurity[2] } ;
                ACTION {|| PrtForm5(cCitation), CodeAction(IIF(lNewRec,1,2),GetList)}

  @ 30.25,14.00 DCPUSHBUTTON           CAPTION 'Cancel'                   SIZE  9, 1.20                                               PARENT oStatic2 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| CodeAction(0,GetList) }

  @ 30.25,25.00 DCPUSHBUTTON           CAPTION 'Exit'                     SIZE  9, 1.20                                               PARENT oStatic2 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 30.25,68.00 DCPUSHBUTTON           CAPTION 'Print'                    SIZE  9, 1.20                                               PARENT oStatic2 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. !Empty(cPcode) .AND. aSecurity[4] } ;
                ACTION {|| PrtForm5(cCitation) }


  DCSETPARENT TO


/* ---- Tab Page #3 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage3    CAPTION ' Receipting '             RELATIVE oTabPage2                                                              COLOR GRA_CLR_GREEN ;
                ACCELKEY xbeK_ALT_R ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(DC_GetObject(GetList,"Get_dRdate")) }

  DCSETPARENT TO oTabPage3

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3,DCGUI_PARENTHEIGHT - 2           PARENT oTabPage3    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic3 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic3

  @   .25, 1.50 DCGROUP oGroup4        CAPTION ' Citation Information '   SIZE DCGUI_PARENTWIDTH - 3,10.00                            PARENT oStatic3     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)


  @ 10.50, 1.50 DCGROUP oGroup7        CAPTION ' Payment / Service Hours ' ;
                                                                          SIZE DCGUI_PARENTWIDTH - 3,18.75                            PARENT oStatic3     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @   .00,56.45 DCSAY ' Assessed '                                        SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLUE
  @   .00,67.15 DCSAY ' Remaining '                                       SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLUE

  @  1.25, 1.00 DCSAY 'Fine Assessed'                                     SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  1.00,16.00 DCGET nFine            Picture '999999.99'                                                                            PARENT oGroup7      COLOR GRA_CLR_BLUE ;
					 TABSTOP ;
 				    GETID "Get_nFineR" ;
					 LOSTFOCUS bRefresh ;
                TABGROUP XBP_BEGIN_GROUP ;
                MESSAGE 'Enter The Fine Amount Assessed by the Hearing Officer.' INTO oMsgBox

  @  1.05,53.25 DCSAY bTotal                                              SAYSIZE 10                                                  PARENT oGroup7      COLOR GRA_CLR_BLUE ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New"
  @  1.05,65.00 DCSAY {|| nReceiptAmt }                                   SAYSIZE 10                                                  PARENT oGroup7      COLOR bReceipt ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New"

  @  1.25,33.00 DCSAY 'Fine and Costs'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK

  @  2.50, 1.00 DCSAY 'Costs Assessed'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  2.25,16.00 DCGET nCosts           Picture '999999.99'                                                                            PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nCostsR" ;
					 LOSTFOCUS bRefresh ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Hearing Costs Assessed by the Hearing Officer.' INTO oMsgBox

  @  2.50,33.00 DCSAY 'Community Service Hours'                           SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  2.25,53.25 DCSAY {|| TRANSFORM(nCSHrs,"999") }                       SAYSIZE 10                                                  PARENT oGroup7      COLOR GRA_CLR_BLUE ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New"
  @  2.25,65.00 DCSAY {|| TRANSFORM(nReceiptHrs,"999") }                  SAYSIZE 10                                                  PARENT oGroup7      COLOR GRA_CLR_BLUE ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New"

  @  3.45,63.50 DCPUSHBUTTON           CAPTION 'Receipting Review'        SIZE 12.00, 2.00                                            PARENT oGroup7 ;
                CARGO "CANCEL" ;
                WHEN {|| lReceipts } ;
                ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| CashReview(GetList) }

  @  3.75, 1.00 DCSAY 'Hours Assessed'                                    SIZE  0                                                     PARENT oGroup7     COLOR GRA_CLR_BLACK
  @  3.50,16.00 DCGET nCSHrs           Picture '999999'                                                                               PARENT oGroup7     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nCSHrsR" ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Community Service Hours Assessed by the Hearing Officer.' INTO oMsgBox

  @  3.75,33.00 DCSAY {|| LTRIM(TRANSFORM(nChecks,"999")) + ' Returned Check Fees' }                                                  PARENT oGroup7      COLOR GRA_CLR_RED ;
	 				 HIDE {|| nCheckFee == 0.00 }	                             SAYSIZE 20

  @  3.60,53.25 DCSAY {|| TRANSFORM(nCheckFee,"999.99") }                 SAYSIZE 10                                                  PARENT oGroup7      COLOR GRA_CLR_RED ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New" ;
                HIDE {|| nCheckFee == 0.00 }

  @  5.00, 1.00 DCSAY 'Batch Control'                                     SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  4.75,16.00 DCGET cBatchName       Picture '!XXXXXXXXXXXXXXXXXXX'                                                                 PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cBatchName" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 VALID {|| ValidateBatchName(GetList) } ;
                POPUP {|c| c := GuiBatchScan(c, GetList) } ;
	             MESSAGE 'Enter the Receipt Batch Control.'  INTO oMsgBox

  @  5.00,48.00 DCSAY {|| TRANSFORM(nBatchAmt,"999,999.99") }             SAYSIZE 12                                                  PARENT oGroup7      COLOR GRA_CLR_DARKGREEN ;
                FONT "11.Courier New" ;
                HIDE {|| nBatchAmt == 0.00 }

  @  6.25, 1.00 DCSAY 'Activity Date'                                     SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  6.00,16.00 DCGET dRdate           Picture '@D'                                                                                   PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_dRdate" ;
					 WHEN {|| Empty(dRdate) } ;
                TABGROUP XBP_WITHIN_GROUP ;
					 VALID {|| ValidateRdate(dRdate, GetList) } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  6.25,33.00 DCSAY {|| PrintDate(dRdate,1) }                           SIZE 20                                                     PARENT oGroup7      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dRdate) }

  @  5.85,63.50 DCPUSHBUTTON           CAPTION 'Under / Over;Payment Letter' ;
                                                                          SIZE 12.00, 2.00                                            PARENT oGroup7 ;
                CARGO "CANCEL" ;
                ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| UnderOverPaid(cCitation) } ;
                WHEN {|| !lPartial .AND. nAmt < (nFine + nCosts) .AND. nAmt > 0.00 .AND. aSecurity[4] .OR. nOverAmt > 0.00 .AND. aSecurity[4] }

  @  7.50, 1.00 DCSAY 'Payment Method'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK

  @  7.25,16.00 DCCOMBOBOX cPayment    LIST aPayment                      SIZE 12, 5 ;
					 PARENT oGroup7 ;
 				    ID "Get_cPayment" ;
					 WHEN {|| !Empty(dRdate) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Select The Payment Type Type.' INTO oMsgBox

  @  8.75, 1.00 DCSAY 'Check Number'                                      SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  8.50,16.00 DCGET cCheckNo         Picture '@!'                                                                                   PARENT oGroup7      COLOR GRA_CLR_BLUE ;
					 GETID "Get_cCheckNo" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(dRdate) .AND. cPayment <> aPayment[1] } ;
                MESSAGE 'Enter The Check Number of the Payment.' INTO oMsgBox

  @  8.25,63.50 DCPUSHBUTTON           CAPTION 'Print Cash;Receipt'       SIZE 12.00, 2.00                                            PARENT oGroup7 ;
                CARGO "CANCEL" ;
                ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| Print390(cCitation) , CodeAction(0,GetList) } ;
                WHEN {|| !Empty(cCitation) .AND. !lNewCash .AND. aSecurity[4] }

  @ 10.00, 1.00 DCSAY 'Amount Received'                                   SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  9.75,16.00 DCGET nAmt             Picture '999999.99'                                                                            PARENT oGroup7      COLOR bReceipt ;
 				    GETID "Get_nAmt" ;
					 LOSTFOCUS bReFresh ;
					 WHEN {|| !Empty(dRdate) } ;
                TABGROUP XBP_WITHIN_GROUP ;
					 VALID {|| ValidatePaid(GetList) } ;
                MESSAGE 'Enter The Payment Amount Received.' INTO oMsgBox

  @ 10.00,33.00 DCSAY 'Receipt Number'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @  9.75,47.00 DCGET nReceipt         Picture '9999999999'                                                                           PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nReceipt" ;
					 WHEN {|| nAmt > 0.00 } ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Manual Receipt Number.' INTO oMsgBox

  @ 11.25, 1.00 DCSAY 'OverPaid Amount'                                   SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 11.00,16.00 DCGET nOverAmt         Picture '999999.99'                                                                            PARENT oGroup7      COLOR GRA_CLR_RED ;
                EDITPROTECT {|| .t. } ;
                TABGROUP XBP_WITHIN_GROUP ;
                WHEN {|| !Empty(dRdate) .AND. nOverAmt > 0.00 }

  @ 11.25,33.00 DCSAY 'Amount Entered'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 11.00,49.15 DCSAY bPayment         Picture '999999.99'                SAYSIZE 10                                                  PARENT oGroup7      COLOR bReceipt ;
                SAYRIGHTBOTTOM ;
                FONT "11.Courier New"

  @ 12.50, 1.00 DCSAY 'Hours Performed'                                   SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 12.25,16.00 DCGET nHrs             Picture '99999'                                                                                PARENT oGroup7      COLOR bCsHrs ;
 				    GETID "Get_nHrs" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| dRdate <> CtoD('') }

  @ 13.75, 1.00 DCSAY 'Agency Amount'                                     SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 13.50,16.00 DCGET nAgency          Picture '999999.99'                                                                            PARENT oGroup7      COLOR bReceipt ;
 				    GETID "Get_nAgency" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(dRdate) } ;
                MESSAGE 'Enter The Amount Paid to the Collection Agency.' INTO oMsgBox

  @ 13.75,33.00 DCSAY 'Agency Code'                                       SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 13.50,47.00 DCGET cAgencyCode      Picture '!!!!'                                                                                 PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cAgencyCode" ;
					 WHEN {|| nAgency > 0.00 } ;
                TABGROUP XBP_WITHIN_GROUP ;
                POPUP {|c| c := GuiAgencyScan(c, GetList) } ;
                VALID {|| ValidateAgency(cAgencyCode, GetList) } ;
                MESSAGE 'Enter The Collection Agency Receipting Code.' INTO oMsgBox
  @ 13.75,56.00 DCSAY {|| cAgencyDesc }                                   SAYSIZE 20                                                  PARENT oGroup7      COLOR GRA_CLR_BLUE

  @ 15.00, 1.00 DCSAY 'Write Off Amount'                                  SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 14.75,16.00 DCGET nWriteOff        Picture '999999.99'                                                                            PARENT oGroup7      COLOR bReceipt ;
					 LOSTFOCUS bReFresh ;
 				    GETID "Get_nWriteOff" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(dRdate) } ;
                MESSAGE 'Enter The Write-Off Amount.' INTO oMsgBox

  @ 15.00,33.00 DCSAY 'Payment Type'                                      SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK
  @ 14.75,47.00 DCGET cCashCode        Picture '!!!!'                                                                                 PARENT oGroup7      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cCashCode" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| nWriteOff <> 0.00 } ;
                POPUP {|c| c := GuiPaymentScan(c, GetList) } ;
                VALID {|| ValidatePayment(cCashCode, GetList) } ;
                MESSAGE 'Enter The Write-Off Payment Type Code.' INTO oMsgBox
  @ 15.00,56.00 DCSAY {|| cCashDesc }                                     SAYSIZE 20                                                  PARENT oGroup7      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dRdate) }

  @ 16.00,16.00 DCCHECKBOX lBadCheck   PROMPT " Returned Check"                                                                       PARENT oGroup7      COLOR GRA_CLR_RED ;
					 ID "Get_lBadCheck" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| !Empty(dRdate) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
					 TOOLTIP 'Designate Payment Information As "Returned Check" and Reverse Payment.'

  @ 16.25,33.00 DCSAY 'Returned Date'                                     SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_RED ;
					 WHEN {|| lBadCheck }
  @ 16.00,47.00 DCGET dBadCheck        Picture '@D'                                                                                   PARENT oGroup7      COLOR GRA_CLR_BLUE ;
					 ID "Get_dBadCheck" ;
					 WHEN {|| lBadCheck } ;
                TABGROUP XBP_WITHIN_GROUP ;
					 TOOLTIP 'Date "Returned Check" Received.' ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.) } ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Returned Check Date.' INTO oMsgBox

  @ 17.25, 1.00 DCSAY 'Amnesty Amount'                                    SIZE  0                                                     PARENT oGroup7      COLOR GRA_CLR_BLACK ;
					 WHEN {|| lAmnesty }
  @ 17.00,16.00 DCGET nAmnesty         Picture '999999.99'                                                                            PARENT oGroup7      COLOR bReceipt ;
					 LOSTFOCUS bReFresh ;
 				    GETID "Get_nAmnesty" ;
                TABGROUP XBP_END_GROUP ;
					 WHEN {|| lAmnesty .AND. !Empty(dRdate) } ;
                MESSAGE 'Enter The Amnesty Write-Off Amount.' INTO oMsgBox


  @ 30.25, 3.00 DCPUSHBUTTON           CAPTION {|| IIF(lNewCash,'Add','Update') } ;
                CARGO "CANCEL"                                            SIZE  9, 1.20                                               PARENT oStatic3 ;
					 WHEN {|| !Empty(dRdate) .AND. aSecurity[2] } ;
                ACTION {|| CashAction(IIF(lNewCash,1,2),GetList) }

  @ 30.25,14.00 DCPUSHBUTTON           CAPTION 'Delete'                   SIZE  9, 1.20                                               PARENT oStatic3 ;
					 CARGO "CANCEL" ;
                ACTION {|| CashAction(3,GetList) } ;
                WHEN {|| !lNewCash .AND. nGroup > 1 .AND. aSecurity[3] }

  @ 30.25,25.00 DCPUSHBUTTON           CAPTION 'Cancel'                   SIZE  9, 1.20                                               PARENT oStatic3 ;
					 CARGO "CANCEL" ;
                ACTION {|| CashAction(0,GetList) }

  @ 30.25,36.00 DCPUSHBUTTON           CAPTION 'Exit'                     SIZE  9, 1.20                                               PARENT oStatic3 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 30.25,68.00 DCPUSHBUTTON           CAPTION 'Print'                    SIZE  9, 1.20                                               PARENT oStatic3 ;
					 CARGO "CANCEL" ;
                ACTION {|| Print390(cCitation) , CodeAction(0,GetList) } ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. aSecurity[4] }


  DCSETPARENT TO


/* ---- Tab Page #4 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage4    CAPTION ' Status '                 RELATIVE oTabPage3                                                              COLOR GRA_CLR_BROWN ;
                ACCELKEY xbeK_ALT_S ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(DC_GetObject(GetList,"Get_dSdate")) }

  DCSETPARENT TO oTabPage4

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3,DCGUI_PARENTHEIGHT - 2           PARENT oTabPage4    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic4 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic4

  @   .25, 1.50 DCGROUP oGroup4  CAPTION ' Citation Information '         SIZE DCGUI_PARENTWIDTH - 3,10.00                            PARENT oStatic4     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)


  @ 10.50, 1.50 DCGROUP oGroup9  CAPTION ' Status Information '           SIZE DCGUI_PARENTWIDTH - 3,19.25                            PARENT oStatic4     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.20, 1.00 DCSAY 'Activity Date'                                     SIZE  0                                                     PARENT oGroup9      COLOR GRA_CLR_BLACK
  @  1.00,12.00 DCGET dSdate           Picture '@D'                                                                                   PARENT oGroup9      COLOR GRA_CLR_BLUE ;
					 TABSTOP ;
 				    GETID "Get_dSdate" ;
                TABGROUP XBP_BEGIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  1.20,30.00 DCSAY {|| PrintDate(dSdate,1) }                           SAYSIZE 20                                                  PARENT oGroup9      COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dSdate) }

  @  1.00,65.00 DCPUSHBUTTON  CAPTION 'Status Review'                     SIZE 10, 2                                                  PARENT oGroup9 ;
					 CARGO "CANCEL" ;
					 WHEN {|| nStatus > 0 } ;
				    ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| StatusReview(GetList) }

  @  2.40, 1.00 DCSAY 'Status Code'                                       SIZE  0                                                     PARENT oGroup9      COLOR GRA_CLR_BLACK
  @  2.20,12.00 DCGET cScode           Picture '!!!!'                                                                                 PARENT oGroup9      COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cScode" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| dSdate > CtoD('') } ;
                POPUP {|c| c := GuiStatusScan(c, GetList) } ;
                VALID {|| ValidateStatus(cScode, GetList) }
  @  2.40,30.00 DCSAY {|| cSdesc }                                        SAYSIZE 35                                                  PARENT oGroup9      COLOR GRA_CLR_BLUE

  @  3.40, 1.00 DCCHECKBOX lSuspense   PROMPT " &Hold Processing"                                                                     PARENT oGroup9      COLOR GRA_CLR_BLUE ;
					 ACCELKEY xbeK_ALT_H ;
                TABGROUP XBP_WITHIN_GROUP ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                TOOLTIP 'Flag Citation as "Hold" Processing.'

  @  3.60,30.00 DCSAY 'Sent to Collections Date'                          SIZE  0                                                     PARENT oGroup9      COLOR GRA_CLR_BLACK
  @  3.40,50.00 DCGET dCollections     Picture '@D'                                                                                   PARENT oGroup9      COLOR GRA_CLR_RED ;
 				    GETID "Get_dCollections" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| dSdate > CtoD('') } ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  4.90, 1.00 DCMULTILINE cStext                                        SIZE DCGUI_PARENTWIDTH - 2,13.95                            PARENT oGroup9 ;
				    TABSTOP ;
                NOHORIZSCROLL ;
				    OBJECT oStext ;
 				    ID "Get_cStext" ;
				    FONT "10.Courier New" ;
                TABGROUP XBP_END_GROUP ;
 					 WHEN {|| !Empty(cScode) } ;
				    EVAL {|o| o:RbDown := {|x,y,z| oMenuMemo1:PopUp( z, x, 2, ;
				                               XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) } }

  DCSUBMENU oMenuMemo1 PROMPT "&Memo"                                                                                                 PARENT oStext

    DCMENUITEM "~Delete" ACTION {|| oStext:deleteMarked() } MESSAGE 'Delete Item'                                                     PARENT oMenuMemo1

    DCMENUITEM "~Cut"    ACTION {|| oStext:cutMarked() }    MESSAGE 'Cut Item'                                                        PARENT oMenuMemo1

    DCMENUITEM "C~opy"   ACTION {|| oStext:copyMarked() }   MESSAGE 'Copy Item'                                                       PARENT oMenuMemo1

    DCMENUITEM "~Paste"  ACTION {|| oStext:pasteMarked()}   MESSAGE 'Paste Item'                                                      PARENT oMenuMemo1

    DCMENUITEM "~Undo"   ACTION {|| oStext:undo() }         MESSAGE 'Undo Item'                                                       PARENT oMenuMemo1


  @ 30.25, 3.00 DCPUSHBUTTON  CAPTION {|| IIF(lNewStat,'Add','Update') }  SIZE  9, 1.20                                               PARENT oStatic4 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. !Empty(cScode) .AND. aSecurity[2] } ;
                ACTION {|| StatAction(IIF(lNewStat,1,2),GetList) }

  @ 30.25,14.00 DCPUSHBUTTON  CAPTION 'Delete'                            SIZE  9, 1.20                                               PARENT oStatic4 ;
					 CARGO "CANCEL" ;
                WHEN {|| !lNewStat .AND. nGroup > 1 .AND. aSecurity[3] } ;
                ACTION {|| StatAction(3,GetList) }

  @ 30.25,25.00 DCPUSHBUTTON  CAPTION 'Cancel'                            SIZE  9, 1.20                                               PARENT oStatic4 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| StatAction(0,GetList) }

  @ 30.25,36.00 DCPUSHBUTTON  CAPTION 'Exit'                              SIZE  9, 1.20                                               PARENT oStatic4 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 30.25,68.00 DCPUSHBUTTON  CAPTION 'Print'                             SIZE  9, 1.20                                               PARENT oStatic4 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. aSecurity[4] } ;
                ACTION {|| Print390(cCitation) , CodeAction(0,GetList) }


  DCSETPARENT TO


/* ---- Tab Page #5 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage5 CAPTION ' Disposition '               RELATIVE oTabPage4                                                              COLOR GRA_CLR_RED ;
                ACCELKEY xbeK_ALT_D ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(DC_GetObject(GetList,"Get_dXdate")) }

  DCSETPARENT TO oTabPage5

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3,DCGUI_PARENTHEIGHT - 2           PARENT oTabPage5    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic5 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic5

  @   .25, 1.50 DCGROUP oGroup4  CAPTION ' Citation Information '         SIZE DCGUI_PARENTWIDTH - 3,10.00                            PARENT oStatic5     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)


  @ 10.50, 1.50 DCGROUP oGroup11 CAPTION ' Disposition Information '      SIZE DCGUI_PARENTWIDTH - 3,19.25                            PARENT oStatic5     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.25, 1.00 DCSAY 'Disposition Date'                                  SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  1.00,15.00 DCGET dXdate          Picture '@D'                                                                                    PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 TABSTOP ;
 				    GETID "Get_dXdate" ;
                TABGROUP XBP_BEGIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Hearing Disposition Date.' INTO oMsgBox

  @  1.25,34.00 DCSAY {|| PrintDate(dXdate,1) }                           SAYSIZE 20                                                  PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 HIDE {|| Empty(dXdate) }

  @  1.00,65.00 DCPUSHBUTTON CAPTION "Vacation of Conviction" 		        SIZE 10, 2                                                  PARENT oGroup11 ;
					 ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| lVacate := .t., Mvp952x(GetList) } ;
                WHEN {|| OrdMst->SosNotice .AND. aSecurity[4] } ;
                TOOLTIP 'Secretary of State - Vacation of Conviction.'

  @  2.50, 1.00 DCSAY 'Disposition Code'                                  SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  2.25,15.00 DCGET cXcode          Picture '!!!!'                                                                                  PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_cXcode" ;
                TABGROUP XBP_WITHIN_GROUP ;
					 WHEN {|| dXdate <> CtoD('') } ;
                POPUP {|c| c := GuiDispositionScan(c, GetList) } ;
                VALID {|| ValidateDisposition(cXcode, GetList) } ;
                MESSAGE 'Enter The Hearing Disposition Code.' INTO oMsgBox

  @  2.50,28.00 DCSAY {|| cXform }                                        SAYSIZE  5                                                  PARENT oGroup11     COLOR {110,165,220} ;
					 WHEN !Empty(cXform)

  @  2.50,34.00 DCSAY {|| cXdesc }                                        SAYSIZE 30                                                  PARENT oGroup11     COLOR GRA_CLR_BLUE

  @  3.75, 1.00 DCSAY 'Fine Assessed'                                     SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  3.50,15.00 DCGET nFine           Picture '999999.99'                                                                             PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nFine" ;
					 LOSTFOCUS bRefresh ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Fine Amount Assessed by the Hearing Officer.' INTO oMsgBox

  @  5.00, 1.00 DCSAY 'Hours Assessed'                                    SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  4.75,15.00 DCGET nCSHrs          Picture '999999'                                                                                PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nCSHrs" ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Community Service Hours Assessed by the Hearing Officer.' INTO oMsgBox

  @  6.25, 1.00 DCSAY 'Costs Assessed'                                    SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  6.00,15.00 DCGET nCosts          Picture '999999.99'                                                                             PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_nCosts" ;
					 LOSTFOCUS bRefresh ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE 'Enter The Hearing Costs Assessed by the Hearing Officer.' INTO oMsgBox

  @  7.45, 1.00 DCSAY 'Judgement Total'                                   SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLUE
  @  7.35,26.00 DCSAY {|| TRANSFORM((nFine + nCosts),"999,999.99") }      SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_RED ;
                ALIGNRIGHT ;
                FONT "11.Courier New"


  @  3.60,34.00 DCSAY 'C/S Return Date'                                   SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  3.40,48.00 DCGET dCSdate         Picture '@D'                                                                                    PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_dCSdate" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Community Service Hours Return Date.' INTO oMsgBox

  @  3.50,64.00 DCPUSHBUTTON CAPTION "1" 			 		                    SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(1,GetList) } ;
                TOOLTIP '1 Month Return Date'

  @  3.50,66.00 DCPUSHBUTTON CAPTION "2"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(2,GetList) } ;
                TOOLTIP '2 Month Return Date'

  @  3.50,68.00 DCPUSHBUTTON CAPTION "3"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(3,GetList) } ;
                TOOLTIP '3 Month Return Date'

  @  3.50,70.00 DCPUSHBUTTON CAPTION "4"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(4,GetList) } ;
                TOOLTIP '4 Month Return Date'

  @  3.50,72.00 DCPUSHBUTTON CAPTION "5"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(5,GetList) } ;
                TOOLTIP '5 Month Return Date'

  @  3.50,74.00 DCPUSHBUTTON CAPTION "6"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpReturn(6,GetList) } ;
                TOOLTIP '6 Month Return Date'

  @  5.00,34.00 DCSAY 'Continuation Date'                                 SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  4.75,48.00 DCGET dContinued      Picture '@D'                                                                                    PARENT oGroup11     COLOR GRA_CLR_BLUE ;
 				    GETID "Get_dContinued" ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  4.75,64.00 DCPUSHBUTTON CAPTION "1"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(1,GetList) } ;
                TOOLTIP '1 Month Continuation Date'

  @  4.75,66.00 DCPUSHBUTTON CAPTION "2"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(2,GetList) } ;
                TOOLTIP '2 Month Continuation Date'

  @  4.75,68.00 DCPUSHBUTTON CAPTION "3"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(3,GetList) } ;
                TOOLTIP '3 Month Continuation Date'

  @  4.75,70.00 DCPUSHBUTTON CAPTION "4"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(4,GetList) } ;
                TOOLTIP '4 Month Continuation Date'

  @  4.75,72.00 DCPUSHBUTTON CAPTION "5"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(5,GetList) } ;
                TOOLTIP '5 Month Continuation Date'

  @  4.75,74.00 DCPUSHBUTTON CAPTION "6"                                  SIZE  2, 1                                                  PARENT oGroup11 ;
                ACTION {|| BumpContinuation(6,GetList) } ;
                TOOLTIP '6 Month Continuation Date'


  @  5.90,34.00 DCCHECKBOX lSubpoena  PROMPT " Officer Required at Hearing "                                                          PARENT oGroup11     COLOR GRA_CLR_BLUE ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
					 TOOLTIP "Designates Officer's Required Attendance and Prints Subpoena for the Hearing."

  @  6.10,65.29 DCSAY "F12"                                               SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_RED ;
                FONT "12.Courier New"
  @  6.20,70.57 DCSAY "Print"                                             SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLUE ;
                FONT "8.Courier New"

  @  7.15,34.00 DCCHECKBOX lTownship  PROMPT " Township Program"                                                                      PARENT oGroup11     COLOR GRA_CLR_BLUE ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                TOOLTIP "Designates Respondent Ordered into Township Program."

  @  7.50,51.00 DCSAY 'Completion Date'                                   SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK
  @  7.25,64.00 DCGET dTownship       Picture '@D'                                                                                    PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 WHEN {|| lTownship } ;
 				    GETID "Get_dTownship" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Community Service Hours Completion Date.' INTO oMsgBox

  @  8.75, 1.00 DCSAY 'Evidence Code'                                     SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK ;
					 WHEN {|| lEvidence }
  @  8.50,15.00 DCGET cEvidCode       Picture '!!!!'                                                                                  PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 WHEN {|| lEvidence } ;
 				    GETID "Get_cEvidCode" ;
                TABGROUP XBP_WITHIN_GROUP ;
                POPUP {|c| c := GuiEvidenceScan(c, GetList) } ;
                VALID {|| ValidateEvidence(cEvidCode, GetList) } ;
                MESSAGE 'Enter The Evidence Disposition Code.' INTO oMsgBox

  @  8.75,28.00 DCSAY {|| cEvidDesc }                                     SAYSIZE 20                                                  PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 WHEN {|| !Empty(cEvidCode) }

  @  8.75,51.00 DCSAY 'Evidence Date'                                     SIZE  0                                                     PARENT oGroup11     COLOR GRA_CLR_BLACK ;
					 WHEN {|| lEvidence }
  @  8.50,64.00 DCGET dEvidDate       Picture '@D'                                                                                    PARENT oGroup11     COLOR GRA_CLR_BLUE ;
					 WHEN {|| !Empty(cEvidCode) } ;
 				    GETID "Get_dEvidDate" ;
                TABGROUP XBP_WITHIN_GROUP ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE ;
                MESSAGE 'Enter The Date which the Evidence can be Disposed or Eeleased.' INTO oMsgBox


  @  9.75, 1.00 DCMULTILINE cXtext                                        SIZE DCGUI_PARENTWIDTH - 2, 9.00                            PARENT oGroup11 ;
                TABSTOP ;
                OBJECT oXtext ;
                NOHORIZSCROLL ;
                ID "Get_cXtext" ;
                FONT "8.Courier New" ;
                TABGROUP XBP_END_GROUP ;
 					 WHEN {|| !Empty(dXdate) } ;
                EVAL {|o| o:RbDown := {|x,y,z| oMenuMemo2:PopUp( z, x, 2, ;
                                               XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) } }

  DCSUBMENU oMenuMemo2 PROMPT "&Memo" PARENT oXtext

    DCMENUITEM "~Delete" ACTION {|| oXtext:deleteMarked() } MESSAGE 'Delete Item'                                                     PARENT oMenuMemo2

    DCMENUITEM "~Cut"    ACTION {|| oXtext:cutMarked() }    MESSAGE 'Cut Item'                                                        PARENT oMenuMemo2

    DCMENUITEM "C~opy"   ACTION {|| oXtext:copyMarked() }   MESSAGE 'Copy Item'                                                       PARENT oMenuMemo2

    DCMENUITEM "~Paste"  ACTION {|| oXtext:pasteMarked()}   MESSAGE 'Paste Item'                                                      PARENT oMenuMemo2

    DCMENUITEM "~Undo"   ACTION {|| oXtext:undo() }         MESSAGE 'Undo Item'                                                       PARENT oMenuMemo2


  @ 30.25, 3.00 DCPUSHBUTTON  CAPTION {|| IIF(lNewRec,'Add','Update')}    SIZE  9, 1.20                                               PARENT oStatic5 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. aSecurity[2] } ;
                ACTION {|| CodeAction(IIF(lNewRec,1,2),GetList)}

  @ 30.25,14.00 DCPUSHBUTTON  CAPTION 'Cancel'                            SIZE  9, 1.20                                               PARENT oStatic5 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| CodeAction(0,GetList) }

  @ 30.25,25.00 DCPUSHBUTTON  CAPTION 'Exit'                              SIZE  9, 1.20                                               PARENT oStatic5 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 30.25,38.00 DCCHECKBOX lPayPlan    PROMPT '  30 Day Payment Deferral'                                                             PARENT oStatic5     COLOR GRA_CLR_RED ;
                ID "Get_lPayPlan" ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                MESSAGE 'Print 30 Day to Pay Request Form' INTO oMsgBox ;
                WHEN {|| !Empty(dXdate) .AND. (nFine + nCosts) > 0.00 .AND. lConvict .AND. nAmt == 0.00 }

  @ 30.25,63.00 DCPUSHBUTTON  CAPTION 'Print Disposition'                 SIZE 14, 1.20                                               PARENT oStatic5 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. dXdate > CtoD('') .AND. aSecurity[4] } ;
                ACTION {|| PrintDisposition( GetList ) }


  DCSETPARENT TO


/* ---- Tab Page #6 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage6    CAPTION ' Associated '             RELATIVE oTabPage5                                                              COLOR GRA_CLR_YELLOW ;
                ACCELKEY xbeK_ALT_A ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(oBrowse13) }

  DCSETPARENT TO oTabPage6

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3.00,DCGUI_PARENTHEIGHT - 2.00     PARENT oTabPage6    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic6 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic6

  @   .25, 1.50 DCGROUP oGroup4        CAPTION ' Citation Information '   SIZE DCGUI_PARENTWIDTH - 3.00,10.00                         PARENT oStatic6     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)

  nPointer  := 1
  bSetSize6 := {|x,y,o| {o:currentsize()[1]+x, o:currentsize()[2]+y} }


  @ 10.50, 1.50 DCGROUP oGroup13       CAPTION ' Associated Citations '   SIZE DCGUI_PARENTWIDTH - 3.00,21.50                         PARENT oStatic6     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @   .75, 1.00 DCBROWSE oBrowse13     DATA aAssociated                   SIZE DCGUI_PARENTWIDTH - 2.00,19.00                         PARENT oGroup13 ;
					 NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
					 RESIZECOLUMNS ;
					 POINTER nPointer ;
					 RESIZE { Nil, bSetSize6 } ;
  			       PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW

  DCBROWSECOL   ELEMENT 1                                                HEADER '    Citation;    Number'      WIDTH  6               PARENT oBrowse13 ;
				    ALIGN 1
//				    DATATOOLTIP {|| .t. }  TIPBLOCK {|| AssociatedStatus() }
  DCBROWSECOL   DATA {|x| SexDesc(x := DC_GetColArray(1,oBrowse13)) }    HEADER ';   Sex'                      WIDTH  4               PARENT oBrowse13 ;
				    ALIGN 1
  DCBROWSECOL   DATA {|x| RaceDesc(x := DC_GetColArray(1,oBrowse13)) }   HEADER ';  Race'                      WIDTH  4               PARENT oBrowse13 ;
				    ALIGN 1
  DCBROWSECOL   DATA {|x| DobDesc(x := DC_GetColArray(1,oBrowse13)) }    HEADER ';   Birth Date'               WIDTH  6               PARENT oBrowse13 ;
				    ALIGN 1
  DCBROWSECOL   DATA {|x| NameDesc(x := DC_GetColArray(1,oBrowse13)) }   HEADER '; Respondent Name'            WIDTH 24               PARENT oBrowse13


  DCSETPARENT TO


/* ---- Tab Page #7 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage7    CAPTION ' Comments '               RELATIVE oTabPage6                                                              COLOR GRA_CLR_WHITE ;
                ACCELKEY xbeK_ALT_X ;
                WHEN {|| nGroup > 1 } ;
                GOTFOCUS {|| SetAppFocus(oCdate) }

  DCSETPARENT TO oTabPage7

  @  1.50, 1.50 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                  SIZE DCGUI_PARENTWIDTH - 3,DCGUI_PARENTHEIGHT - 2           PARENT oTabPage7    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND ;
					 OBJECT oStatic7 ;
                RESIZE DCGUI_RESIZE_BOTH

  DCSETPARENT TO oStatic7

  @   .25, 1.50 DCGROUP oGroup4        CAPTION ' Citation Information '   SIZE DCGUI_PARENTWIDTH - 3,10.00                            PARENT oStatic7     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  TabDisplay(GetList)


  @ 10.50, 1.50 DCGROUP oGroup17       CAPTION ' Miscellaneous Comments ' SIZE DCGUI_PARENTWIDTH - 3,19.25                            PARENT oStatic7     COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  1.20, 2.00 DCSAY 'Comments Date'                                     SIZE  0                                                     PARENT oGroup17     COLOR GRA_CLR_BLACK
  @  1.00,15.00 DCGET dCdate           Picture '@D'                                                                                   PARENT oGroup17     COLOR GRA_CLR_BLUE ;
 				    GETOBJECT oCdate ;
 				    GETID "Get_dCdate" ;
				    POPUP {|d| tdPopCal( ,2,2,.t.,3,"gray",.f.)} ;
					   POPCAPTION { BITMAP_CALENDAR_M, 0 } ;
					   POPFONT '12.Arial Bold' ;
					   POPSTYLE DCGUI_POPUPSTYLE_OUTSIDE

  @  1.00,65.00 DCPUSHBUTTON           CAPTION 'Review'                   SIZE 10, 1.10                                               PARENT oGroup17 ;
					 CARGO "CANCEL" ;
					 WHEN {|| .f. } ;
				    ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @  2.50, 1.00 DCMULTILINE cCtext                                        SIZE DCGUI_PARENTWIDTH - 2,16.25                            PARENT oGroup17 ;
				    TABSTOP ;
				    OBJECT oCtext ;
 				    ID "Get_cCtext" ;
				    FONT "8.Courier New" ;
 					 WHEN {|| !Empty(dCdate) } ;
				    EVAL {|o| o:RbDown := {|x,y,z| oMenuMemo8:PopUp( z, x, 2, XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) } }

  DCSUBMENU oMenuMemo7                 PROMPT "&Memo"                                                                                 PARENT oCtext

    DCMENUITEM "~Delete" ACTION {|| oCtext:deleteMarked() } MESSAGE 'Delete Item'                                                     PARENT oMenuMemo7

    DCMENUITEM "~Cut"    ACTION {|| oCtext:cutMarked() }    MESSAGE 'Cut Item'                                                        PARENT oMenuMemo7

    DCMENUITEM "C~opy"   ACTION {|| oCtext:copyMarked() }   MESSAGE 'Copy Item'                                                       PARENT oMenuMemo7

    DCMENUITEM "~Paste"  ACTION {|| oCtext:pasteMarked()}   MESSAGE 'Paste Item'                                                      PARENT oMenuMemo7

    DCMENUITEM "~Undo"   ACTION {|| oCtext:undo() }         MESSAGE 'Undo Item'                                                       PARENT oMenuMemo7


  @ 30.25, 3.00 DCPUSHBUTTON  CAPTION {|| IIF(lNewRec,'Add','Update')}    SIZE  9, 1.20                                               PARENT oStatic7 ;
					 CARGO "CANCEL" ;
                WHEN {|| nGroup > 1 .AND. dCdate > CtoD('') .AND. aSecurity[2] } ;
                ACTION {|| CodeAction(IIF(lNewRec,1,2),GetList) }

  @ 30.25,14.00 DCPUSHBUTTON  CAPTION 'Delete'                            SIZE  9, 1.20                                               PARENT oStatic7 ;
					 CARGO "CANCEL" ;
                WHEN {|| !lNewRec .AND. nGroup > 1 .AND. aSecurity[3] } ;
                ACTION {|| CodeAction(3,GetList)}

  @ 30.25,25.00 DCPUSHBUTTON  CAPTION 'Cancel'                            SIZE  9, 1.20                                               PARENT oStatic7 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) } ;
                ACTION {|| CodeAction(0,GetList) }

  @ 30.25,36.00 DCPUSHBUTTON  CAPTION 'Exit'                              SIZE  9, 1.20                                               PARENT oStatic7 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 29.00,68.00 DCPUSHBUTTON  CAPTION 'Print'                             SIZE  9, 1.20                                               PARENT oStatic7 ;
					 CARGO "CANCEL" ;
                WHEN {|| !Empty(cCitation) .AND. !lNewRec .AND. aSecurity[4] } ;
                ACTION {|| Print390(cCitation) , CodeAction(0,GetList) }


  DCSETPARENT TO


/* ---- Tab Page #8 ---- */

  @  0.00, 0.00 DCTABPAGE oTabPage8    CAPTION ' Graphics '               RELATIVE oTabPage7                                                              COLOR GRA_CLR_PALEGRAY ;
                ACCELKEY xbeK_ALT_G ;
					 WHEN {|| !lNewRec } ;
                RESIZE DCGUI_RESIZE_RESIZEONLY ;
                GOTFOCUS {|| DC_GetWhen(GetList), TabPage8(GetList), ;
                             IIF( !oDoc:setScope(), (DC_ClearEvents(), oTabPage8:disable(), DC_TabActivate(oTabPage1)), Nil) }

  oDoc                := Document():new()
  oDoc:alias          := 'OrdMst'
  oDoc:getList        := GetList
  oDoc:referenceBlock := {|| "Citation " + AllTrim(cTtype) + AllTrim(cCitation) + "  " + AllTrim(cBname) + "  " + AllTrim(cVdesc) }
  oDoc:buildGets( @oTabPage8 )


  DCSETPARENT TO


  DCSTATUSBAR oStatBar  HEIGHT 25  ALIGN DCGUI_ALIGN_BOTTOM  SPACING 0

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			        SIZE 300,20 			                                         PARENT oStatBar ;
                PIXEL OBJECT oMsgStatic

  @  2.00, 2.00 DCMESSAGEBOX TYPE XBPSTATIC_TYPE_TEXT                     SIZE 300,20                                                 PARENT oMsgStatic   COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND ;
                OBJECT oMsgBox  PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			        SIZE 30,20                                                  PARENT oStatBar ;
                PIXEL OBJECT oCapsStatic

  @  1.00, 1.00 DCSAY '' PARENT oCapsStatic ID 'CAPSLOCK' 			        SAYSIZE 28,18     SAYCENTER PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			        SIZE 30,20                                                  PARENT oStatBar ;
                PIXEL OBJECT oNumStatic

  @  1.00, 1.00 DCSAY '' PARENT oNumStatic ID 'NUMLOCK' 			           SAYSIZE 28,18     SAYCENTER PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			        SIZE 30,20                                                  PARENT oStatBar ;
                PIXEL OBJECT oInsStatic

  @  1.00, 1.00 DCSAY '' PARENT oInsStatic ID 'INSERT' 			           SAYSIZE 28,18     SAYCENTER PIXEL


  DCHOTKEY K_INS ACTION {|| ReadInsert(!ReadInsert()) }

  DCGETOPTIONS ;
    CASCADE ;
	 AUTORESIZE ;
	 NOMAXBUTTON ;
    SOURCEFILE __FILEPATH__


  DCREAD GUI ;
         FIT ;
			MODAL ;
         OPTIONS GetOptions ;
         TITLE 'Maintain Citation Information' ;
			EVAL {|o| SetTimerEvent(100,{|| _UpdateStats(GetList)}) }

	SetTimerEvent(0)

RETURN

*---

STATIC FUNCTION CodeAction( nAction, GetList )

  IF nAction == 1 .OR. nAction == 2 .OR. nAction == 5

	 nDollars := 0.00
	 nHours   := 0.00

    SELECT OrdMst
    SET ORDER TO 1
    SEEK cTtype + cCitation
    IF Eof()
      APND()
      IF lSystemData
	     tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Added Citation " + AllTrim(cCitation) + ".")
      ENDIF
	 ELSE
      IF lSystemData
	     tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Updated Citation " + AllTrim(cCitation) + ".")
      ENDIF
    ENDIF
    IF DC_RecLock(5)                                    // Update Record Text
      REPLACE T_Type         WITH cTtype
      REPLACE T_Number       WITH cCitation
      REPLACE RdYr           WITH nRdYr
      REPLACE RdNumber       WITH nRdNumber
      REPLACE RdSuffix       WITH cRdSuffix
      REPLACE RptYr          WITH nRptYr
      REPLACE RptNumber      WITH nRptNumber
      REPLACE T_Date         WITH dTdate
      REPLACE T_Time         WITH TS_TO_MIN(cTtime)
      REPLACE Evidence       WITH lEvidence
      REPLACE CrimeFree      WITH lCrimeFree
      REPLACE EvidCode       WITH cEvidCode
      REPLACE EvidDate       WITH dEvidDate
      REPLACE Location       WITH cLocation
      REPLACE CommonName     WITH cCommonName
      REPLACE Unit           WITH cUnit
      REPLACE Beat           WITH cBeat
		REPLACE V_Alter        WITH nViolation
      REPLACE V_Desc         WITH cVdesc
      REPLACE V_Type         WITH cTypeCode                // Out
      REPLACE V_Chapter      WITH nChapter                 // Out
      REPLACE V_Section      WITH nSection                 // Out
      REPLACE V_ParaGrph     WITH cParaGraph               // Out
      REPLACE Star           WITH nRstar
		REPLACE IdNumber       WITH nIdNumber
      REPLACE C_Name         WITH cComplainant
      REPLACE C_Type         WITH cRespondent
      REPLACE Sex            WITH cSex
      REPLACE Race           WITH cRace
      REPLACE Dob            WITH dDob
      REPLACE Social         WITH cSocial
      REPLACE Dln            WITH cDln
      REPLACE DlnState       WITH cDlnState
      REPLACE B_Name         WITH cBname
      REPLACE M_Address      WITH cBaddress
      REPLACE M_City         WITH cBcity
      REPLACE M_State        WITH cBstate
      REPLACE M_Zip          WITH nBzip
      REPLACE Phone          WITH cPhone
      REPLACE A_Code         WITH cPcode
      REPLACE A_Date         WITH dPdate
      REPLACE H_Date         WITH dHdate
		IF dNewHdate > CtoD('') .AND. dNewHdate > dContinued    // Petition to Set Aside
        REPLACE H_Date       WITH dNewHdate
		ENDIF
		IF dContinued > CtoD('') .AND. dContinued > dNewHdate   // Continuance Date
        REPLACE H_Date       WITH dContinued
		ENDIF
      REPLACE H_Time         WITH TS_TO_MIN(cHtime)
//      REPLACE H_Date2        WITH dHdate2
      REPLACE D_Date         WITH dDuedate
      REPLACE Srv_Code       WITH cSrvCode
      REPLACE CircuitDte     WITH dCircuitDte
      REPLACE X_Code         WITH cXcode
      REPLACE X_Date         WITH dXdate
		REPLACE PayPlan        WITH lPayPlan
      REPLACE Cs_Hrs         WITH nCShrs
      REPLACE Cs_Date        WITH dCSdate
		REPLACE DueAmt         WITH nDueDateAmt
		REPLACE DefaultAmt     WITH nDefaultAmt
      REPLACE F_Amt          WITH nFine
      REPLACE C_Amt          WITH nCosts
		REPLACE Ar_Amt         WITH ((nFine + nCosts) - nDollars)
		REPLACE Ar_Hrs         WITH (nCShrs - nHours)
      REPLACE Liquor         WITH lLiquor
      REPLACE M_Appear       WITH lAppear
      REPLACE O_Appear       WITH lSubpoena
      REPLACE Coll_Date      WITH dCollections
		REPLACE Township       WITH lTownship
		REPLACE Alarms         WITH nAlarms
		REPLACE PgmDate        WITH dTownship
		REPLACE Suspense       WITH lSuspense
		REPLACE MaintUser      WITH M_Officer
		REPLACE MaintDate      WITH Date()
		IF EntryDate == CtoD('')
		  REPLACE EntryDate    WITH Date()
		ENDIF
		UNLOCK

      SELECT MemoDtl
      SET ORDER TO 1
		IF !Empty(cPtext)
        SEEK "A" + cCitation
        IF Eof()
          APND()
        ENDIF
        IF DC_RecLock(5)
          REPLACE MemoKey    WITH "A" + cCitation
          REPLACE MemoText   WITH cPtext
          UNLOCK
        ENDIF
      ENDIF

      SEEK "O" + cCitation
		IF !Empty(cXtext)
        IF Eof()
          APND()
        ENDIF
        IF DC_RecLock(5)
          REPLACE MemoKey    WITH "O" + cCitation
          REPLACE MemoText   WITH cXtext
          UNLOCK
        ENDIF

		  IF dXdate > CtoD('')
		    SEEK "S" + cCitation + DtoS(dXdate)
          IF Eof()
		      APND()
		    ENDIF
		    IF DC_RecLock(5)
            REPLACE MemoKey  WITH "S" + cCitation + DtoS(dXdate)
            REPLACE MemoText WITH cXtext
		      UNLOCK
		    ENDIF
		  ENDIF
		ENDIF

		SELECT DigiMst
      SET ORDER TO 1
      SEEK cTtype + cCitation
	   DO WHILE DigiMst->T_Type == cTtype .AND. DigiMst->T_Number == cCitation .AND. !Eof()
		  IF DC_RecLock(5)
			 DELETE
			 UNLOCK
		  ENDIF
		  DbSkip()
	   ENDDO

		FOR x := 1 TO Len(aFiles)
		  APND()
		  IF DC_RecLock(5)
			 REPLACE T_Type     WITH cTtype
			 REPLACE T_Number   WITH cCitation
			 REPLACE F_Name     WITH aFiles[x]
			 REPLACE F_Desc     WITH aFiles[x]
			 UNLOCK
		  ENDIF
		NEXT

    ENDIF

  ELSEIF nAction == 3                            // Delete Record

    IF Dc_MsgBox( ,, { "Delete " + AllTrim(cTtype) + AllTrim(cCitation) + " Citation ?" }, "Delete Citation",,,.t. )

      SELECT OrdMst                                                         // Master File
      SET ORDER TO 1
      SEEK cTtype + cCitation
      IF !Eof()

        IF lSystemData
	       tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Deleted Citation " + AllTrim(cCitation) + ".")
        ENDIF

        IF DC_RecLock(5)
          DELETE
          UNLOCK
        ENDIF

        SELECT CashMst                                                      // Cash Receipts
        SET ORDER TO 1
        SEEK cTtype + cCitation
	     DO WHILE CashMst->T_Type == cTtype .AND. CashMst->T_Number == cCitation
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
	       DbSkip()
	     ENDDO

        SELECT StatMst                                                      // Status
        SET ORDER TO 1
        SEEK cTtype + cCitation
	     DO WHILE StatMst->T_Type == cTtype .AND. StatMst->T_Number == cCitation
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
	       DbSkip()
	     ENDDO

        SELECT MemoDtl
        SET ORDER TO 1
        SEEK "A" + cCitation                                                // Petition to Set Aside
        IF !Eof()
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
        ENDIF

        SEEK "O" + cCitation                                                // Disposition Orders
        IF !Eof()
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
        ENDIF

        SEEK "C" + cCitation                                                // Comments
	  	  DO WHILE SubStr(MemoKey,1,11) == "C" + cCitation .AND. !Eof()
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
	  		 DbSkip()
        ENDDO

        SEEK "S" + cCitation                                                // Status Comments
	  	  DO WHILE SubStr(MemoKey,1,11) == "S" + cCitation .AND. !Eof()
          IF DC_RecLock(5)
            DELETE
            UNLOCK
          ENDIF
	  		 DbSkip()
        ENDDO

	  	  SELECT DigiMst                                                      // Digital FIles
        SET ORDER TO 1
        SEEK cTtype + cCitation
	     DO WHILE DigiMst->T_Type == cTtype .AND. DigiMst->T_Number == cCitation .AND. !Eof()
	  		 IF DC_RecLock(5)
	  			DELETE
	  			UNLOCK
	  		 ENDIF
	  		 DbSkip()
	     ENDDO

      ENDIF

    ENDIF

  ENDIF

  SELECT StatMst
  SET ORDER TO 1
  SEEK cTtype + cCitation
  IF Eof()
    nStatus      := 0
  ELSE
    nStatus      := 1
  ENDIF

  lNewRec        := .t.
  lNewCash       := .t.
  lNewStat       := .t.
  lNewAssoc      := .t.
  lNewGraphic    := .t.
  lNewComment    := .t.
  lAlarm         := .f.
  lLiquor        := .f.
  lSuspense      := .f.

  cCitation      := Space(10)

  IF nAction <> 5              // Additional Citation(s)
    nRdYr        := 0
    nRdNumber    := 0
    cRdSuffix    := Space(1)
    nRptYr       := 0
    nRptNumber   := 0
    dTdate       := CtoD('')
    cTtime       := Space(5)
    cLocation    := Space(30)
    cCommonName  := Space(30)
    cUnit        := Space(4)
    cBeat        := Space(4)
    cSubBeat     := Space(4)
    nCensus      := 0
    cWatch       := Space(4)
    cWatchDesc   := Space(30)
    cClass       := Space(4)
    cClassDesc   := Space(30)
    cTypeCode    := Space(4)
    nRstar       := 0
	 nIdNumber    := 0
    cRname       := Space(30)
    cKcode       := Space(4)
    cDdesc       := Space(30)  // Department
    nRespondent  := 0
    cComplainant := Space(40)
    cRespondent  := "I"
    cSex         := Space(1)
    cRace        := Space(1)
    dDob         := CtoD('')
    cSocial      := Space(11)
    cDln         := Space(16)
    cDlnState    := Space(2)
    cBname       := Space(40)
    cBaddress    := Space(40)
    cBcity       := Space(25)
    cBstate      := Space(2)
    nBzip        := 0
    cPhone       := Space(13)
    dHdate       := CtoD('')
    cHtime       := Space(5)
    dHdate2      := CtoD('')
    dDuedate     := CtoD('')
    cSrvCode     := Space(4)
    cSrvDesc     := Space(30)
    dCircuitDte  := CtoD('')
    lAppear      := .f.
    lEvidence    := .f.
    lCrimeFree   := .f.
    cEvidCode    := Space(4)
    cEvidDesc    := ""
    dEvidDate    := CtoD('')
    lReceipts    := .f.
    nAlarms      := 0
  ENDIF

  nViolation     := 0
  nChapter       := 0.000
  nSection       := 0
  cParagraph     := Space(6)
  cVdesc         := Space(65)
  cXcode         := Space(4)
  cXdesc         := Space(30)
  cXform         := Space(4)
  dXdate         := CtoD('')
  lConvict       := .f.
  lPayPlan       := .f.
  nCShrs         := 0
  dCSdate        := CtoD('')
  dContinued     := CtoD('')
  nDueDateAmt    := 0.00
  nDefaultAmt    := 0.00
  nFine          := 0.00
  nCosts         := 0.00
  nARamt         := 0.00
  nARhrs         := 0
  lCollection    := .f.
  lSubpoena      := .f.
  lTownship      := .f.
  dTownship      := CtoD('')
  nAlarms        := 0
  nRespondent    := 0

  dPdate         := CtoD('')
  cPcode         := Space(4)
  cPdesc         := Space(30)
  dNewHdate      := CtoD('')
  cPtext         := ''

  nCount         := 0
  nBalAmt        := 0.00
  nBalHrs        := 0
  nHistCount     := 0
  nHistAmt       := 0.00
  nHistHrs       := 0
  nTownCnt       := 0
  nTownBal       := 0

  dRdate         := CtoD('')
  cCheckNo       := Space(25)
  nAmt           := 0.00
  nDollars       := (nFine + nCosts)
  nReceipt       := 0
  nHrs           := 0
  nHours         := nCsHrs
  nAgency        := 0.00
  cAgencyCode    := Space(4)
  cAgencyDesc    := Space(30)
  nWriteOff      := 0.00
  cCashCode      := Space(4)
  cCashDesc      := Space(30)
  nAmnesty       := 0.00
  lBadCheck      := .f.
  dBadCheck      := CtoD('')
  lReceipts      := .f.
  nTransNo       := 0
  nChecks        := 0
  nCheckFee      := 0.00
  nReceiptAmt    := 0.00
  nReceiptHrs    := 0

  dSdate         := CtoD('')
  cScode         := Space(4)
  cSdesc         := Space(30)
  cStext         := ''
  cStatus        := ""
  dCollections   := CtoD('')
  cCurrentStatus := ""

  cXtext         := ''
  lSubpoena      := .f.
  lTownship      := .f.
  dTownship      := CtoD('')
  nAlarms        := 0

  cDeptCode      := Space(4)
  cDeptDesc      := Space(40)
  lStepPct       := .f.
  cFineType      := 'A'
  cClassCode     := ' '
  cClassDesc     := Space(40)
  nMin           := 0.00
  nMax           := 0.00
  nGroup         := 1

  cTicket        := Space(10)
  cSexDesc       := ""
  cRaceDesc      := ""
  dDobDesc       := CtoD('')
  cNameDesc      := ""
  cAssocName     := ""
  cAssocAddr     := ""
  nAssociated    := 0
  nPointer       := 1
  aRemove(aAssociated,1,Len(aAssociated))

  cDirectory     := ''
  cFileName      := Space(75)
  aFiles         := {}

  cCtext         := ''
  dCdate         := CtoD('')

  DC_TabActivate(oTabPage1)

  DC_GetRefresh(GetList)
  SetAppFocus(DC_GetObject(GetList,"Get_cCitation"))

RETURN Nil

*---

STATIC FUNCTION ViolationScan(aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25), cSeek0 := cSeek, cIndex := "CodeDx04", oGet, ;
        bOwnerDraw, cHighlight := Space(10), oFontNormal, oFontLarge, oBitmap, bColorBlock


  SELECT CodeDtl
  SET ORDER TO 4
  SET FILTER TO CodeDtl->V_Alter > 0 .AND. !Empty(CodeDtl->V_Desc)
  DbGoTop()

  cPartial  := Space(30)

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  oFontLarge             := XbpFont():new():create('12.Lucida Console Bold')
  oBitmap                := XbpBitmap():new()
  oBitmap:transparentClr := GraMakeRGBColor({192,192,192})
  oBitmap:create()
  oBitmap:loadFile('\Express\Bitmaps\Forwards.Bmp')

  bOwnerDraw  := {|a,b| DrawCellHighlighted(a,b,AllTrim(cSeek0), oBrowse, oFontLarge, oBitmap) }

  bColorBlock := {|| IIF(Dc_GetColArray(11,oBrowse) =.f., IIF(oBrowse:arrayElement%2 == 0, {Nil, GraMakeRGBColor({220,220,255})}, {Nil, GRA_CLR_WHITE}),{Nil,GRA_CLR_YELLOW}) }


  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  1.00, 1.00 DCSAY "Find: " GET cSeek0  SAYRIGHT  Picture '@!'  GETID 'oSeek' ;
			       GETOBJECT oGet ;
			       GETTOOLTIP 'Example:;  "*PARK" for All Violations;  Containing the Letters "PARK"' ;
                KEYBLOCK {|a,b,o| o:getData(), oBrowse:invalidateRect(), CodeDtl->(_ViolationSeek(a, b, o, oBrowse, GetList, cIndex, @cSeek0)) }

  @  1.25,40.00 DCSAY {|| cPartial }                                                     SAYSIZE 25                                   PARENT oBrowse   COLOR GRA_CLR_RED
  @  1.25,67.50 DCSAY '(enter an "*" before the desired search text to locate a Violation Descriptions containing that text)' ;
                                                                                         SAYSIZE 85                                   PARENT oBrowse   COLOR GRA_CLR_BLUE

  @  2.50, 1.00 DCBROWSE oBrowse ALIAS 'CodeDtl' SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                USEVISUALSTYLE ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
                SUBCLASS "DC_XbpBrowseOwnerDraw()" ;
                ITEMMARKED {|| oBrowse:invalidateRect() } ;
                EVAL {|o| o:ownerDrawBlock := bOwnerDraw } ;
                ITEMSELECTED {|a,b,o| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


  DCBROWSECOL   DATA {|| CodeDtl->V_Alter }                                              HEADER 'Violation;Number'                    WIDTH  7  PARENT oBrowse ;
					 ALIGN 5 ;                                                        // Align Center [horizontal & vertical]
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX12') } LEFTBUTTON

  DCBROWSECOL   DATA {|| CodeDtl->V_Type }                                               HEADER 'Violation;Type'                      WIDTH  6  PARENT oBrowse ;
					 ALIGN 5 ;                                                        // Align Center [horizontal & vertical]
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX01') }  LEFTBUTTON

  DCBROWSECOL   DATA {|| TRANSFORM(CodeDtl->V_Chapter,"9999.999") }                      HEADER 'Chapter;Number'                      WIDTH  6  PARENT oBrowse ;
					 ALIGN 5 ;                                                        // Align Center [horizontal & vertical]
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX02') }  LEFTBUTTON

  DCBROWSECOL   DATA {|| TRANSFORM(CodeDtl->V_Section,"99999") }                         HEADER 'Section;Number'                      WIDTH  6  PARENT oBrowse ;
					 ALIGN 5 ;                                                        // Align Center [horizontal & vertical]
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX14') }  LEFTBUTTON

  DCBROWSECOL   DATA {|| CodeDtl->V_ParaGrph }                                           HEADER 'Paragraph;Number'                    WIDTH  6  PARENT oBrowse ;
					 ALIGN 5 ;                                                        // Align Center [horizontal & vertical]
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX15') }  LEFTBUTTON

  DCBROWSECOL   DATA {|| CodeDtl->Ucr }                                                  HEADER 'UCR;Code'                            WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX16') }  LEFTBUTTON

  DCBROWSECOL   DATA {|| Trim(CodeDtl->V_Desc) }                                         HEADER ';Violation Description'              WIDTH 25  PARENT oBrowse ;
                EVAL {|o| o:drawMode := XBP_DRAW_OWNER } ;
                PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEDX04') }  LEFTBUTTON                           _DEFAULT OrdSetFocus() == 'CODEDX04'

  DCBROWSECOL   DATA {|| OffenseType(CodeDtl->ParkType) }                                HEADER 'Citation;Type'                       WIDTH  7  PARENT oBrowse

  DCBROWSECOL   DATA {|| FineClass(CodeDtl->V_FineType, CodeDtl->V_Class) }              HEADER 'Fine;Classification'                 WIDTH  7  PARENT oBrowse

  DCBROWSECOL   DATA {|| VMIN(CodeDtl->V_FineType, CodeDtl->V_Class, CodeDtl->V_Min) }   HEADER 'Minimum;Fine'                        WIDTH  5  PARENT oBrowse

  DCBROWSECOL   DATA {|| VMAX(CodeDtl->V_FineType, CodeDtl->V_Class, CodeDtl->V_Max) }   HEADER 'Maximum;Fine'                        WIDTH  5  PARENT oBrowse

  DCBROWSECOL   DATA {|| DeptDesc(CodeDtl->V_Dept) }                                     HEADER ';Department'                         WIDTH 12  PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
         EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Select The Desired Violation'

  IF lStatus

    nViolation := CodeDtl->V_Alter
	 cVdesc     := AllTrim(CodeDtl->V_Desc)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cComplainant"))

  ELSE

    SetAppFocus(DC_GetObject(aGetList,"Get_nViolation"))

  ENDIF

  SELECT CodeDtl
  SET FILTER TO

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN nViolation

*---

STATIC FUNCTION DrawCellHighlighted( oPS, aInfo, cHighLight, oBrowse, oFontLarge, oBitmap )

  LOCAL xData, nPos, nRow, aRect, oCell := aInfo[5], oColumn

  IF oCell:isDerivedFrom('DC_MultiLineCellGroup') // It's a header
    RETURN .t.
  ENDIF

  xData   := UPPER(DC_XtoC(aInfo[ XBP_DRAWINFO_AREA ]:getCell( aInfo[ XBP_DRAWINFO_ITEM ] )))

  nRow    := aInfo[1]
  oColumn := oCell:setParent()

//  IF nRow == oBrowse:rowPos
//    oPS:setFont(oFontLarge)
//  ENDIF

  IF SubStr(cHighLight,1,1) == "*"
	 cHighLight := SubStr(cHighLight,2)
  ENDIF

  IF xData <> Nil .AND. ( nPos := At( cHighlight, xData ) ) > 0

     oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] == XBP_DRAWSTATE_SELECTED, ;
                               XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

     GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                                                       aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

     IF nRow == oBrowse:rowPos
       oPS:setColor( GRA_CLR_DARKPINK )
     ELSE
       oPS:setColor( GRA_CLR_RED )
     ENDIF

     IF nPos == 1
       GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                           aInfo[ XBP_DRAWINFO_RECT, 4 ] }, cHighlight )
     ELSE
       aRect := GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

       GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, ;
                           { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, ;
                             cHighlight )
     ENDIF

     RETURN .f.

  ELSE

    oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] == XBP_DRAWSTATE_SELECTED, ;
                              XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

//    IF nRow == oBrowse:rowPos
//      oPS:setColor( GRA_CLR_BLUE )
//    ENDIF

    IF nRow == oBrowse:rowPos .AND. oColumn == oBrowse:getColumn(1)

      aRect := GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

      oBitmap:draw(oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], ;
                          aInfo[ XBP_DRAWINFO_RECT, 2 ] } )

      GraCaptionStr( oPS,{ aInfo[ XBP_DRAWINFO_RECT, 1 ] + oBitmap:xSize + 2, ;
                           aInfo[ XBP_DRAWINFO_RECT, 2 ] }, ;
                         { aInfo[ XBP_DRAWINFO_RECT, 3 ] + oBitmap:xSize + 2, ;
                           aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

    ELSE

      GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], ;
                        { aInfo[ XBP_DRAWINFO_RECT, 3 ], ;
                          aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

    ENDIF

    RETURN .f.

  ENDIF

RETURN .t.

*---

STATIC FUNCTION OffenseType(cOffense)

  DO CASE
	 CASE cOffense == "P"
      cOffenseDesc := "Parking"
	 CASE cOffense == "C"
      cOffenseDesc := "Compliance"
	 CASE cOffense == "O"
      cOffenseDesc := "Ordinance"
	 OTHERWISE
      cOffenseDesc := "Not Defined"
  ENDCASE

RETURN cOffenseDesc

*---

STATIC FUNCTION _ViolationSeek( a, b, o, oBrowse, GetList, cIndex, cSeek0 )

  LOCAL lClearBuffer := .t., lSoftSeek := .t. , aWild := {} , _cSeek
  // Local oCSeek := DC_GetObject(GetList,'ocSeek')

  IF ValType(o) == "C"
    o    := DC_GetObject(GetList,o)
  ENDIF
  _cSeek := o:editbuffer()

  IF a == xbeK_F1 .OR. a == xbeK_F2
    RETURN Nil
  ENDIF

  IF Left(_cSeek,1) == "*" .AND. ValType(cIndex) == "C"
    IF a == xbeK_ENTER
      aWild    := WildSrch(cIndex,_cSeek)
		cPartial := AllTrim(SubStr(cSeek0,2))
      IF Len(aWild) > 0
	     oBrowse:cargo[3] := {1,aWild}
	     dbGoto(oBrowse:cargo[3,2,1])
	     oBrowse:skipBlock     := {|n,oBr| n := SkipRecArray(n,oBr:cargo[3]), dbgoto(oBr:cargo[3,2,oBr:cargo[3,1]]), n}
	     oBrowse:goTopBlock    := {|oBr| oBr:cargo[3,1] := 1, dbgoto(oBr:cargo[3,2,1]), 1 }
	     oBrowse:goBottomBlock := {|oBr| oBr:cargo[3,1] := Len( oBr:cargo[3,2]), dbgoto(oBr:cargo[3,2,oBr:cargo[3,1]]), oBr:cargo[3,1] }
	     oBrowse:posBlock      := {|oBr| oBr:cargo[3,1] }
	     oBrowse:phyPosBlock   := {|oBr| oBr:cargo[3,1] }
	     oBrowse:lastPosBlock  := {|oBr| Len( oBr:cargo[3,2] ) }
	     oBrowse:firstPosBlock := {|| 1 }
	     oBrowse:gotop()
      ENDIF
      cSeek0 := Space(30)
      o:Get:home()
      o:setData()
      oBrowse:refreshall()
      RETURN Nil
	 ELSE
      RETURN Nil
    ENDIF
  ELSE
    cPartial := Space(30)
  ENDIF

  IF a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageup()
  ELSEIF a == xbeK_PGDN
    oBrowse:pagedown()
  ELSEIF a == xbeK_END
    oBrowse:gobottom()
  ELSEIF a == xbeK_HOME
    oBrowse:gotop()
  ELSEIF a == 42
    cSeek0 := "*"+Space(29)
    o:Get:home()
    o:Get:right()
    o:setdata()
    lClearBuffer := .f.
  ELSEIF a == xbeK_ENTER
    DC_ReadGuiEvent(DCGUI_EXIT_OK, GetList)
  ELSE
    lSoftSeek := Set(_SET_SOFTSEEK, .t.)
    IF Len(AllTrim(_cSeek)) == 1
	   oBrowse:skipBlock     := {|n| DbSkipper(n)    }
	   oBrowse:goTopBlock    := {| | DbGoTop()       }
	   oBrowse:goBottomBlock := {| | DbGoBottom()    }
	   oBrowse:phyPosBlock   := {| | Recno()         }
	   oBrowse:posBlock      := {| | DbPosition()    }
	   oBrowse:goPosBlock    := {|n| DbGoPosition(n) }
	   oBrowse:lastPosBlock  := {| | 100             }
	   oBrowse:firstPosBlock := {| | 0               }
	 ENDIF
//    SEEK AllTrim(Strip(_cSeek))
	 SELECT CodeDtl
	 DO CASE
	   CASE OrdNumber() == 2
	     SEEK Str(Val(AllTrim(Strip(_cSeek))),8,3)        // Chapter
	   CASE OrdNumber() == 14
	     SEEK Str(Val(AllTrim(Strip(_cSeek))),5,0)        // Section
	   CASE OrdNumber() == 12
	     SEEK Val(AllTrim(Strip(_cSeek)))                 // Violation Number
		OTHERWISE
      SEEK AllTrim(Strip(_cSeek))
	 ENDCASE
    Set(_SET_SOFTSEEK, lSoftSeek)
    lClearBuffer := .f.
  ENDIF

  IF lClearBuffer
    cSeek0   := Space(30)
//    cPartial := cSeek0
    o:Get:home()
    o:setdata()
  ENDIF

  oBrowse:refreshall()

RETURN Nil

*---

STATIC FUNCTION WildSrch (cNtxFile, cSrchArg, nMaxHits)

  /*
  parameters    :  cNTXFile  : drive:\path\filename.ext
                               (the NTX-File, to be scanned)
                   cSrchArg  : character-string with the search-argument

                   nMaxHits  : If the result-array is as long as <nMaxHits>
                               the function returns.
                               If nMaxHits = Nil, nMaxHits is set to 10000
                               (Array is full..)

  returns       :  aResult   : an array with the record-numbers who
                               matched <cSrchArg>
  */


  // Search Result
  LOCAL aResult   := {}                // array to hold the record-numbers

  // For Low-Level-Services
  LOCAL nBlock    := 1024              // Size of each index-page
  LOCAL cBuffer   := Space(nBlock)     // Buffer for FREAD
  LOCAL nHandle   := -1                // file-handle
  LOCAL nLen      := 0                 // length of index-file
  LOCAL nPages    := 0                 // index-pages (excl. header)


  // Index-Header (offset from 0, SubStr from 1 -> always (+1) )
  LOCAL nPtrItemSize   := 13           // h0C -> Pointer to ItemSize (keysize+8)
  LOCAL nPtrKeySize    := 15           // h0E -> Pointer to KeySize
  LOCAL nPtrMaxItem    := 19           // h12 -> Pointer to max. items on each page

  LOCAL nLenItem       := 0            // length of each item
  LOCAL nLenKey        := 0            // length of each key
  LOCAL nItemMax       := 0            // max. items on each page

  // IndexPage   (offset from 0, SubStr form 1 -> always (+1) )
  LOCAL nPtrItemPage   := 1            // h00 -> Pointer to Items on this page

  LOCAL nItemCnt       := 0            // items on this page

  LOCAL x := 0, y := 0                 // FOR-loop indices
  LOCAL nPtrItem       := 0            // pointer to current item
  LOCAL nItemOffset    := 0            // offset of current item
  LOCAL cKey           := ""           // key-value of current item
  LOCAL nRecord        := 0            // recno of current item (inside the DBF-File)

  // Check nMaxHits and Set Break
  LOCAL lBreak := .f.                  // Break-Condition
  LOCAL cSrch1 := " ", cSrch2 := " ", cSrch3 := " "
  LOCAL nPos1  := 1,   nPos2  := 0,   nPos3  := 0

  cSrchArg   := AllTrim(Strip(cSrchArg))
  cSrch1     := SubStr(cSrchArg,2)
  nPos2      := AT("*",cSrch1)
  IF nPos2 > 0
    cSrch2   := SubStr(cSrch1,nPos2+1)
    cSrch1   := SubStr(cSrch1,1,nPos2-1)
    nPos3    := AT("*",cSrch2)
    IF nPos3 > 0
      cSrch3 := SubStr(cSrch2,nPos3+1)
      cSrch2 := SubStr(cSrch2,1,nPos3-1)
    ENDIF
  ENDIF

  nMaxHits := IF(nMaxHits==Nil,10000,nMaxHits)

  cNtxFile += ".Ntx"

  // Let's do..

  // FileOpen

  nHandle := FOPEN("\_Psst\Cm\" + cNtxFile, FO_READ + FO_SHARED)

  IF FError() <> 0
    Dc_Alert("Error opening the file:" + Str(FError()))
  ENDIF

  // Calculate how many pages excl. header-page

  nLen   := FSEEK(nHandle, 0, FS_END)
  nPages := INT(nLen/nBlock) - 1
  FSEEK(nHandle,0)

  // Read Header and get some information

  FREAD(nHandle, @cBuffer, nBlock )

  nLenItem := BIN2W( SubStr(cBuffer,nPtrItemSize,2) )
  nLenKey  := BIN2W( SubStr(cBuffer,nPtrKeySize,2) )
  nItemMax := BIN2W( SubStr(cBuffer,nPtrMaxItem,2) )

  //Now Read all Index-Pages and check for Search-Value

  FOR x := 1 to nPages

    FREAD(nHandle, @cBuffer, nBlock)

    // check how many items on this page
    nItemCnt := BIN2W( SubStr(cBuffer, nPtrItemPage, 2) )

    // check all items on this page
    FOR y := 1 TO nItemCnt

      // Page-Offset to read Item-Offset
      nPtrItem := (y*2)+1

      // Read Item-Offset
      nItemOffset := BIN2W( SubStr(cBuffer, nPtrItem, 2) ) + 1

      // Check current item
      cKey := SubStr(cBuffer, nItemOffset+8, nLenKey)
      IF AT(cSrch1, cKey) != 0 .AND. AT(cSrch2,cKey) != 0 .AND. AT(cSrch3,cKey) != 0
        // Read recno from index-page (beginning at <nItemOffset+4>)
        nRecord := BIN2L( SubStr(cBuffer, nItemOffset+4, 4) )
        // Add recno to result-array
        AAdd(aResult, nRecord)

        // Check nMaxHits
        IF Len(aResult) >= nMaxHits
          lBreak := .t.
          EXIT
        ENDIF

      ENDIF

    NEXT y

    IF lBreak
      EXIT
    ENDIF

  NEXT x

  // close NTX-File
  FCLOSE(nHandle)

RETURN(aResult)

*---

STATIC FUNCTION SkipRecArray( nWantSkip, aCargo )

  LOCAL nDidSkip, nLastRec := Len( aCargo[2] )

  IF aCargo[1] + nWantSkip < 1              // "BoF"
    nDidSkip := 1 - aCargo[1]
  ELSEIF aCargo[1] + nWantSkip > nLastRec   // "EoF"
    nDidSkip := nLastRec - aCargo[1]
  ELSE
    nDidSkip := nWantSkip
  ENDIF
  aCargo[1]  += nDidSkip

RETURN nDidSkip



STATIC FUNCTION Strip(te_strippen)

  LOCAL cGestript := ""
  LOCAL nLengte   := Len(te_Strippen)
  LOCAL y         := Len(AllTrim(te_strippen))
  LOCAL x         := 0 , cChar := ""

  FOR x := 1 to y
    cChar := SubStr(te_Strippen,x,1)
    IF !(cChar $ " ',/.")
      cGestript += cChar
    ENDIF
  NEXT
RETURN SubStr(cGestript + Space(250),1,nLengte)

*---

STATIC FUNCTION ValidateViolation( nViolation, GetList )

  SELECT CodeDtl
  SET ORDER TO 12
  SEEK nViolation

  IF Eof()

	 lError            := .f.
	 cVdesc            := ""
    DC_GetRefresh(GetList)
    SetAppFocus(DC_GetObject(GetList,"Get_nViolation"))

  ELSE

	 lError            := .t.

	 IF lNewRec
	   IF CodeDtl->M_Appear
		  lAppear       := .t.
	   ELSE
	     lAppear       := .f.
	     IF dDueDate == CtoD('') .AND. lDueDate
	       dDueDate    := (dTdate + nDueDays)
        ENDIF
	   ENDIF
    ENDIF
	 cTypeCode         := CodeDtl->V_Type
	 nChapter          := CodeDtl->V_Chapter
	 nSection          := CodeDtl->V_Section
	 cParaGraph        := CodeDtl->V_ParaGrph
	 cVdesc            := AllTrim(CodeDtl->V_Desc)
	 lAlarm            := CodeDtl->Alarm
	 lLiquor           := CodeDtl->Liquor
    IF lNewRec .AND. nFine == 0.00
      IF CodeDtl->V_FineType == "A" .OR. Empty(CodeDtl->V_FineType) .OR. Empty(CodeDtl->V_Class)
	     nFine         := CodeDtl->V_Min
	     nDueDateAmt   := CodeDtl->V_DueDate
	     nDefaultAmt   := CodeDtl->V_Default
	   ELSE
        SELECT CodeMst
        SET ORDER TO 6
        SET SOFTSEEK ON
        SEEK "FE" + CodeDtl->V_Class  + DtoS(Date())
        SET SOFTSEEK OFF
        IF CodeMst->CmCode <> CodeDtl->V_Class .OR. Eof()
  	 	 	 DbSkip(-1)
          IF CodeMst->CmCode <> CodeDtl->V_Class .OR. Eof()
            SET ORDER TO 1
            SEEK "FE" + CodeDtl->V_Class
          ENDIF
        ENDIF
		  IF Eof()
	       nFine       := CodeDtl->V_Min
	       nDueDateAmt := CodeDtl->V_DueDate
	       nDefaultAmt := CodeDtl->V_Default
		  ELSE
			 IF Val(SubStr(CodeMst->CmText2, 1,10)) > 0.00
	         nFine     := Val(SubStr(CodeMst->CmText2, 1,10))
			 ELSE
	         nFine     := CodeMst->CmLow
			 ENDIF
	       nDueDateAmt := Val(SubStr(CodeMst->CmText2,11,10))
	       nDefaultAmt := Val(SubStr(CodeMst->CmText2,21,10))
	     ENDIF
	   ENDIF
	 ENDIF

    DC_GetRefresh(GetList)
    SetAppFocus(DC_GetObject(GetList,"Get_cComplainant"))
  ENDIF

RETURN lError

*---

STATIC FUNCTION AmendViolation( _Tnumber, _nViolation, _cType, _nChapter, _nSection, _cParagrph, GetList )

  ViolationScan(_Tnumber, _nViolation, _cType, _nChapter, _nSection, _cParagrph, GetList)

RETURN Nil

*---

STATIC FUNCTION FineClass(cFineType, cClassCode)

  LOCAL nSelect, nOrder

  nSelect        := SELECT()
  nOrder         := OrdNumber()

  IF Empty(cFineType)
	 cFineType    := "A"
  ENDIF

  IF cFineType == "C"
    SELECT CodeMst
    SET ORDER TO 1
    SEEK "FE" + cClassCode
    IF Eof()
      cClassDesc := cClassCode
    ELSE
      cClassDesc := AllTrim(CodeMst->CmDesc)
    ENDIF
  ELSE
    cClassDesc   := "Fixed Amount"
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN cClassDesc

*---

STATIC FUNCTION VMIN(cFineType, cClassCode, nVmin)

  LOCAL nSelect, nOrder

  nSelect     := SELECT()
  nOrder      := OrdNumber()

  IF Empty(cFineType)
	 cFineType := "A"
  ENDIF

  IF cFineType == "C"
    SELECT CodeMst
    SET ORDER TO 6
    SET SOFTSEEK ON
    SEEK "FE" + cClassCode + DtoS(Date())
    SET SOFTSEEK OFF
    IF CodeMst->CmCode <> cClassCode .OR. Eof()
  	 	DbSkip(-1)
      IF CodeMst->CmCode <> cClassCode .OR. Eof()
        SET ORDER TO 1
        SEEK "FE" + cClassCode
      ENDIF
    ENDIF
    IF Eof()
      nVmin   := nVmin
    ELSE
      nVmin   := CodeMst->CmLow
    ENDIF
  ELSE
    nVmin     := CodeDtl->V_Min
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN nVmin

*---

STATIC FUNCTION VMAX(cFineType, cClassCode, nVmax)

  LOCAL nSelect, nOrder

  nSelect     := SELECT()
  nOrder      := OrdNumber()

  IF Empty(cFineType)
	 cFineType := "A"
  ENDIF

  IF cFineType == "C"
    SELECT CodeMst
    SET ORDER TO 6
    SET SOFTSEEK ON
    SEEK "FE" + cClassCode + DtoS(Date())
    SET SOFTSEEK OFF
    IF CodeMst->CmCode <> cClassCode .OR. Eof()
  	 	DbSkip(-1)
      IF CodeMst->CmCode <> cClassCode .OR. Eof()
        SET ORDER TO 1
        SEEK "FE" + cClassCode
      ENDIF
    ENDIF
    IF Eof()
      nVmax   := nVmax
    ELSE
      nVmax   := CodeMst->CmHigh
    ENDIF
  ELSE
    nVmax     := CodeDtl->V_Max
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN nVmax

*---

STATIC FUNCTION GuiDeptScan(c, cRecid, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,cRecid))
  CodeMst->(DC_SetScope(1,cRecid))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,cRecid))
  CodeMst->(DC_SetScope(1,cRecid))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 60,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }           HEADER 'Department;Code'                       WIDTH  7  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }  HEADER ';Department Description'               WIDTH 25  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Department Code'


  IF lStatus

    cDeptCode := CodeMst->CmCode
    cDeptDesc := AllTrim(CodeMst->CmDesc)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_nChapter"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cTypeCode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cDeptCode

*---

STATIC FUNCTION CitationScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25), bColor

  SELECT OrdMst
  SET ORDER TO 16
  DbGotop()

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  bColor    := {|| IIF(Empty(OrdMst->X_Code) , { GRA_CLR_RED, Nil }, { GRA_CLR_GREEN, Nil }) }

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  1.00, 1.00 DCGET cSeek            Picture '@!' 		                      KEYBLOCK {|a,b,o| _Mvp110(a,b,o, oBrowse, @cSeek) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse ALIAS 'OrdMst' SIZE 50,20 ;
  			       FIT ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| OrdMst->T_Number }                                                                  HEADER 'Citation;Number'         WIDTH  6  PARENT oBrowse  COLOR bColor ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx16')} LEFTBUTTON  _DEFAULT OrdSetFocus() == 'OrdMx16' ;
				    DATATOOLTIP {|| .t. }  TIPBLOCK {|| CitationStatus() }

  DCBROWSECOL   DATA {|| Rd() }                                                                              HEADER 'Incident;Number'         WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx02')} LEFTBUTTON

  DCBROWSECOL   DATA {|| OrdMst->T_Date }                                                                    HEADER 'Issue;Date'              WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx11')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| MIN_TO_AMPM(OrdMst->T_Time)}                                                       HEADER 'Issue;Time'              WIDTH  5  PARENT oBrowse

  DCBROWSECOL   DATA  {|| AllTrim(OrdMst->Location) }                                                        HEADER ';Location'               WIDTH 13  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx12')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| AllTrim(OrdMst->CommonName) }                                                      HEADER ';Common Name'            WIDTH 13  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx25')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| AllTrim(OrdMst->B_Name) }                                                          HEADER ';Respondent Name'        WIDTH 13  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx05')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| AllTrim(OrdMst->C_Name) }                                                          HEADER ';Complainant Name'       WIDTH 13  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx06')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| AllTrim(OrdMst->V_Desc) }                                                          HEADER ';Violation Description'  WIDTH 19  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx28')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| OrdMst->H_Date }                                                                   HEADER 'Hearing;Date'            WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('OrdMx14')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| MIN_TO_AMPM(OrdMst->H_Time) }                                                      HEADER 'Hearing;Time'            WIDTH  5  PARENT oBrowse


  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Select Desired Citation' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    nGroup    := 2
    cCitation := OrdMst->T_Number
	 ValidateCitation(cCitation, aGetList)
    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_nRdYr"))

  ELSE

    nGroup    := 1
    cCitation := Space(10)
    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cCitation"))

  ENDIF

RETURN cCitation

*---

STATIC FUNCTION _Mvp110( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP       // Up
    oBrowse:up()
  ELSEIF a == xbeK_DOWN     // Down
    oBrowse:down()
  ELSEIF a == xbeK_PGUP     // PageUp
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN     // PageDown
    oBrowse:pageDown()
  ELSEIF a == xbeK_END      // End
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME     // Home
    oBrowse:goTop()
  ELSE                      // Seek
    SEEK AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(25)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK, lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION CitationStatus()

  LOCAL cStatus, nSelect

  cStatus          := Nil
  nSelect          := SELECT()

  IF !Empty(OrdMst->X_Code)
	 IF OrdMst->Coll_Date > CtoD('') .AND. OrdMst->Ar_Amt > 0.00
		dCollections := OrdMst->Coll_Date
      cStatus      := "In Collections"
	 ELSE
		dCollections := CtoD('')
      SELECT CodeMst
      SET ORDER TO 1
      SEEK "F2" + OrdMst->X_Code
      IF Eof()
        cStatus    := AllTrim(OrdMst->X_Code)
      ELSE
        cStatus    := AllTrim(CodeMst->CmDesc)
      ENDIF
	 ENDIF
  ELSE
	 cStatus        := "Open Citation"
  ENDIF

  cStatus          := cStatus + ";" + ;
				       	  "Fine    : " + Ltrim(Transform(OrdMst->F_Amt,"99,999.99")) + ";" + ;
				       	  "Costs   : " + Ltrim(Transform(OrdMst->C_Amt,"99,999.99")) + ";" + ;
				       	  "Payment : " + Ltrim(Transform((OrdMst->F_Amt + OrdMst->C_Amt) - OrdMst->Ar_Amt,"99,999.99")) + ";" + ;
				       	  "Balance : " + Ltrim(Transform(OrdMst->Ar_Amt,"99,999.99")) + ;
				       	  "          " + ";" + ;
				       	  "C/S Hours " + Ltrim(Transform(OrdMst->Cs_Hrs,"99,999")) + ";" + ;
				       	  "Performed " + Ltrim(Transform(OrdMst->Cs_Hrs - OrdMst->Ar_Hrs,"99,999")) + ";" + ;
				       	  "C/S Due   " + Ltrim(Transform(OrdMst->Ar_Hrs,"99,999"))


  SELECT (nSelect)

RETURN cStatus

*---

STATIC FUNCTION AssociatedStatus()

  LOCAL cStatus, nSelect

  cStatus       := Nil
  nSelect       := SELECT()

  IF !Empty(aAssociated[6])
	 IF aAssociated[12] > CtoD('') .AND. aAssociated[9] > 0.00
      cStatus   := "In Collections"
	 ELSE
      SELECT CodeMst
      SET ORDER TO 1
      SEEK "F2" + aAssociated[6]
      IF Eof()
        cStatus := AllTrim(aAssociated[6])
      ELSE
        cStatus := AllTrim(CodeMst->CmDesc)
      ENDIF
	 ENDIF
  ELSE
	 cStatus     := "Open Citation"
  ENDIF

  cStatus       := cStatus + ";" + ;
				    	  "Fine    : " + Ltrim(Transform(aAssociated[7],"99,999.99")) + ";" + ;
				    	  "Costs   : " + Ltrim(Transform(aAssociated[8],"99,999.99")) + ";" + ;
				    	  "Payment : " + Ltrim(Transform((aAssociated[7] + aAssociated[8]) - aAssociated[9],"99,999.99")) + ";" + ;
				    	  "Balance : " + Ltrim(Transform(OrdMst->Ar_Amt,"99,999.99")) + ;
				    	  "          " + ";" + ;
				    	  "C/S Hours " + Ltrim(Transform(aAssociated[10],"99,999")) + ";" + ;
				    	  "Performed " + Ltrim(Transform(aAssociated[10] - aAssociated[11],"99,999")) + ";" + ;
				    	  "C/S Due   " + Ltrim(Transform(aAssociated[11],"99,999"))


  SELECT (nSelect)

RETURN cStatus

*---

STATIC FUNCTION Rd()

  LOCAL cRd

  IF OrdMst->RdNumber > 0
    cRd := StrZero(OrdMst->RdYr,2,0) + "-" + AllTrim(TRANSFORM(OrdMst->RdNumber,"999999"))
  ELSE
    cRd := Nil
  ENDIF

RETURN cRd

*---

STATIC FUNCTION DisplayRD(cTicket)

  cRd := SubStr(Str(Year(Date()),4,0),1,2) + TRANSFORM(OrdMst->RdYr,"99") + "-" + AllTrim(TRANSFORM(OrdMst->RdNumber,"999999"))

RETURN(cRD)

*---

STATIC FUNCTION ViolationDesc()

  LOCAL nSelect, nOrder

  nSelect  := SELECT()
  nOrder   := OrdNumber()

  SELECT CodeDtl
  SET ORDER TO 12
  SEEK OrdMst->V_Alter
  IF Eof()
    cVdesc := Str(OrdMst->V_Alter,8,0)
  ELSE
    cVdesc := AllTrim(CodeDtl->V_Desc)
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cVdesc)

*---

STATIC FUNCTION ValidateCitation(cCitation, GetList)

//  cCitation := StrZero(nCitation,8,0)
  IF lSystemData
    tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Access of Citation " + AllTrim(cCitation) + ".")
  ENDIF

  SELECT OrdMst
  SET ORDER TO 1
  SEEK cTtype + cCitation
  IF Eof()
	 SELECT RcptMst
	 SET ORDER TO 6
	 SET SOFTSEEK ON
    SEEK cTtype + StrZero(Val(cCitation),10,0)
	 SET SOFTSEEK OFF
	 IF RcptMst->T_Type == cTtype .AND. Val(cCitation) >= Val(RcptMst->F_Number) .AND. Val(cCitation) <= Val(RcptMst->T_Number)
		nRstar           := RcptMst->Officer
      nIdNumber        := RcptMst->IdNumber
		IF nIdNumber == 0
        SELECT PersMst
        SET ORDER TO 1
        SEEK nRstar
        IF Eof()
          cKcode       := Space(4)
          cDcode       := Space(4)
          cRname       := Space(30)
		    nIdNumber    := 0
		  ELSE
          cKcode       := PersMst->K_Code
          cDcode       := PersMst->D_Code
		    nIdNumber    := PersMst->IdNumber
          IF PersMst->O_Middle > ""
            cRname     := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First) + " " + AllTrim(PersMst->O_Middle) + "."
          ELSE
            cRname     := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First)
          ENDIF
	     ENDIF
	   ENDIF
	 ENDIF
    lNewRec            := .t.                          // New Record
  ELSE
    lNewRec            := .f.                          // Record Exists
    nRdYr              := OrdMst->RdYr
    nRdNumber          := OrdMst->RdNumber
    cRdSuffix          := OrdMst->RdSuffix
    dTdate             := OrdMst->T_Date
    cTtime             := MIN_TO_TS(OrdMst->T_Time)
    cLocation          := OrdMst->Location
    cUnit              := OrdMst->Unit
    cCommonName        := OrdMst->CommonName
    cBeat              := OrdMst->Beat
    nViolation         := OrdMst->V_Alter
    nRstar             := OrdMst->Star
	 nIdNumber          := OrdMst->IdNumber
    cComplainant       := OrdMst->C_Name
    cRespondent        := OrdMst->C_Type
    cSex               := OrdMst->Sex
    cRace              := OrdMst->Race
    dDob               := OrdMst->Dob
    cSocial            := OrdMst->Social
    cDln               := OrdMst->Dln
    cDlnState          := OrdMst->DlnState
    cBname             := OrdMst->B_Name
    cBaddress          := OrdMst->M_Address
    cBcity             := OrdMst->M_City
    cBstate            := OrdMst->M_State
    nBzip              := OrdMst->M_Zip
    cPhone             := OrdMst->Phone
    dHdate             := OrdMst->H_Date
    cHtime             := MIN_TO_TS(OrdMst->H_Time)
    dDuedate           := OrdMst->D_Date
    cSrvCode           := OrdMst->Srv_Code
    dCircuitDte        := OrdMst->CircuitDte
    lAppear            := OrdMst->M_Appear
    lEvidence          := OrdMst->Evidence
    lCrimeFree         := OrdMst->CrimeFree
    lSuspense          := OrdMst->Suspense
    cEvidCode          := OrdMst->EvidCode
    dEvidDate          := OrdMst->EvidDate

	 dPdate             := OrdMst->A_Date                 // Petition
	 cPcode             := OrdMst->A_Code
	 dNewHdate          := OrdMst->H_Date

	 dXdate             := OrdMst->X_Date                 // Disposition
	 cXcode             := OrdMst->X_Code
	 dCSdate            := OrdMst->Cs_Date
	 dContinued         := OrdMst->H_Date
	 lPayPlan           := OrdMst->PayPlan
	 nFine              := OrdMst->F_Amt
	 nCSHrs             := OrdMst->Cs_Hrs
    lSubpoena          := OrdMst->O_Appear
	 lTownship          := OrdMst->Township
	 dTownship          := OrdMst->PgmDate
	 nCosts             := OrdMst->C_Amt
	 nAlarms            := OrdMst->Alarms

	 IF OrdMst->Coll_Date > CtoD('') .AND. OrdMst->Ar_Amt > 0.00
		lCollection      := .t.
		dCollections     := OrdMst->Coll_Date
	 ELSE
		lCollection      := .f.
		dCollections     := CtoD('')
	 ENDIF

	 IF Empty(OrdMst->MaintDate)
	   cMaintInfo       := ""
	 ELSE
	   cMaintInfo       := "Last Maintained " + DtoC(OrdMst->MaintDate) + " by " + LTRIM(TRANSFORM(OrdMst->MaintUser,"9999"))
	 ENDIF

	 nRespondent        := RespondentCount(GetList)
    History(GetList)

	 SELECT MemoDtl                                 // Petition Text
	 SET ORDER TO 1
	 SEEK "A" + cCitation
	 IF Eof()
	   cPtext           := ""
	 ELSE
	   cPtext           := MemoDtl->MemoText
	 ENDIF
	 SEEK "O" + cCitation
	 IF Eof()
	   cXtext           := ""
	 ELSE
	   cXtext           := MemoDtl->MemoText
	 ENDIF

	 aFiles             := {}
	 SELECT DigiMst
	 SET ORDER TO 1
    SEEK cTtype + cCitation
	 DO WHILE DigiMst->T_Type == cTtype .AND. DigiMst->T_Number == cCitation .AND. !Eof()
      AAdd(aFiles, DigiMst->F_Name)
		DbSkip()
	 ENDDO

    SELECT CodeDtl
    SET ORDER TO 12
    SEEK nViolation
    IF Eof()
      cTypeCode        := Space(4)
      nChapter         := 0.000
      nSection         := 0
      cParagraph       := Space(6)
      nV_min           := 0.00
      nV_max           := 0.00
      cVdesc           := "[" + AllTrim(Str(nViolation,8,0)) + "] - Missing."
		lAlarm           := .f.
		lLiquor          := .f.
    ELSE
      cTypeCode        := CodeDtl->V_Type
      nChapter         := CodeDtl->V_Chapter
      nSection         := CodeDtl->V_Section
      cParagraph       := CodeDtl->V_Paragrph
      nV_min           := CodeDtl->V_Min
      nV_max           := CodeDtl->V_Max
      cVdesc           := AllTrim(CodeDtl->V_Desc)
		lAlarm           := CodeDtl->Alarm
		lLiquor          := CodeDtl->Liquor
    ENDIF

    SELECT PersMst
	 IF nIdNumber > 0
	   SET ORDER TO 5
      SEEK nIdNumber
      IF Eof()
        cKcode         := Space(4)
        cDcode         := Space(4)
        cRname         := Space(30)
      ELSE
        cKcode         := PersMst->K_Code
        cDcode         := PersMst->D_Code
        IF PersMst->O_Middle > ""
          cRname       := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First) + " " + AllTrim(PersMst->O_Middle) + "."
        ELSE
          cRname       := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First)
        ENDIF
      ENDIF
	 ELSE
	   SET ORDER TO 6
      SEEK Str(nRstar,4,0)
      IF Eof()
        cKcode         := Space(4)
        cDcode         := Space(4)
        cRname         := Space(30)
      ELSE
        cKcode         := PersMst->K_Code
        cDcode         := PersMst->D_Code
        IF PersMst->O_Middle > ""
          cRname       := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First) + " " + AllTrim(PersMst->O_Middle) + "."
        ELSE
          cRname       := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First)
        ENDIF
      ENDIF
    ENDIF

    SELECT CashMst
    SET ORDER TO 1
    SEEK cTtype + cCitation
 	 lReceipts          := .f.
    nChecks            := 0
    nCheckFee          := 0.00
    nReceiptHrs        := nCShrs
    nReceiptAmt        := (nFine + nCosts)
	 DO WHILE CashMst->T_Type == cTtype .AND. CashMst->T_Number == cCitation .AND. !Eof()
		lReceipts   := .t.
		IF CashMst->BadCheck
        nChecks++
        nCheckFee      += CashMst->CheckFee
        nReceiptAmt    += CashMst->CheckFee
		ELSE
        nReceiptHrs    -= CashMst->R_Hours
        nReceiptAmt    -= (CashMst->R_Amt + CashMst->A_Amt + CashMst->W_Amt + CashMst->Amnesty)
		ENDIF
      DbSkip()
    ENDDO

    SELECT StatMst
    SET ORDER TO 3
	 SET SOFTSEEK ON
    SEEK cTtype + cCitation + DESCEND(DtoS(Date()))
	 SET SOFTSEEK OFF
	 IF StatMst->T_Type == cTtype .AND. StatMst->T_Number == cCitation .AND. !Eof()
      nStatus          := 1
		SELECT CodeMst
		SET ORDER TO 1
		SEEK "F7" + StatMst->S_Code
		IF Eof()
		  cCurrentStatus := ""
		ELSE
		  cCurrentStatus := AllTrim(CodeMst->CmDesc)
		ENDIF
	 ELSE
      nStatus          := 0
		cCurrentStatus   := ""
	 ENDIF

    SELECT CodeMst
    SET ORDER TO 1
    SEEK "F4" + cSrvCode                      // Service Type
    IF Eof()
      cSrvDesc         := Space(30)
    ELSE
      cSrvDesc         := AllTrim(CodeMst->CmDesc)
    ENDIF
    SEEK "08" + cTypeCode                     // Violation Type Code
    IF Eof()
      cTypeDesc        := Space(30)
    ELSE
      cTypeDesc        := AllTrim(CodeMst->CmDesc)
    ENDIF
	 SEEK "F2" + cXcode                        // Disposition Order
	 IF Eof()
      cXform           := Space(4)
	   cXdesc           := Space(30)
	   lConvict         := .f.
    ELSE
      cXform           := CodeMst->CmLink
      cXdesc           := AllTrim(CodeMst->CmDesc)
	   lConvict         := CodeMst->CmCalc
	 ENDIF
	 SEEK "F0" + cDcode                        // Department
	 IF Eof()
	   cDdesc           := Space(30)
    ELSE
      cDdesc           := AllTrim(CodeMst->CmDesc)
	 ENDIF
	 SEEK "F9" + cPcode                        // Petition to Set Aside
	 IF Eof()
	   cPdesc           := Space(30)
    ELSE
      cPdesc           := AllTrim(CodeMst->CmDesc)
	 ENDIF

	 nComplainant       := 0
	 SELECT CompDtl
	 SET ORDER TO 1
    SEEK cTtype + cCitation
	 DO WHILE CompDtl->T_Type == cTtype .AND. CompDtl->T_Number == cCitation .AND. !Eof()
		nComplainant++
	   DbSkip()
	 ENDDO

	 SELECT LocMst
	 SET ORDER TO 2
	 SEEK TRIM(UPPER(cLocation))
	 IF Eof()
		SET ORDER TO 1
		SEEK TRIM(UPPER(cLocation))
		IF Eof()
		  cCommonName    := Space(30)
		ELSE
		  cCommonName    := LocMst->Name
		ENDIF
	 ELSE
		cCommonName      := LocMst->Name
	 ENDIF

    ValidateRdNumber(nRdYr, nRdNumber, GetList)

  ENDIF

  nGroup := 2
  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION ValidateRdNumber(nRdYr, nRdNumber, GetList)

  IF nRdNumber > 0
    SELECT AltOrdMst
    SET ORDER TO 2
    SEEK Str(nRdYr,2,0) + Str(nRdNumber,6,0)
    DO WHILE AltOrdMst->RdYr == nRdYr .AND. AltOrdMst->RdNumber == nRdNumber .AND. !Eof()
  	 	IF AltOrdMst->T_Number <> cCitation
        nAssociated++
//                                           1               2                3               4                  5                  6                 7                 8                  9                 10                 11
	 	  AAdd(aAssociated, {AltOrdMst->T_Number, AltOrdMst->Sex, AltOrdMst->Race, AltOrdMst->Dob, AltOrdMst->B_Name, AltOrdMst->X_Code, AltOrdMst->F_Amt, AltOrdMst->C_Amt, AltOrdMst->Ar_Amt, AltOrdMst->Cs_Hrs, AltOrdMst->Ar_Hrs} )
  	 	ENDIF
  	 	DbSkip()
    ENDDO
  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION LocationScan(c, aGetList)

  LOCAL GetList := {}, GetOptions, lStatus, aFields, aPres, aSort[6], aSaveSort, bEval

  PRIVATE i

  SELECT LocMst
  DbGotop()

  aSort[1]  := GRA_CLR_WHITE       // Sort Selected Color (Foreground)
  aSort[2]  := GRA_CLR_BLUE        // Sort Selected Color (Background)
  aSort[3]  := GRA_CLR_WHITE       // Sort Unselected Color (Foreground)
  aSort[4]  := GRA_CLR_DARKGRAY    // Sort Unselected Color (Background)
  aSort[5]  := BITMAP_RD_UP_RED    // Sort UP Bitmap
  aSort[6]  := BITMAP_RD_DOWN_RED  // Sort DOWN Bitmap

  aSaveSort := DC_FindBrowseSort(aSort)

  aPres     := { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE    }, ;
                 { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
                 { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK    }, ;
                 { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE    }, ;
                 { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER} }       /* Header Alignment */  ;

  aFields   := { ; // field                           Header                        Width  Index      Prompt
               { {|| LocMst->Address},               ';Address',                       17, 'LocMx01', 'Address' }, ;
               { {|| LocMst->Name},                  ';Associated Name',               17, 'LocMx02', 'Name Associated' }, ;
               { {|| LocMst->Beat},                  'Beat;Number',                     4, 'LocMx03', 'Beat Assignment' }, ;
               { {|| LocMst->SubBeat},               'Sub-Beat;Number',                 4, 'LocMx04', 'Sub-Beat Assignment' }, ;
               { {|| LocMst->Census},                'Census;Tract',                    5, 'LocMx07', 'Census Tract' }, ;
               { {|| LocMst->W_Code},                'Neighborhood;Watch',              7, 'LocMx06', 'Neighborhood Watch Area' }, ;
               { {|| LocationDesc()},                ';Location Classification',       15, 'LocMx05', 'Location Classification' } ;
               }

  bEval     := {|o| o:drawingArea:setColorBG(GRA_CLR_BACKGROUND) }

  lStatus   := DC_AutoFind( aFields, Nil, Nil, Nil, 152.2, 20.2, ;
                            'Location Master File Review', ;
                            .t., Nil, Nil, Nil, Nil, bEval, ;
                            { aPres, { GRA_CLR_DARKGRAY, GRA_CLR_CYAN } }, ;
                            .f., Nil, Nil, .01, Nil, .f., Nil )

  DC_FindBrowseSort(aSaveSort)

  IF lStatus

    cLocation   := LocMst->Address
    cBeat       := LocMst->Beat
    cCommonName := LocMst->Name
	 ValidateAddress(cLocation, aGetList)
    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cUnit"))

  ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cLocation"))

  ENDIF

RETURN cLocation

*---

STATIC FUNCTION LocationDesc

  LOCAL nSelect, nOrder

  nSelect      := SELECT()
  nOrder       := OrdNumber()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F1" + LocMst->L_Code
  IF Eof()
    cClassDesc := ""
  ELSE
    cClassDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cClassDesc)

*---

STATIC FUNCTION ComplainantScan(c, aGetList)

  LOCAL GetList := {}, GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25)

  SELECT OrdMst
  SET ORDER TO 6
  DbGotop()

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  1.00, 1.00 DCGET cSeek       Picture '@!'                                             KEYBLOCK {|a,b,o| _Mvp110Comp( a, b, o, oBrowse, @cSeek ) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse  ALIAS 'OrdMst'                                           SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| OrdMst->T_Number }                HEADER 'Citation;Number'        WIDTH  5                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx16')} LEFTBUTTON

  DCBROWSECOL   DATA {|| Y2K(OrdMst->T_Date) }             HEADER 'Issue;Date'             WIDTH  5                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx11')} LEFTBUTTON

  DCBROWSECOL   DATA {|| MIN_TO_AMPM(OrdMst->T_Time) }     HEADER 'Issue;Time'             WIDTH  5                                   PARENT oBrowse

  DCBROWSECOL   DATA {|| AllTrim(OrdMst->Location) }       HEADER ';Issue Location'        WIDTH 15                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx12')} LEFTBUTTON

  DCBROWSECOL   DATA {|| AllTrim(OrdMst->B_Name) }         HEADER 'Respondent;Name'        WIDTH 15                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx05')} LEFTBUTTON

  DCBROWSECOL   DATA {|| AllTrim(OrdMst->C_Name) }         HEADER 'Complainant;Name'       WIDTH 15                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx06')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'OrdMx06'

  DCBROWSECOL   DATA {|| ViolationDesc() }                 HEADER ';Violation Description' WIDTH 20                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx13')} LEFTBUTTON

  DCBROWSECOL   DATA {|| Y2K(OrdMst->H_Date) }             HEADER 'Hearing;Date'           WIDTH  5                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx14')} LEFTBUTTON

  DCBROWSECOL   DATA {|| MIN_TO_AMPM(OrdMst->H_Time) }     HEADER 'Hearing;Time'           WIDTH  5                                   PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Desired Complainant' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    cComplainant := OrdMst->C_Name
    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_nRstar"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cComplainant"))

  ENDIF

  DC_BrowPres(aPres)                                           // restore original browse presentation factors
  DC_BrowseSort(aSort)

RETURN cComplainant

*---

STATIC FUNCTION _Mvp110Comp( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN
    oBrowse:pageDown()
  ELSEIF a == xbeK_END
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME
    oBrowse:goTop()
  ELSE
    SEEK AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(25)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK,lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION RespondentScan(c, aGetList)

  LOCAL GetList := {}, GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25)

  SELECT AltOrdMst
  SET ORDER TO 8
  DbGotop()

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  1.00, 1.00 DCGET cSeek       Picture '@!'                                             KEYBLOCK {|a,b,o| _Mvp110Resp( a, b, o, oBrowse, @cSeek ) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse  ALIAS 'AltOrdMst'                                        SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| AllTrim(AltOrdMst->B_Name) }      HEADER 'Respondent;Name'        WIDTH 20                                   PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('OrdMx08')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'OrdMx08'

  DCBROWSECOL   DATA {|| AltOrdMst->Sex }                  HEADER ';Sex'                   WIDTH  2                                   PARENT oBrowse

  DCBROWSECOL   DATA {|| AltOrdMst->Race }                 HEADER ';Race'                  WIDTH  3                                   PARENT oBrowse

  DCBROWSECOL   DATA {|| AltOrdMst->Dob }                  HEADER 'Date of;Birth'          WIDTH  6                                   PARENT oBrowse

  DCBROWSECOL   DATA {|| AltOrdMst->Social }               HEADER 'Social Security;Number' WIDTH  7                                   PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Desired Respondent' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    cSex      := AltOrdMst->Sex
    cRace     := AltOrdMst->Race
    dDob      := AltOrdMst->Dob
    cSocial   := AltOrdMst->Social
    cDln      := AltOrdMst->Dln
    cDlnState := AltOrdMst->DlnState
    cBname    := AltOrdMst->B_Name
    cBaddress := AltOrdMst->M_Address
    cBcity    := AltOrdMst->M_City
    cBstate   := AltOrdMst->M_State
    nBzip     := AltOrdMst->M_Zip
    cPhone    := AltOrdMst->Phone

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cBaddress"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cBname"))

  ENDIF

  DC_BrowPres(aPres)                                           // restore original browse presentation factors
  DC_BrowseSort(aSort)

RETURN cBname

*---

STATIC FUNCTION _Mvp110Resp( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN
    oBrowse:pageDown()
  ELSEIF a == xbeK_END
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME
    oBrowse:goTop()
  ELSE
    SEEK AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(25)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK,lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION ValidateRespondent(GetList)

  RespondentCount( GetList )
  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION SearchCity( nKey, mp2, oGet, cSearch )

  LOCAL lFound, nLen := Len(cSearch)

  IF Chr(nKey) < 'A' .OR. Chr(nKey) > 'z'
	 RETURN Nil
  ENDIF

  oGet:getData()

  cSearchText := Upper(AllTrim(cSearch))

  SELECT OrdMst
  SET ORDER TO 20
  dbSeek(cSearchText,.f.,20)

  IF !Eof()
	 cSearch   := Pad(OrdMst->M_City,nLen)
	 oGet:_assign(cSearch)
	 oGet:xbpSle:setMarked({Len(cSearchText)+1,nLen})
  ENDIF

RETURN Nil

* ---

STATIC FUNCTION ValidateCity(_City, GetList)

  lValid := .t.

  IF lNewRec .AND. !Empty(_City)

    SELECT CityMst
    SET ORDER TO 1
    SEEK Upper(_City)
    IF !Eof()
		cBstate := CityMst->State
		nBzip   := Val(SubStr(CityMst->ZipCode,1,5))
      DC_GetRefresh(GetList)
    ENDIF

  ENDIF

RETURN .t.

*---

STATIC FUNCTION RespondentCount( GetList )

  nRespondent := 0

  IF !Empty(cBname)

    SELECT AltOrdMst
    SET ORDER TO 17
    SEEK cSex + cRace + DtoS(dDob) + cSocial + cDln + cDlnState + AllTrim(Upper(cBname))
    DO WHILE AltOrdMst->Sex == cSex .AND. AltOrdMst->Race == cRace .AND. AltOrdMst->Dob == dDob .AND. AltOrdMst->Social == cSocial .AND. ;
  		       AltOrdMst->Dln == cDln .AND. AltOrdMst->DlnState == cDlnState .AND. AllTrim(Upper(AltOrdMst->B_Name)) == AllTrim(Upper(cBname)) .AND. !Eof()
      nRespondent++
	   DbSkip()
    ENDDO

  ENDIF

RETURN nRespondent

*---

STATIC FUNCTION ValidateAddress(cLocation, GetList)

  IF !Empty(cLocation)

    nSelect         := SELECT()
    nOrder          := OrdNumber()

	 SELECT LocMst
	 SET ORDER TO 2
	 SEEK TRIM(UPPER(cLocation))
	 IF Eof()
	   SET ORDER TO 1
	   SEEK TRIM(UPPER(cLocation))
	   IF Eof()
		  cCommonName := Space(30)
		ELSE
		  cCommonName := LocMst->Name
		  IF Empty(cBeat)
		    cBeat     := LocMst->Beat
	     ENDIF
	     cSubBeat    := LocMst->SubBeat
	     nCensus     := LocMst->Census
	     cWatch      := LocMst->W_Code
	     cClass      := LocMst->L_Code
	   ENDIF
	 ELSE
		cLocation     := LocMst->Address
		cCommonName   := LocMst->Name
		IF Empty(cBeat)
		  cBeat       := LocMst->Beat
	   ENDIF
	   cSubBeat      := LocMst->SubBeat
	   nCensus       := LocMst->Census
	   cWatch        := LocMst->W_Code
	   cClass        := LocMst->L_Code
	 ENDIF

	 SELECT CodeMst
	 SET ORDER TO 1
	 SEEK "C5" + cWatch
	 IF Eof()
		cWatchDesc    := ""
	 ELSE
		cWatchDesc    := AllTrim(CodeMst->CmDesc)
	 ENDIF
	 SEEK "F1" + cClass
	 IF Eof()
		cClassDesc    := ""
	 ELSE
		cClassDesc    := AllTrim(CodeMst->CmDesc)
	 ENDIF


    DC_GetRefresh(GetList)

    SELECT (nSelect)
    SET ORDER TO nOrder

  ENDIF

  DC_GetRefresh(GetList)
  SetAppFocus(DC_GetObject(GetList,"Get_cUnit"))

RETURN .t.

*---

STATIC FUNCTION SearchComplainant( nKey, mp2, oGet, cComplainant )

  LOCAL lFound, nLen := Len(cComplainant)

  IF Chr(nKey) < 'A' .OR. Chr(nKey) > 'z'
    RETURN Nil
  ENDIF

  oGet:getData()

  cName := Upper(AllTrim(cComplainant))

  SELECT AltOrdMst
  SET ORDER TO 6
  dbSeek(cName,.f.,6)

  IF !Eof()
    cComplainant := Pad(AltOrdMst->C_Name,nLen)
    oGet:_assign(cComplainant)
    oGet:xbpSle:setMarked({Len(cName)+1,nLen})
  ENDIF

RETURN Nil

*---

STATIC FUNCTION SearchRespondent( nKey, mp2, oGet, cBname )

  LOCAL lFound, nLen := Len(cBname)

  IF Chr(nKey) < 'A' .OR. Chr(nKey) > 'z'
    RETURN Nil
  ENDIF

  oGet:getData()

  cName    := Upper(AllTrim(cBname))

  SELECT AltOrdMst
  SET ORDER TO 8
  dbSeek(cName,.f.,8)

  IF !Eof()
    cBname := Pad(AltOrdMst->B_Name,nLen)
    oGet:_assign(cBname)
    oGet:xbpSle:setMarked({Len(cName)+1,nLen})
  ENDIF

RETURN Nil

*---

STATIC FUNCTION ValidateIssueDate( Getlist )

  IF dTdate > CtoD('') .AND. dHdate == CtoD('')

    SELECT CrtMst
	 IF Empty(cKcode)
      SET ORDER TO 2
      SET SOFTSEEK ON
      SEEK DtoS(dTdate + nCdays)
      IF CrtMst->H_Date >= (dTdate + nCdays) .AND. CrtMst->H_Date >= (Date() + nCdays)
    	  dHdate   := CrtMst->H_Date
    	  cHtime   := MIN_TO_TS(CrtMst->H_Time)
      ELSE
        SEEK DtoS(Date() + nCdays)
        IF CrtMst->H_Date >= (Date() + nCdays)
    	    dHdate := CrtMst->H_Date
    	    cHtime := MIN_TO_TS(CrtMst->H_Time)
        ELSE
    	    dHdate := CtoD('')
    	    cHtime := Space(5)
        ENDIF
      ENDIF
      SET SOFTSEEK OFF
	 ELSE
      SET ORDER TO 1
      SET SOFTSEEK ON
      SEEK cKcode + DtoS(dTdate + nCdays)
      IF CrtMst->H_Date >= (dTdate + nCdays) .AND. CrtMst->H_Date >= (Date() + nCdays)
    	  dHdate   := CrtMst->H_Date
    	  cHtime   := MIN_TO_TS(CrtMst->H_Time)
      ELSE
        SEEK cKcode + DtoS(Date() + nCdays)
        IF CrtMst->H_Date >= (Date() + nCdays)
    	    dHdate := CrtMst->H_Date
    	    cHtime := MIN_TO_TS(CrtMst->H_Time)
        ELSE
    	    dHdate := CtoD('')
    	    cHtime := Space(5)
        ENDIF
      ENDIF
      SET SOFTSEEK OFF
    ENDIF

	 IF dDueDate == CtoD('') .AND. lDueDate .AND. !lAppear
		dDueDate   := (dTdate + nDueDays)
	 ENDIF

    DC_GetRefresh(GetList)

  ENDIF

RETURN .t.

*---

STATIC FUNCTION ValidateTtime(cTtime, Getlist)

  DC_GetRefresh(GetList)

  IF VAL(SubStr(cTtime,1,2)) > 23 .OR. VAL(SubStr(cTtime,4,2)) < 0 .OR. VAL(SubStr(cTtime,4,2)) > 59
	 lError := .t.
  ELSE
	 lError := .f.
  ENDIF

RETURN !lError

*---

STATIC FUNCTION ValidateLocation(cLocation, GetList)

  IF !Empty(cLocation)

    nSelect         := SELECT()
    nOrder          := OrdNumber()

	 SELECT LocMst
	 SET ORDER TO 2
	 SEEK TRIM(UPPER(cLocation))
	 IF Eof()
	   SET ORDER TO 1
	   SEEK TRIM(UPPER(cLocation))
	   IF !Eof()
		  cCommonName := LocMst->Name
		  IF Empty(cBeat)
		    cBeat     := LocMst->Beat
	     ENDIF
	   ENDIF
	 ELSE
		cLocation     := LocMst->Address
		cCommonName   := LocMst->Name
		IF Empty(cBeat)
		  cBeat       := LocMst->Beat
	   ENDIF
	 ENDIF

    DC_GetRefresh(GetList)

    SELECT (nSelect)
    SET ORDER TO nOrder

  ENDIF

RETURN .t.

*---

STATIC FUNCTION ValidateBeat(cBeat, Getlist)

  LOCAL nSelect, nOrder

  IF !Empty(cBeat)

    lValid   := .f.
    nSelect  := SELECT()
    nOrder   := OrdNumber()

    SELECT CodeMst
    SET ORDER TO 1
    SEEK "M7" + cBeat
    IF Eof()
      lValid := .f.
    ELSE
      lValid := .t.
    ENDIF

    SELECT(nSelect)
    SET ORDER TO nOrder

  ELSE

    lValid   := .t.

  ENDIF

RETURN lValid

*---

STATIC FUNCTION ValidateHearingDate( dHdate, Getlist )

  lError     := .t.
  IF dHdate > CtoD('')

    SELECT CrtMst
    SET ORDER TO 2
    SEEK DtoS(dHdate)
    IF Eof()
		lError := .f.
    ELSE
		lError := .t.
    ENDIF

  ENDIF

RETURN lError

*---

STATIC FUNCTION ValidateHtime(cHtime, Getlist)

  DC_GetRefresh(GetList)

  IF VAL(SubStr(cHtime,1,2)) > 23 .OR. VAL(SubStr(cHtime,4,2)) < 0 .OR. VAL(SubStr(cHtime,4,2)) > 59
	 lError := .t.
  ELSE
	 lError := .f.
  ENDIF

RETURN !lError

*---

STATIC FUNCTION ValidateComplainant(Getlist)

  DC_GetRefresh(GetList)

RETURN .t.

* ---

STATIC FUNCTION ValidateSex(cSex, GetList)

  LOCAL nSelect, nOrder

  IF !Empty(cSex) .AND. cRespondent == "I"

    lValid   := .f.
    nSelect  := SELECT()

    SELECT CodeMst
    SET ORDER TO 1
    SEEK "K5" + cSex
    IF Eof()
      lValid := .f.
    ELSE
      lValid := .t.
    ENDIF

    SELECT(nSelect)

  ELSE

    lValid   := .t.

  ENDIF

RETURN lValid

* ---

STATIC FUNCTION ValidateRace(cRace, GetList)

  LOCAL nSelect

  IF !Empty(cRace) .AND. cRespondent == "I"

    lValid   := .f.
    nSelect  := SELECT()

    SELECT CodeMst
    SET ORDER TO 1
    SEEK "K4" + cRace
    IF Eof()
      lValid := .f.
    ELSE
      lValid := .t.
    ENDIF

    SELECT(nSelect)

  ELSE

    lValid   := .t.

  ENDIF

RETURN lValid

*---

STATIC FUNCTION ValidateRstar(nRstar, dTdate, Getlist)

  SELECT PersMst
  SET ORDER TO 1

  SEEK nRstar
  IF Eof()

    cRname        := Space(30)
    cDdesc        := Space(30)
    DC_GetRefresh(GetList)
    SetAppFocus(DC_GetObject(GetList,"Get_nRstar"))

  ELSE
    DO WHILE PersMst->Officer == nRstar .AND. !Eof()
      IF Empty(PersMst->O_Term) .AND. PersMst->A_Flag .OR. PersMst->O_Term >= dTdate
	     nIdNumber := PersMst->IdNumber
        cKcode    := PersMst->K_Code
        IF PersMst->O_Middle > ""
          cRname  := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First) + " " + AllTrim(PersMst->O_Middle) + "."
        ELSE
          cRname  := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First)
        ENDIF
		  EXIT
      ENDIF
	   DbSkip()
    ENDDO

    SELECT CodeMst
    SET ORDER TO 1
	 SEEK "F0" + PersMst->D_Code               // Department
	 IF Eof()
	   cDdesc  := ""
    ELSE
      cDdesc  := AllTrim(CodeMst->CmDesc)
	 ENDIF

	 IF dHdate == CtoD('')
      SELECT CrtMst
		IF Empty(cKcode)
        SET ORDER TO 2
        SET SOFTSEEK ON
        SEEK DtoS(dTdate + nCdays)
        SET SOFTSEEK OFF
        IF !Eof()
          dHdate := CrtMst->H_Date
		    cHtime := MIN_TO_TS(CrtMst->H_Time)
        ENDIF
		ELSE
        SET ORDER TO 1
        SET SOFTSEEK ON
        SEEK cKcode + DtoS(dTdate + nCdays)
        SET SOFTSEEK OFF
        IF !Eof()
          dHdate := CrtMst->H_Date
		    cHtime := MIN_TO_TS(CrtMst->H_Time)
        ENDIF
      ENDIF
	 ENDIF

    DC_GetRefresh(GetList)
	 IF cRespondent == "I"
      SetAppFocus(DC_GetObject(GetList,"Get_cSex"))
	 ELSE
      SetAppFocus(DC_GetObject(GetList,"Get_cBname"))
	 ENDIF

  ENDIF

RETURN .t.

* ---

STATIC FUNCTION GuiRstarScan(nRstar, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT PersMst
  SET ORDER TO 1
  PersMst->(DC_DbGoTop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'PersMst' SIZE 60,20 ;
  			       FIT ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| TRANSFORM(PersMst->Officer,'9999') } HEADER 'Employee;ID'               WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('PERSMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'PERSMX01'

  DCBROWSECOL   DATA {|| RankDesc(PersMst->O_Rank) }          HEADER ';Rank'                     WIDTH  9  PARENT oBrowse

  DCBROWSECOL   DATA {|| PersMst->O_Name }                    HEADER ';Employee Name'            WIDTH 15  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('PERSMX02')} LEFTBUTTON

  DCBROWSECOL   DATA {|| DeptDesc(PersMst->D_Code) }          HEADER ';Department'               WIDTH 15  PARENT oBrowse
  DCBROWSECOL   DATA {|| IIF(PersMst->A_Flag,"Yes", "No") }   HEADER 'Active;Employee'           WIDTH  5  PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Desired Personnel' ;
         EVAL { || SetAppFocus(oBrowse) }

  IF lStatus

	 nRstar    := PersMst->Officer
	 nIdNumber := PersMst->IdNumber
    IF PersMst->O_Middle > ""
      cRname  := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First) + " " + AllTrim(PersMst->O_Middle) + "."
    ELSE
      cRname  := AllTrim(PersMst->O_Last) + ", " + AllTrim(PersMst->O_First)
    ENDIF

    SELECT CodeMst
    SET ORDER TO 1
	 SEEK "F0" + PersMst->D_Code               // Department
	 IF Eof()
	   cDdesc  := ""
    ELSE
      cDdesc  := AllTrim(CodeMst->CmDesc)
	 ENDIF

  ENDIF

  DC_GetRefresh(aGetList)
  IF cRespondent == "I"
    SetAppFocus(DC_GetObject(aGetList,"Get_cSex"))
  ELSE
    SetAppFocus(DC_GetObject(aGetList,"Get_cBname"))
  ENDIF

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN nRstar

* ---

STATIC FUNCTION DeptDesc(cDeptCode)

  LOCAL nSelect

  nSelect     := SELECT()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F0" + cDeptCode
  IF Eof()
    cDeptDesc := ""
  ELSE
    cDeptDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT(nSelect)

RETURN cDeptDesc

* ---

STATIC FUNCTION RankDesc(cRcode)

  LOCAL nSelect

  nSelect  := SELECT()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "20" + cRcode
  IF Eof()
    cRdesc := ""
  ELSE
    cRdesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT(nSelect)

RETURN cRdesc

* ---

STATIC FUNCTION GuiServiceScan(cSrvCode, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"F4"))
  CodeMst->(DC_SetScope(1,"F4"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"F4"))
  CodeMst->(DC_SetScope(1,"F4"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 50,20 ;
  			       FIT ;
			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode}  HEADER 'Service;Code'                 WIDTH  6 PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| CodeMst->CmDesc}  HEADER ';Service by Description'      WIDTH 20 PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
         EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Citation Service by Method'

  IF lStatus

    cSrvCode := CodeMst->CmCode
    cSrvDesc := AllTrim(CodeMst->CmDesc)

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

  DC_GetRefresh(aGetList)
  SetAppFocus(DC_GetObject(aGetList,"Get_cSrvCode"))

RETURN cSrvCode

* ---

STATIC FUNCTION ValidateService(cSrvCode, GetList)

  LOCAL nSelect

  lValid     := .f.
  nSelect    := SELECT()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F4" + cSrvCode
  IF Eof()
    lValid   := .f.
    cSrvDesc := ""
  ELSE
    lValid   := .t.
    cSrvDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT(nSelect)
  DC_GetRefresh(GetList)
//  SetAppFocus(DC_GetObject(GetList,"Get_cSrvCode"))

RETURN lValid

*---

STATIC FUNCTION ValidateRdate(dRdate, Getlist)

  SELECT CashMst
  SET ORDER TO 1
  SEEK cTtype + cCitation + DtoS(dRdate)
  IF EOF()
	 lNewCash      := .t.
  ELSE
	 lNewCash      := .f.
    lReceipts     := .t.
	 cCashCode     := CashMst->P_Type
	 nAmt          := CashMst->R_Amt
    nOverAmt      := CashMst->R_Over
	 nHrs          := CashMst->R_Hours
	 nAgency       := CashMst->A_Amt
	 cAgencyCode   := CashMst->AgencyCode
	 nWriteOff     := CashMst->W_Amt
	 nAmnesty      := CashMst->Amnesty
	 cCheckNo      := CashMst->CheckNo
	 lBadCheck     := CashMst->BadCheck
	 dBadCheck     := CashMst->BadDate
	 nReceipt      := CashMst->Receipt
    nTransNo      := CashMst->TransNo
    DO CASE
      CASE CashMst->P_Method == "C"
        cPayment  := aPayment[1]
      CASE CashMst->P_Method == "K"
        cPayment  := aPayment[2]
      CASE CashMst->P_Method == "D"
        cPayment  := aPayment[3]
      CASE CashMst->P_Method == "M"
        cPayment  := aPayment[4]
//    OTHERWISE
//      cPayment  := aPayment[1]
    ENDCASE

	 SELECT CodeMst
	 SET ORDER TO 1
	 SEEK "M5" + cAgencyCode
	 IF Eof()
		cAgencyDesc := Space(30)
	 ELSE
		cAgencyDesc := Trim(CodeMst->CmDesc)
	 ENDIF
	 SEEK "FD" + cCashCode
	 IF EOF()
		cCashDesc   := ""
	 ELSE
		cCashDesc   := AllTrim(CodeMst->CmDesc)
	 ENDIF
  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

* ---

STATIC FUNCTION GuiPaymentScan(cCashCode, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"FD"))
  CodeMst->(DC_SetScope(1,"FD"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"FD"))
  CodeMst->(DC_SetScope(1,"FD"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 50,20 ;
  			       FIT ;
			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode}  HEADER 'Payment;Code'                 WIDTH  6 PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| CodeMst->CmDesc}  HEADER ';Payment Type Description'      WIDTH 20 PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Payment Type Code' ;
         EVAL { || SetAppFocus(oBrowse) }

  IF !lStatus

    cCashCode := Space(4)
    cCashDesc := ""

  ELSE

    cCashCode := CodeMst->CmCode
    cCashDesc := AllTrim(CodeMst->CmDesc)

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

  DC_GetRefresh(aGetList)
  SetAppFocus(DC_GetObject(aGetList,"Get_cCashCode"))

RETURN cCashCode

* ---

STATIC FUNCTION ValidatePayment(cCashCode, GetList)

  LOCAL nSelect

  lValid      := .f.
  nSelect     := SELECT()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "FD" + cCashCode
  IF Eof()
    lValid    := .f.
    cCashDesc := ""
  ELSE
    lValid    := .t.
    cCashDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT(nSelect)
  DC_GetRefresh(GetList)

RETURN lValid

*---

STATIC FUNCTION CashDesc(cCashCode)

  SavSel      := SELECT()
  SELECT CodeMst
  SET ORDER TO 1
  SEEK "FD" + cCashCode
  IF Eof()
    cCashDesc := cCashCode
  ELSE
    cCashDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT (SavSel)

RETURN(cCashDesc)

* ---

STATIC FUNCTION UnderOverPaid( cCitation )

  DO CASE
    CASE nAmt < (nFine + nCosts + nCheckFee) .AND. !lPartial
      UnderPaid(cCitation)
    CASE nOverAmt > 0.00
      OverPaid(cCitation)
  ENDCASE

RETURN .t.

* ---

STATIC FUNCTION ValidatePaid( GetList )

  DO CASE
    CASE nAmt == 0.00 .AND. !lNewRec .AND. Empty(cXcode) .AND. !lPartial                 // PrePaid (Violation Fine Empty)
		nFine    := nAmt
	   nOverAmt := 0.00
      DC_GetRefresh(GetList)
    CASE nAmt > (nFine + nCosts + nCheckFee)
	   nOverAmt := (nAmt  - (nFine + nCosts + nCheckFee))
      nAmt     := (nFine + nCosts)
      DC_GetRefresh(GetList)
    CASE nAmt <=  (nFine + nCosts + nCheckFee)
	   nOverAmt := 0.00
      DC_GetRefresh(GetList)
  ENDCASE

RETURN .t.

*---

STATIC FUNCTION ValidateTicket(cTicket, GetList)

  IF cTicket <> cCitation

    SELECT AltOrdMst
    SET ORDER TO 1
    SEEK cTtype + cTicket
    IF Eof()
		lNewAssoc  := .t.
      cAssocName := Space(35)
      cAssocAddr := Space(35)
    ELSE
		lNewAssoc  := .f.
      cAssocName := AltOrdMst->B_Name
      cAssocAddr := AltOrdMst->M_Address
    ENDIF

  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION TicketScan(c, aGetList)

  LOCAL GetList := {}, GetOptions, lStatus, aFields, aPres, aSort[6], aSaveSort, bEval

  PRIVATE i

  SELECT AltOrdMst
  DbGotop()

  aSort[1]  := GRA_CLR_WHITE       // Sort Selected Color (Foreground)
  aSort[2]  := GRA_CLR_BLUE        // Sort Selected Color (Background)
  aSort[3]  := GRA_CLR_WHITE       // Sort Unselected Color (Foreground)
  aSort[4]  := GRA_CLR_DARKGRAY    // Sort Unselected Color (Background)
  aSort[5]  := BITMAP_RD_UP_RED    // Sort UP Bitmap
  aSort[6]  := BITMAP_RD_DOWN_RED  // Sort DOWN Bitmap

  aSaveSort := DC_FindBrowseSort(aSort)

  aPres     := { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE    }, ;
                 { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
                 { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK    }, ;
                 { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE    }, ;
                 { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER} }       /* Header Alignment */  ;

  aFields   := { ; // field                           Header                        Width  Index      Prompt
               { {|| AltOrdMst->T_Number},              'Citation;Number',                 5, 'AltOrdMx16', 'Citation Number' }, ;
               { {|| AltOrdMst->T_Date},                'Issue;Date',                      6, 'AltOrdMx11', 'Issue Date' }, ;
               { {|| MIN_TO_AMPM(AltOrdMst->T_Time)},   'Issue;Time',                      5,          Nil, Nil }, ;
               { {|| AltOrdMst->Location},              ';Issue Location',                14, 'AltOrdMx12', 'Issue Location' }, ;
               { {|| AltOrdMst->B_Name},                ';Respondent Name',               14, 'AltOrdMx05', 'Respondent Name' }, ;
               { {|| AltOrdMst->C_Name},                ';Complainant Name',              14, 'AltOrdMx06', 'Complainant Name' }, ;
               { {|| AltVdesc()},                       ';Violation Description',         30, 'AltOrdMx13', 'Violation Description' }, ;
               { {|| AltOrdMst->H_Date},                'Hearing; Date',                   6, 'AltOrdMx14', 'Hearing Date' }, ;
               { {|| MIN_TO_AMPM(AltOrdMst->H_Time)},   'Hearing; Time',                   5,          Nil, Nil } ;
               }

  bEval     := {|o| o:drawingArea:setColorBG(GRA_CLR_BACKGROUND) }

  lStatus   := DC_AutoFind( aFields, Nil, Nil, Nil, 152.2, 20.2, ;
                            'Citation Master File Review', ;
                            .t., Nil, Nil, Nil, Nil, bEval, ;
                            { aPres, { GRA_CLR_DARKGRAY, GRA_CLR_CYAN } }, ;
                            .f., Nil, Nil, .01, Nil, .f., Nil )

  DC_FindBrowseSort(aSaveSort)

  IF lStatus .AND. cCitation <> AltOrdMst->T_Number

	 lNewAssoc  := .f.
    cTicket    := AltOrdMst->T_Number
	 ValidateTicket(cTicket, aGetList)

  ELSE

	 lNewAssoc  := .t.
    cTicket    := Space(10)
    cAssocName := Space(35)
    cAssocAddr := Space(35)

  ENDIF

  DC_GetRefresh(aGetList)
  SetAppFocus(DC_GetObject(aGetList,"Get_cTicket"))

RETURN cTicket

*---

STATIC FUNCTION AltVdesc

  LOCAL nSelect, nOrder

  nSelect     := SELECT()
  nOrder      := OrdNumber()

  SELECT CodeDtl
  SET ORDER TO 12
  SEEK AltOrdMst->V_Alter
  IF Eof()
    cAltVdesc := Str(AltOrdMst->V_Alter,8,0)
  ELSE
    cAltVdesc := AllTrim(CodeDtl->V_Desc)
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cAltVdesc)

*---

STATIC FUNCTION SexDesc(cNumber)

  LOCAL nSelect, nOrder

  nSelect      := SELECT()
  nOrder       := OrdNumber()

  SELECT AltOrdMst
  SET ORDER TO 1
  SEEK cTtype + cNumber
  IF Eof()
    cSexDesc   := ""
  ELSE
    SELECT CodeMst
    SET ORDER TO 1
    SEEK "K5" + AltOrdMst->Sex
    IF Eof()
      cSexDesc := AltOrdMst->Sex
    ELSE
      cSexDesc := AllTrim(CodeMst->CmDesc)
    ENDIF
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cSexDesc)

*---

STATIC FUNCTION RaceDesc(cNumber)

  LOCAL nSelect, nOrder

  nSelect       := SELECT()
  nOrder        := OrdNumber()

  SELECT AltOrdMst
  SET ORDER TO 1
  SEEK cTtype + cNumber
  IF Eof()
    cRaceDesc   := ""
  ELSE
    SELECT CodeMst
    SET ORDER TO 1
    SEEK "K4" + AltOrdMst->Race
    IF Eof()
      cRaceDesc := AltOrdMst->Race
    ELSE
      cRaceDesc := AllTrim(CodeMst->CmDesc)
    ENDIF
  ENDIF

  SELECT (nSelect)

RETURN(cRaceDesc)

*---

STATIC FUNCTION DobDesc(cNumber)

  LOCAL nSelect, nOrder

  nSelect    := SELECT()
  nOrder     := OrdNumber()

  SELECT AltOrdMst
  SET ORDER TO 1
  SEEK cTtype + cNumber
  IF Eof()
    dDobDesc := CtoD("")
  ELSE
    dDobDesc := AltOrdMst->Dob
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(dDobDesc)

*---

STATIC FUNCTION NameDesc(cNumber)

  LOCAL nSelect, nOrder

  nSelect     := SELECT()
  nOrder      := OrdNumber()

  SELECT AltOrdMst
  SET ORDER TO 1
  SEEK cTtype + cNumber
  IF Eof()
    cNameDesc := ""
  ELSE
    cNameDesc := AllTrim(AltOrdMst->B_Name)
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cNameDesc)

*---

STATIC FUNCTION AssocAction( nAction, GetList )

  SELECT AssocMst
  SET ORDER TO 2
  IF nAction == 1 .OR. nAction == 2

	 SEEK cTtype + cTicket
	 IF Eof()
      APND()
    ENDIF
    IF DC_RecLock(5)                                    // Update Record Text
      REPLACE T_Type      WITH cTtype
      REPLACE T_Number    WITH cCitation
      REPLACE A_Type      WITH cTtype
      REPLACE A_Number    WITH cTicket
      UNLOCK
    ENDIF

  ELSEIF nAction == 3                            // delete record

    SET ORDER TO 2
	 SEEK cTtype + cTicket
	 IF !Eof()
      IF DC_RecLock(5)
        DELETE
        UNLOCK
      ENDIF
    ENDIF

  ENDIF

  cTicket    := Space(10)
  cAssocName := Space(35)
  cAssocAddr := Space(35)
//  SetAppFocus(DC_GetObject(GetList,"Get_cTicket"))
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION GuiAsideScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"F9"))
  CodeMst->(DC_SetScope(1,"F9"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"F9"))
  CodeMst->(DC_SetScope(1,"F9"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 60,9.85 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }           HEADER 'Petition to;Set Aside Code'            WIDTH 10  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }  HEADER ';Petition to Set Aside Description'    WIDTH 30  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Petition to Set Aside Code'


  IF lStatus

    cPcode := SubStr(CodeMst->CmCode,1,1)
    cPdesc := AllTrim(CodeMst->CmDesc)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_dNewHdate"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cPcode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cPcode

* ---

STATIC FUNCTION ValidateAside(cPcode, GetList)

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F9" + cPcode
  IF Eof()

    lValid := .f.
    cPdesc := ""

  ELSE

    lValid := .t.
    cPdesc := AllTrim(CodeMst->CmDesc)

  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION CashAction( nAction, GetList )

  SELECT CashMst
  SET ORDER TO 1
  SEEK cTtype + cCitation + DtoS(dRdate)
  IF nAction == 1 .OR. nAction == 2

    IF Eof()
		nTransYear := YEAR(dRdate)
		SELECT CodeMst
		SET ORDER TO 1
		SEEK "M4" + Str(nTransYear,4,0)
		IF Eof()
		  APND()
		  nTransNo := 1
		ELSE
		  nTransNo := CodeMst->CmValue
		ENDIF
		IF DC_RecLock(5)
		  REPLACE CmRecid    WITH "M4"
		  REPLACE CmCode     WITH Str(nTransYear,4,0)
		  REPLACE CmDesc     WITH Str(nTransYear,4,0) + " - Next Available Cash Receipt Transaction Number."
		  REPLACE CmValue    WITH nTransNo + 1
		  UNLOCK
		ENDIF

      IF lSystemData
	     tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Receipted Citation " + AllTrim(cCitation) + ".")
      ENDIF
      SELECT CashMst
      APND()
    ENDIF

    IF DC_RecLock(5)                                      // Update Record Text
      REPLACE T_Type       WITH cTtype
      REPLACE T_Number     WITH cCitation
      REPLACE Name         WITH cBname
      REPLACE A_Date       WITH Date()
      REPLACE R_Date       WITH dRdate
      REPLACE P_Type       WITH cCashCode
		DO CASE
		  CASE cPayment == aPayment[1]
          REPLACE P_Method WITH "C"
		  CASE cPayment == aPayment[2]
          REPLACE P_Method WITH "K"
		  CASE cPayment == aPayment[3]
          REPLACE P_Method WITH "D"
		  CASE cPayment == aPayment[4]
          REPLACE P_Method WITH "M"
		ENDCASE
      REPLACE R_Amt        WITH nAmt
      REPLACE R_Hours      WITH nHrs
      REPLACE A_Amt        WITH nAgency
      REPLACE AgencyCode   WITH cAgencyCode
		REPLACE CheckNo      WITH cCheckNo
      REPLACE W_Amt        WITH nWriteOff
      REPLACE Amnesty      WITH nAmnesty
		REPLACE BadDate      WITH dBadCheck
		REPLACE BadCheck     WITH lBadCheck
		REPLACE CheckFee     WITH nBadCheck
		REPLACE Receipt      WITH nReceipt
		REPLACE TransYear    WITH nTransYear
		REPLACE TransNo      WITH nTransNo
		REPLACE D_Code       WITH cClerkDept
		REPLACE MaintDate    WITH Date()
		REPLACE MaintUser    WITH M_Officer
		UNLOCK
    ENDIF

	 IF lBadCheck                                   // Print Bad Check Letter

      oP := tdcPrn3():New()

      IF ! oP:lInitErr                             // User did not Cancel

        oP:create()                                // begin normal report code
        oP:setPt(tdPT_NORM)
        oP:startDoc("MvCheck")

        nPage   := 1
        nCopies := 1
        DO WHILE nCopies <= 4

          IF FRM("MVFB",nCopies)
            MvCheck()                              // Returned Check Notice
          ENDIF
    	    nCopies++

        ENDDO
        *
        *--- Status Update ---
        *
        Sx("~75~",cXcode)

        oP:EndDoc()                                // end output to spooler

        oP:Destroy()

  		ENDIF

	 ENDIF

  ELSEIF nAction == 3                              // delete record

    IF !Eof()
      IF lSystemData
	     tdLog("User " + LTRIM(TRANSFORM(nClerkId,"9999")) + " Deleted Receipt for Citation " + AllTrim(cCitation) + ".")
      ENDIF
      IF DC_RecLock(5)
        DELETE
        UNLOCK
      ENDIF
    ENDIF

  ENDIF

  lReceipts   := .f.
  nChecks     := 0
  nCheckFee   := 0.00
  nReceiptHrs := nCShrs
  nReceiptAmt := (nFine + nCosts)

  SELECT CashMst
  SET ORDER TO 1
  SEEK cTtype + cCitation
  DO WHILE CashMst->T_Type == cTtype .AND. CashMst->T_Number == cCitation .AND. !Eof()
	 lReceipts     := .t.
	 IF CashMst->BadCheck
      nChecks++
      nCheckFee   += CashMst->CheckFee
      nReceiptAmt += CashMst->CheckFee
	 ELSE
      nReceiptHrs -= CashMst->R_Hours
      nReceiptAmt -= (CashMst->R_Amt + CashMst->A_Amt + CashMst->W_Amt + CashMst->Amnesty)
	 ENDIF
    DbSkip()
  ENDDO

  SELECT OrdMst
  SET ORDER TO 1
  IF nAction <> 3 .AND. lReceipts                // Payments Received - Verify Account Balances.
    SEEK cTtype + cCitation
	 IF DC_RecLock(5)
		REPLACE T_Type       WITH cTtype
		REPLACE T_Number     WITH cCitation
		REPLACE F_Amt        WITH nFine
		REPLACE C_Amt        WITH nCosts
		REPLACE Cs_Hrs       WITH nCsHrs
		REPLACE Ar_Amt       WITH nReceiptAmt
		REPLACE Ar_Hrs       WITH nReceiptHrs
	   IF !Empty(cPaid) .AND. Empty(OrdMst->X_Code) .AND. (OrdMst->F_Amt + OrdMst->C_Amt) > 0.00   // Pre-Paid - Update Disposition Information
		  cXcode := cPaid
		  dXdate := dRdate
		  REPLACE X_Code     WITH cPaid
		  REPLACE X_Date     WITH dRdate
	   ENDIF
		UNLOCK
	 ENDIF
  ENDIF

  lNewCash    := .t.
  dRdate      := CtoD('')
  cCheckNo    := Space(25)
  nAmt        := 0.00
  nDollars    := 0.00
  nReceipt    := 0
  nHrs        := 0
  nHours      := 0
  nAgency     := 0.00
  cAgencyCode := Space(4)
  cAgencyDesc := Space(30)
  nWriteOff   := 0.00
  cCashCode   := Space(4)
  cCashDesc   := Space(30)
  nAmnesty    := 0.00
  lBadCheck   := .f.
  dBadCheck   := CtoD('')

  DC_GetRefresh(GetList)
  IF lNewRec
    SetAppFocus(DC_GetObject(GetList,"Get_dRdate"))
  ELSE
    CodeAction(0,GetList)                               // Force Tab1 Gop
  ENDIF

RETURN Nil

*---

STATIC FUNCTION GuiStatusScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"F7"))
  CodeMst->(DC_SetScope(1,"F7"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"F7"))
  CodeMst->(DC_SetScope(1,"F7"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 60,9.85 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }           HEADER 'Status;Code'                 WIDTH 10  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }  HEADER ';Status Code Description'    WIDTH 30  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Status Code'


  IF lStatus

    cScode      := CodeMst->CmCode
    cSdesc      := AllTrim(CodeMst->CmDesc)

    SELECT StatMst
    SET ORDER TO 1
    SEEK cTtype + cCitation + cScode + DtoS(dSdate)
    IF Eof()
  	 	 lNewStat := .t.
    ELSE
  	 	 lNewStat := .f.
    ENDIF

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cStext"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cScode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cScode

* ---

STATIC FUNCTION ValidateStatus(cScode, GetList)

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F7" + cScode
  IF Eof()

    lValid := .f.
    cSdesc := ""

  ELSE

    lValid := .t.
    cSdesc := AllTrim(CodeMst->CmDesc)

  ENDIF

  DC_GetRefresh(GetList)

  SELECT StatMst
  SET ORDER TO 1
  SEEK cTtype + cCitation + cScode + DtoS(dSdate)
  IF Eof()
	 lNewStat := .t.
  ELSE
	 lNewStat := .f.
  ENDIF

RETURN .t.

*---

STATIC FUNCTION StatAction( nAction, GetList )

  SELECT StatMst
  SET ORDER TO 1
  SEEK cTtype + cCitation + DtoS(dSdate)
  IF nAction == 1 .OR. nAction == 2

    IF Eof()
      APND()
    ENDIF
    IF DC_RecLock(5)                                    // Update Record Text
      REPLACE T_Type     WITH cTtype
      REPLACE T_Number   WITH cCitation
      REPLACE S_Date     WITH dSdate
      REPLACE S_Code     WITH cScode
      REPLACE X_Code     WITH OrdMst->X_Code
		UNLOCK

		SELECT MemoDtl
		SET ORDER TO 1
		SEEK "S" + cCitation + DtoS(dSdate)
		IF Eof()
		  APND()
		ENDIF
		IF DC_RecLock(5)
        REPLACE MemoKey    WITH "S" + cCitation + DtoS(dSdate)
        REPLACE MemoText   WITH cStext
		  UNLOCK
		ENDIF
    ENDIF

  ELSEIF nAction == 3                            // delete record

    IF !Eof()

      IF DC_RecLock(5)
        DELETE
        UNLOCK
      ENDIF

		SELECT MemoDtl
		SET ORDER TO 1
		SEEK "S" + cCitation + DtoS(dSdate)
		IF !Eof()
		  IF DC_RecLock(5)
		    DELETE
		    UNLOCK
		  ENDIF
		ENDIF

    ENDIF

  ENDIF

  lNewStat := .t.
  dSdate   := CtoD('')
  cScode   := Space(4)
  cSdesc   := Space(30)
  cStext   := ""

  DC_GetRefresh(GetList)
  SetAppFocus(DC_GetObject(GetList,"Get_dSdate"))

RETURN Nil

*---

STATIC FUNCTION ValidatePDate(cGet, _Date, GetList)

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION ValidateDate(cGet, GetList)

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION StatusReview(aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT StatMst
  SET ORDER TO 1
  StatMst->(DC_SetScope(0,cTtype + cCitation))
  StatMst->(DC_SetScope(1,cTtype + cCitation))
  StatMst->(DC_DbGoTop())

  SET ORDER TO 3
  StatMst->(DC_SetScope(0,cTtype + cCitation))
  StatMst->(DC_SetScope(1,cTtype + cCitation))
  StatMst->(DC_DbGoTop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'StatMst' SIZE 60,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| StatMst->S_Date }                    HEADER 'Status;Date'                           WIDTH  7  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('STATMX03')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'STATMX03'

  DCBROWSECOL   DATA {|| StatMst->S_Code }                    HEADER 'Status;Code'                           WIDTH  6  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('STATMX01')} LEFTBUTTON

  DCBROWSECOL   DATA {|| StatusDesc(StatMst->S_Code) }        HEADER ';Status Description'                   WIDTH 20  PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE " " + AllTrim(cTtype) + AllTrim(cCitation) + "  " + AllTrim(cBname)


  IF lStatus

    cScode   := StatMst->S_Code
    dSdate   := StatMst->S_Date
	 lNewStat := .f.

	 SELECT MemoDtl
	 SET ORDER TO 1
	 SEEK "S" + cCitation + DtoS(dSdate)
	 IF Eof()
	   cStext := ""
	 ELSE
	   cStext := MemoDtl->MemoText
	 ENDIF

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_dSdate"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cScode"))

  ENDIF

  SELECT StatMst
  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 3
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cScode

*---

STATIC FUNCTION StatusDesc(cScode)

  LOCAL nSelect, nOrder

  nSelect     := SELECT()
  nOrder      := OrdNumber()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F7" + cScode
  IF Eof()
    cStatDesc := cScode
  ELSE
    cStatDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  SELECT (nSelect)
  SET ORDER TO nOrder

RETURN(cStatDesc)

*---

STATIC FUNCTION CashReview(aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CashMst
  SET ORDER TO 3
  CashMst->(DC_SetScope(0,cTtype + cCitation))
  CashMst->(DC_SetScope(1,cTtype + cCitation))
  CashMst->(DC_DbGotop())

  SET ORDER TO 1
  CashMst->(DC_SetScope(0,cTtype + cCitation))
  CashMst->(DC_SetScope(1,cTtype + cCitation))
  CashMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CashMst' SIZE 60,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CashMst->R_Date }                                              HEADER 'Activity;Date'                         WIDTH  6  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CASHMX03')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CASHMX03'

  DCBROWSECOL   DATA {|| CashMst->P_Type }                                              HEADER 'Payment;Code'                          WIDTH  6  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CASHMX01')} LEFTBUTTON

  DCBROWSECOL   DATA {|| CashDesc(CashMst->P_Type) }                                    HEADER ';Payment Description'                  WIDTH 20  PARENT oBrowse

  DCBROWSECOL   DATA {|| CashMst->CheckNo }                                             HEADER 'Check;Number'                          WIDTH  6  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->Receipt }                                             HEADER 'Receipt;Number'                        WIDTH  6  PARENT oBrowse
  DCBROWSECOL   DATA {|| IIF(CashMst->BadCheck,"Yes", "No") }                           HEADER 'Returned;Check'                        WIDTH  5  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->BadDate }                                             HEADER 'Returned;Date'                         WIDTH  7  PARENT oBrowse
  DCBROWSECOL   DATA {|| IIF(CashMst->BadCheck,CashMst->R_Amt * -1,CashMst->R_Amt) }    HEADER 'Payment;Amount'                        WIDTH  6  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->R_Hours }                                             HEADER 'Community;Service Hours'               WIDTH  7  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->A_Amt }                                               HEADER 'Agency;Amount'                         WIDTH  6  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->W_Amt }                                               HEADER 'Write-Off;Amount'                      WIDTH  6  PARENT oBrowse
  DCBROWSECOL   DATA {|| CashMst->Amnesty }                                             HEADER 'Amnesty;Amount'                        WIDTH  6  PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE " " + AllTrim(cTtype) + AllTrim(cCitation) + "  " + AllTrim(cBname)


  IF lStatus

	 lNewCash    := .f.
    lReceipts   := .t.
	 dRdate      := CashMst->R_Date
    nAmt        := CashMst->R_Amt
    nOverAmt    := CashMst->R_Over
    nHrs        := CashMst->R_Hours
    nAgency     := CashMst->A_Amt
	 cAgencyCode := CashMst->AgencyCode
    nWriteOff   := CashMst->W_Amt
    nAmnesty    := CashMst->Amnesty
    cCashCode   := CashMst->P_Type
	 cCheckNo    := CashMst->CheckNo
	 lBadCheck   := CashMst->BadCheck
	 dBadCheck   := CashMst->BadDate
	 nReceipt    := CashMst->Receipt
    nTransNo    := CashMst->TransNo

	 SELECT CodeMst
	 SET ORDER TO 1
	 SELECT CodeMst
	 SET ORDER TO 1
	 SEEK "M5" + cAgencyCode
	 IF Eof()
		cAgencyDesc := ""
	 ELSE
		cAgencyDesc := AllTrim(CodeMst->CmDesc)
	 ENDIF
	 SEEK "FD" + cCashCode
	 IF Eof()
		cCashDesc   := ""
	 ELSE
		cCashDesc   := AllTrim(CodeMst->CmDesc)
	 ENDIF

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_nAmt"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_dRdate"))

  ENDIF

  SELECT CashMst
  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 3
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN dRdate

*---

STATIC FUNCTION GuiDispositionScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"F2"))
  CodeMst->(DC_SetScope(1,"F2"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"F2"))
  CodeMst->(DC_SetScope(1,"F2"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 60, 9.85 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }           HEADER 'Disposition;Code'                 WIDTH 10  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }  HEADER ';Disposition Code Description'    WIDTH 30  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Disposition Code'


  IF lStatus

    cXcode   := CodeMst->CmCode
    cXform   := CodeMst->CmLink
    cXdesc   := AllTrim(CodeMst->CmDesc)
	 lConvict := CodeMst->CmCalc

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_nFine"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cXcode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cXcode

* ---

STATIC FUNCTION ValidateDisposition(cXcode, GetList)

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "F2" + cXcode
  IF Eof()

    lValid   := .f.
    cXform   := Space(4)
    cXdesc   := ""
    lConvict := .f.

  ELSE

    lValid   := .t.
    cXform   := CodeMst->CmLink
    cXdesc   := AllTrim(CodeMst->CmDesc)
	 lConvict := CodeMst->CmCalc

  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION DragDialog( mp1, mp2, oXbp )

  LOCAL GetList[0], GetOptions, oDialog, aPos, cText

  IF oXbp:isDerivedFrom('XbpColumn')
    cText := Trim(Eval(oXbp:dataLink))
  ELSEIF oXbp:isDerivedFrom('XbpStatic')
    cText := Trim(oXbp:caption)
  ELSEIF oXbp:isDerivedFrom('XbpTreeView')
    cText := Trim(oXbp:getData():caption)
  ENDIF

  @  2.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP                SIZE 10, 1.20           CAPTION "..\..\BitMaps\File1.Bmp"

  @ DCGUI_ROW, DCGUI_COL DCSAY cText ;
                         COLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
                         FONT '10.Courier' SAYSIZE  0, 1.20 ;
                         OPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER

  DCGETOPTIONS ;
     HIDE ;
     FITPAD 0 ;
     NOTITLEBAR ;
     COLOR { 240, 240, 255 } ;
     BORDER XBPDLG_NO_BORDER ;
     ORIGIN XBPDLG_ORIGIN_MOUSE

  DCREAD GUI ;
         FIT ;
         EXIT ;
         NOAUTORESTORE ;
         PARENT @oDialog ;
         OPTIONS GetOptions

  aPos    := DC_CalcAbsolutePosition(mp1,oXbp)
  aPos[2] -= (oDialog:currentSize()[2] + 30)
  oDialog:setPos( aPos )
  oDialog:show()

RETURN oDialog

*---

STATIC FUNCTION Label770(cCitation)

  SELECT OrdMst
  SET ORDER TO 1
  SEEK cTtype + cCitation
  IF !Eof()

    oP := tdcPrv3():New(,,,.f.)                         //  toggle .t./.f. for display of row & col positions

    IF oP != Nil .AND. ! oP:lInitErr                    // User did not Cancel

	   oP:create()                                       // begin normal report code
      oP:setPt(tdPT_NORM)
      oP:startDoc("Mvp770")

      nPage := 0
		Print770()

      oP:endDoc()

      oP:openPwin(,,,6,,,.t.)

      oP:destroy()

	 ENDIF

  ENDIF

RETURN Nil

*---

STATIC FUNCTION BumpPetition(nMonths, GetList)

  FOR i := 1 TO nMonths
	 dNewHdate := EOM(dNewHdate) + 1
  NEXT

  SELECT CrtMst
  SET ORDER TO 2
  SEEK DtoS(dCSdate)
  IF Eof()
    SET SOFTSEEK ON
    SEEK DtoS(dCSdate)
    SET SOFTSEEK OFF
    IF !Eof()
      dNewHdate := CrtMst->H_Date
	 ENDIF
  ELSE
    dNewHdate   := CrtMst->H_Date
  ENDIF

  DC_GetRefresh(GetList)

RETURN dCSdate

*---

STATIC FUNCTION History(GetList)

  LOCAL nAmt, nHrs

  nAmt       := 0.00
  nHrs       := 0.00
  nBalAmt    := 0.00
  nBalHrs    := 0
  nCount     := 0
  nHistAmt   := 0.00
  nHistHrs   := 0
  nHistCount := 0
  nTownCnt   := 0
  nTownBal   := 0

  SELECT CashMst
  SET ORDER TO 1
  SELECT AltOrdMst
  SET ORDER TO 5
  SEEK Upper(cBname) + cSex + cRace + DtoS(dDob)
  DO WHILE Upper(AltOrdMst->B_Name) == Upper(cBname) .AND. AltOrdMst->Sex == cSex .AND. AltOrdMst->Race == cRace .AND. AltOrdMst->Dob == dDob .AND. !Eof()

    nHistCount++
	 nAmt     := (AltOrdMst->F_Amt + AltOrdMst->C_Amt)
	 nHrs     := AltOrdMst->Cs_Hrs
    nHistAmt += (AltOrdMst->F_Amt + AltOrdMst->C_Amt)
    nHistHrs += AltOrdMst->Cs_Hrs
    nBalAmt  += (AltOrdMst->F_Amt + AltOrdMst->C_Amt)
    nBalHrs  += AltOrdMst->Cs_Hrs
	 IF AltOrdMst->TownShip
		nTownCnt++
		IF Empty(AltOrdMst->PgmDate)
		  nTownBal++
	   ENDIF
	 ENDIF

    SELECT CashMst
    SEEK AltOrdMst->T_Type + AltOrdMst->T_Number
    DO WHILE CashMst->T_Type == AltOrdMst->T_Type .AND. CashMst->T_Number == AltOrdMst->T_Number .AND. !Eof()
      nHrs    -= CashMst->R_Hours
      nBalHrs -= CashMst->R_Hours
		IF CashMst->BadCheck
        nAmt    += CashMst->CheckFee
        nBalAmt += CashMst->CheckFee
		ELSE
        nAmt    -= (CashMst->R_Amt + CashMst->A_Amt + CashMst->W_Amt + CashMst->Amnesty)
        nBalAmt -= (CashMst->R_Amt + CashMst->A_Amt + CashMst->W_Amt + CashMst->Amnesty)
		ENDIF
      DbSkip()
    ENDDO

	 IF nHrs + nAmt > 0.00
      nCount++
	 ENDIF

	 SELECT AltOrdMst
    DbSkip()
  ENDDO

  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION HearingHistory( GetList, oBrowse )

  cBname := Upper(OrdMst->B_Name)
  cSex   := OrdMst->Sex
  cRace  := OrdMst->Race
  dDob   := OrdMst->Dob

  Print360( cBname, cSex, cRace, dDob )

RETURN Nil

*---

STATIC FUNCTION BumpReturn(nMonths, GetList)

  FOR i := 1 TO nMonths
	 dCSdate   := EOM(dCSdate) + 1
  NEXT

  SELECT CrtMst
  SET ORDER TO 2
  SEEK DtoS(dCSdate)
  IF Eof()
    SET SOFTSEEK ON
    SEEK DtoS(dCSdate)
    SET SOFTSEEK OFF
    IF !Eof()
      dCSdate := CrtMst->H_Date
	 ENDIF
  ELSE
    dCSdate   := CrtMst->H_Date
  ENDIF

  DC_GetRefresh(GetList)

RETURN dCSdate

*---

STATIC FUNCTION BumpContinuation(nMonths, GetList)

  FOR i := 1 TO nMonths
	 dContinued   := EOM(dContinued) + 1
  NEXT

  SELECT CrtMst
  SET ORDER TO 2
  SEEK DtoS(dHdate)
  IF Eof()
    SET SOFTSEEK ON
    SEEK DtoS(dContinued)
    SET SOFTSEEK OFF
    IF !Eof()
      dContinued := CrtMst->H_Date
	 ENDIF
  ELSE
    dContinued   := CrtMst->H_Date
  ENDIF

  DC_GetRefresh(GetList)

RETURN dContinued

*---

STATIC FUNCTION PrintDisposition( GetList )

//    oP := tdcPrn3():New()                        // No Printer Dialog
    oP := tdPdlg(.f.)                            // Printer Dialog

    IF ! oP:lInitErr                             // User did not Cancel

      oP:create()                                // begin normal report code
      oP:setPt(tdPT_NORM)
      oP:startDoc("Mvp210")

      SELECT CrtMst
      SET ORDER TO 2
      SEEK DtoS(dXdate)
      IF Eof()
        SET SOFTSEEK ON
        SEEK DtoS(Date())
        SET SOFTSEEK OFF
        IF !Eof()
          nJudge := CrtMst->Judge
  	 	 	 SELECT CodeMst
  	 	 	 SET ORDER TO 1
  	 	 	 SEEK "FB" + StrZero(nJudge,4,0)
  	 	 	 IF !Eof()
            cHname     := AllTrim(CodeMst->CmDesc)
  	 	 		cSignature := AllTrim(CodeMst->CmText1)
  	 	 	 ENDIF
  	 	  ENDIF
      ELSE
        nJudge := CrtMst->Judge
  	 	  SELECT CodeMst
  	 	  SET ORDER TO 1
  	 	  SEEK "FB" + StrZero(nJudge,4,0)
  	 	  IF !Eof()
          cHname       := AllTrim(CodeMst->CmDesc)
  	 	 	 cSignature   := AllTrim(CodeMst->CmText1)
  	 	  ENDIF
      ENDIF
      *
      *---
      *
      L1_Amt := 0.00
      L1_Hrs := 0
      SELECT CashMst
      SET ORDER TO 1
      SEEK OrdMst->T_Type + OrdMst->T_Number
      DO WHILE CashMst->T_Type == OrdMst->T_Type .AND. CashMst->T_Number == OrdMst->T_Number .AND. !Eof()
        L1_Hrs += CashMst->R_Hours
		  IF CashMst->BadCheck
          L1_Amt -= CashMst->CheckFee
		  ELSE
          L1_Amt += (CashMst->R_Amt + CashMst->A_Amt + CashMst->W_Amt + CashMst->Amnesty)
		  ENDIF
        DbSkip()
      ENDDO
      *
      *---
      *
      SELECT OrdMst
      IF DC_RecLock(5)                                  // Update Record Text
        REPLACE X_Code        WITH cXcode
        REPLACE X_Date        WITH dXdate
        REPLACE Cs_Hrs        WITH nCshrs
        REPLACE Cs_Date       WITH dCsdate
        REPLACE F_Amt         WITH nFine
        REPLACE C_Amt         WITH nCosts
        REPLACE H_Date        WITH dHdate
        REPLACE O_Appear      WITH lSubpoena
		  REPLACE Township      WITH lTownship
		  REPLACE Alarms        WITH nAlarms
		  REPLACE PgmDate       WITH dTownship
        IF cXform == "MVF2"
          REPLACE H_Date2     WITH dXdate
        ENDIF
        REPLACE Ar_Amt        WITH ((OrdMst->F_Amt + OrdMst->C_Amt) - L1_Amt)
        REPLACE Ar_Hrs        WITH (OrdMst->Cs_Hrs - L1_Hrs)
        UNLOCK
      ENDIF

      SELECT MemoDtl                            // Order Text
      SET ORDER TO 1
      SEEK "O" + cCitation
      IF Eof()
		  APND()
		ENDIF
		IF DC_RecLock(5)
        REPLACE MemoKey       WITH "O" + cCitation
        REPLACE MemoText      WITH cXtext
		  UNLOCK
		ENDIF

		nPage   := 0
      nCopies := 1
      DO WHILE nCopies <= 4

        IF dXdate <> dHdate                      // Hearing Date Modified (Continued)

          IF FRM("MVF7",nCopies)
            MvForm7()                            // Continuance Date
          ENDIF

          IF OrdMst->O_Appear
            IF FRM("MVF0",nCopies)
				  IF nCopies == 2
					 oP:newPage()
				  ENDIF
              MvForm0()                          // Subpoena (Issuing Officer Only)
				  IF nCopies == 2
					 oP:newPage()
				  ENDIF
              MvForm0()                          // Subpoena (Issuing Officer Only)
            ENDIF
          ENDIF
          *
          *--- Status Update ---
          *
          Sx("~30~",cXcode)

        ELSE

          IF cXform == "MVF2"

            IF FRM("MVF2",nCopies)
              MvForm2()                          // Finding, Decision and Order Default
            ENDIF

            IF FRM("MVF3",nCopies)
				  IF nCopies == 2
					 oP:newPage()
				  ENDIF
              MvForm3()                          // Petition to Set Aside Default
            ENDIF

          ELSE

            IF FRM("MVF1",nCopies)
              MvForm1()                          // Finding, Decision and Order
            ENDIF

          ENDIF
          *
          *--- Status Update ---
          *
          Sx("~01~",cXcode)

        ENDIF

    	  nCopies++

      ENDDO

  	   IF lConvict
		  IF lPayPlan
			 Promise(OrdMst->T_Number)
		  ENDIF
		ENDIF

      oP:EndDoc()                                // end output to spooler

      oP:Destroy()

    ENDIF

RETURN Nil

*---

STATIC FUNCTION TabDisplay(GetList)

  @  1.00, 1.00 DCSAY 'Number'                                         SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK
  @   .75,15.00 DCSAY {|| AllTrim(cTtype) + cCitation }                SAYSIZE 25                                                PARENT oGroup4   COLOR GRA_CLR_RED ;
					 FONT "14.CAMPBELL"

  @   .75,47.00 DCSAY 'Report Number'                                  SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK
  @   .75,60.00 DCSAY {|| SubStr(Str(Year(dTdate),4,0),1,2) + StrZero(nRdYr,2,0) }       SAYSIZE 10                              PARENT oGroup4   COLOR GRA_CLR_BLUE ;
					 HIDE {|| nRdNumber == 0 }
  @   .75,64.00 DCSAY '-'                                              SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK ;
					 HIDE {|| nRdNumber == 0 }
  @   .75,65.00 DCSAY {|| nRdNumber }                                  SAYSIZE 10                                                PARENT oGroup4   COLOR GRA_CLR_BLUE ;
					 HIDE {|| nRdNumber == 0 }

  @  2.00, 1.00 DCSAY 'Location'                                       SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK
  @  2.00,15.00 DCSAY {|| AllTrim(cLocation) }                         SAYSIZE 25                                                PARENT oGroup4   COLOR GRA_CLR_BLUE
  @  1.75,47.00 DCSAY {|| PrintDate(dTdate,1) }                        SAYSIZE 17                                                PARENT oGroup4   COLOR GRA_CLR_BLUE
  @  1.75,68.00 DCSAY {|| TS_TO_AMPM(cTtime) }                         SAYSIZE  7                                                PARENT oGroup4   COLOR GRA_CLR_BLUE

  @  3.00, 1.00 DCSAY 'Violation'                                      SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK
  @  3.00,15.00 DCSAY {|| cVdesc }                                     SAYSIZE 61                                                PARENT oGroup4   COLOR GRA_CLR_BLUE

  @  3.90,15.00 DCSAY {|| cCurrentStatus }                             SAYSIZE 30                                                PARENT oGroup4   COLOR GRA_CLR_BROWN
  @  3.90,47.00 DCSAY {|| cXdesc }                                     SAYSIZE 28                                                PARENT oGroup4   COLOR GRA_CLR_RED

  @  5.70, 1.00 DCSAY 'Respondent'                                     SIZE  0                                                   PARENT oGroup4   COLOR GRA_CLR_BLACK
  @  5.70,15.00 DCSAY {|| cBname }                                     SAYSIZE 30                                                PARENT oGroup4   COLOR GRA_CLR_BLUE
  @  6.70,15.00 DCSAY {|| cBaddress }                                  SAYSIZE 30                                                PARENT oGroup4   COLOR GRA_CLR_BLUE
  @  7.70,15.00 DCSAY {|| cBcity }                                     SAYSIZE 30                                                PARENT oGroup4   COLOR GRA_CLR_BLUE

  @  6.45, 2.00 DCSAY {|| cJuvenile }                                  SIZE  0                                                   PARENT oGroup4   COLOR {165,000,000} ;
					 SAYFONT '10.Helv Bold' ;
				    WHEN {|| cRespondent == "I" } ;
					 HIDE {|| dDob == CtoD('') .OR. Age( dDob, dTdate ) >= nJage }

  @  7.45, 1.25 DCPUSHBUTTON CAPTION "Respondent History" 				  SIZE 10, 2                                                PARENT oGroup4 ;
                WHEN {|| nHistCount > 0 } ;
					 ALIGNCAPTION BS_MULTILINE ;
                ACTION {|| HearingHistory(GetList) } ;
                TOOLTIP 'Review Respondent History.'

  @  8.70,20.00 DCSAY {|| cLiquor }                                    SAYSIZE 20                                                PARENT oGroup4   COLOR GRA_CLR_RED ;
  					 SAYFONT '12.Helv Bold' ;
					 HIDE {|| !lLiquor .OR. dDob == CtoD('') .OR. Age( dDob, dTdate ) >= nAlcohol }

  @  4.70,45.00 DCGROUP oGroup4a  CAPTION ' Respondent History '       SIZE 30.60, 4.75                                          PARENT oGroup4   COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @   .65,15.25 DCSAY 'Total'                                          SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK
  @   .65,25.00 DCSAY 'Open'                                           SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK

  @  1.25, 1.75 DCSAY 'Citations'                                      SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK
  @  1.25,19.00 DCSAY {|| TRANSFORM(nHistCount,"999") }                SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLUE ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  1.25,29.00 DCSAY {|| TRANSFORM(nCount,"999") }                    SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_RED ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  2.00, 1.75 DCSAY 'Dollars'                                        SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK
  @  2.00,19.00 DCSAY {|| TRANSFORM(nHistAmt,"99,999.99") }            SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLUE ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  2.00,29.00 DCSAY {|| TRANSFORM(nBalAmt,"99,999.99") }             SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_RED ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  2.75, 1.75 DCSAY 'Hours'                                          SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK
  @  2.75,19.00 DCSAY {|| TRANSFORM(nHistHrs,"999") }                  SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLUE ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  2.75,29.00 DCSAY {|| TRANSFORM(nBalHrs,"999") }                   SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_RED ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  3.50, 1.75 DCSAY 'Township'                                       SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLACK
  @  3.50,19.00 DCSAY {|| TRANSFORM(nTownCnt,"999") }                  SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_BLUE ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"
  @  3.50,29.00 DCSAY {|| TRANSFORM(nTownBal,"999") }                  SIZE  0                                                   PARENT oGroup4a  COLOR GRA_CLR_RED ;
					 ALIGNRIGHT ;
				    FONT "9.Courier New"

RETURN Nil

*---

STATIC FUNCTION _UpdateStats( GetList )

  LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
  LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
  LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
  LOCAL lCaps     := AppKeyState( VK_CAPITAL,.t. )
  LOCAL lNum      := AppKeyState( VK_NUMLOCK,.t. )

  IF lNum == APPKEY_PRESSED
    oNumLock:SetCaption( "Num" )
  ELSE
    oNumLock:SetCaption( "" )
  ENDIF

  IF lCaps == APPKEY_PRESSED
    oCapsLock:SetCaption( "Caps" )
  ELSE
    oCapsLock:SetCaption( "" )
  ENDIF

  IF ReadInsert()
    oInsert:SetCaption( "Ins" )
  ELSE
    oInsert:SetCaption( "Ovr" )
  ENDIF

RETURN Nil

* ---

STATIC FUNCTION ValidateAgency( cAgencyCode, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "M5" + cAgencyCode

  IF Eof()
    lError      := .t.
  ELSE
    lError      := .f.
    cAgencyDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN !lError

* ---

STATIC FUNCTION ValidateReceipt( GetList )

  IF (nAmt + nCosts + nAgency + nWriteOff + nAmnesty) <> nBalAmt
	 DC_MsgBox("Payment Amount vs. Fine Amount Error.")
  ENDIF

RETURN .t.

* ---

STATIC FUNCTION GuiAgencyScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"M5"))
  CodeMst->(DC_SetScope(1,"M5"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"M5"))
  CodeMst->(DC_SetScope(1,"M5"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }                                             HEADER 'Collection;Agency Code'                  WIDTH  8  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }                                    HEADER ';Collection Agency Code Description'     WIDTH 25  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
         EVAL { |o| SetAppWindow(o), SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Collection Agency Receipting Code'

  IF lStatus

	 cAgencyCode := CodeMst->CmCode
    cAgencyDesc := AllTrim(CodeMst->CmDesc)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cCashCode"))

  ELSE

    cAgencyCode := Space(4)
    cAgencyDesc := Space(30)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cAgencyCode"))

  ENDIF

  SELECT CodeMst
  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cAgencyCode

*---

STATIC FUNCTION GuiEvidenceScan(c, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,"FJ"))
  CodeMst->(DC_SetScope(1,"FJ"))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,"FJ"))
  CodeMst->(DC_SetScope(1,"FJ"))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  0.00, 0.00 DCBROWSE oBrowse ALIAS 'CodeMst' SIZE 60, 9.85 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode }           HEADER 'Evidence;Code'                 WIDTH 10  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc) }  HEADER ';Evidence Code Description'    WIDTH 30  PARENT oBrowse  ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
			EVAL { || SetAppFocus(oBrowse) } ;
	      TITLE 'Pick Desired Evidence Disposition Code'


  IF lStatus

    cEvidCode := CodeMst->CmCode
    cEvidDesc := AllTrim(CodeMst->CmDesc)

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_dEvidDate"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cEvidCode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cEvidCode

*---

STATIC FUNCTION ValidateEvidence(cEvidCode, GetList)

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "FJ" + cEvidCode
  IF Eof()

    cEvidDesc := Space(30)
    DC_GetRefresh(GetList)

  ELSE

    cEvidDesc := AllTrim(CodeMst->CmDesc)
    DC_GetRefresh(GetList)

  ENDIF

  SetAppFocus(DC_GetObject(GetList,"Get_dEvidDate"))

RETURN .t.

*---

STATIC FUNCTION TabPage8(GetList)

  SELECT OrdMst
  SET ORDER TO 1
  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION ValidateBatchName( GetList )

  SELECT BatchMst
  SET ORDER TO 1
  SEEK Upper(cBatchName)

  IF Eof()
    nBatchAmt := 0.00
  ELSE
    nBatchAmt := BatchMst->BatchAmt
  ENDIF
  DC_GetRefresh(GetList)
  SetAppFocus(DC_GetObject(GetList,"Get_dRdate"))

RETURN .t.

*---

STATIC FUNCTION GuiBatchScan( cBatchName, aGetList )

  LOCAL GetList := {}, GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8]

  SELECT BatchMst
  SET ORDER TO 2
  SET SOFTSEEK ON
  SEEK DtoS(Date())
  SET SOFTSEEK OFF

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  1.00, 1.00 DCBROWSE oBrowse ALIAS 'BatchMst'                                             SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| BatchMst->MaintDate}    HEADER 'Batch;Date'                          WIDTH  6                                     PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('BtchMx02')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'BtchMx02'

  DCBROWSECOL   DATA {|| BatchMst->BatchName}    HEADER ';Batch Description'                  WIDTH 18                                     PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('BtchMx01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'BtchMx01'

  DCBROWSECOL   DATA {|| BatchMst->BatchAmt}     HEADER 'Batch;Amount'                        WIDTH  6                                     PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Desired Receipt Batch' ;
         EVAL { || PostAppEvent(xbeM_RbDown,{0,0},,oBrowse:getColumn(1):heading), SetAppFocus(oBrowse) }

  IF lStatus

    cBatchName := BatchMst->BatchName
    nBatchAmt  := BatchMst->BatchAmt

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_dRdate"))

	ELSE

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cBatchName"))

  ENDIF

  DC_BrowPres(aPres)                                           // restore original browse presentation factors
  DC_BrowseSort(aSort)

RETURN cBatchName

/*

  KEYBLOCK {|a,b,o| SearchComplainant(a,b,o,@cComplainant) } ;
  KEYBLOCK {|a,b,o| SearchRespondent(a,b,o,@cBname) } ;

*/

